#ifndef ALAEQM_H_
#define ALAEQM_H_

#define DECL_CNTRS_FILE "stateCounts.csv"
#define EPOCH_FILE "mtbpEpoch.csv"
#define MTBP_FILE "mtbpSystems.csv"
#define MTBP_GROUP_FILE "mtbpGroups.csv"
#define STATEINFO_FILE "stateInfo.csv"
#define STATES_FILE "stateNonRunning.csv"
#define STATES_RUNNING_FILE "stateRunning.csv"
#define STATES_PROBLEMS_FILE "stateProblems.csv"
#define ALARM_COUNTERS_FILE "almSystemCounters.csv"
#define ALARM_GROUPS_FILE "almSystemGroups.csv"
#define ALAEQM_TAG "ALAEQM"
#define ALAEQM_EXPORT "ALARMSTATE"
#define ALAEQM_NUMDEVICES 100

#define ALAEQM_RATE 500

#define PRP_THRESHOLDS 26
#define PRP_SYS_BLAME_CNTS 25
#define PRP_BLAME 24
#define PRP_DECLPROBLEMS_WINDOW 23
#define PRP_DECLRUNNING_WINDOW 22
#define PRP_DECLPROBLEMS_TIME 21
#define PRP_DECLRUNNING_TIME 20
#define PRP_DECLPROBLEMS_COUNT 19
#define PRP_DECLRUNNING_COUNT 18
#define PRP_MTBP_THRESHOLD 17
#define PRP_MTBP_EPOCH 16
#define PRP_NUMPROBLEMS 15
#define PRP_MTBP 14
#define PRP_TIMESPAN_ENUM 13
#define PRP_TIMESPAN 12
#define PRP_ISRUNNING 11
#define PRP_GRP_CORRECTION_CNTS 10
#define PRP_SYS_CORRECTION_CNTS 9
#define PRP_CORRECTIONS 8
#define PRP_MEMBERS_NAM 7
#define PRP_MEMBERS 6
#define PRP_GROUPS 5
#define PRP_NOTREADYRUNNING 4
#define PRP_NOTREADYRUNNING_SIZE 100
#define PRP_NOTREADYCOUNT 3
#define PRP_NOTREADYCOUNT_SIZE 100
#define PRP_ISREADY 2
#define PRP_ISREADY_SIZE 100
#define PRP_NUMALARMS 1
#define PRP_NUMALARMS_SIZE 1

#define MAX_ALARM_SYSTEMS 100
#define MAX_NONRUNNING_STATES 25
#define MAX_RUNNING_STATES 25

#define SPAN_AVAILABLE 0
#define SPAN_PROBLEMS 1
typedef struct TimeSpan
{
  int type; // problems or available
  int nalarms;
  UINT32 begin; // time_t
  UINT32 end; // time_t
  UINT32 last_prob;
  UINT32 last_avail;
} TimeSpan;

extern TimeSpan gAlarmSystemTimeSpan[MAX_ALARM_SYSTEMS];
extern TimeSpan gAlarmGroupsTimeSpan[MAX_ALARM_SYSTEMS];

typedef struct 
{
  int nproblems;
  int mtbp;
  UINT32 runBegin;
  UINT32 reserved;
} MTBP;

typedef struct 
{
  char grp[48];
  char dsc[64];
  int *indices;
  int nindices;
} ALARM_GRP;

extern UINT32 g_notreadycount;
extern UINT32 g_isready;
extern UINT32 g_numalarms;

int alaeqm(char *devName,char *devProperty,DTYPE *dout, DTYPE *din,short access);
void alaeqm_bkg(void);
void alaeqm_ini(void);
void alaeqm_exi(void);

#ifndef ccerr
# define ccerr(i) { cc = i; goto err; }
#endif

int isRunning(void);
int isOfficiallyRunning(void);
int isOfficallyProblems(void);
int getAlarmIndexFromSystemNumber(char *sys);
int getAlarmGroupIndexFromGroup(char *grp);
FILE *createAndOpen(char *fname,char *attr);

#endif
