#define APPV_MAJOR 2
#define APPV_MINOR 0
#define APPV_REVISION 1 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "tine.h"
#include "alaeqm.h"

char thisFecName[FEC_NAME_SIZE+4] = "";
char thisContext[CONTEXT_NAME_SIZE] = "";
char *thisSubSystem = "SER";
char thisFecDescription[FEC_DESC_SIZE] = "";
char thisLocation[FEC_LOCATION_SIZE] = "";
UINT16 thisPortOffset = 0;

void PreSystemInit(void)
{
  /* Some System Parameters and their default values    */
  /* are shown below.  You may change them as necessary */
  MinPollingRate = 1000;
  MaxPollingRate = 30000;
  MaxNumContracts = 1000;
  MaxNumClients = 100;
  MaxNumConnections = 1000;
  FeclogDepth = 100;
  MaxRPCTransportSize = 65535;
  SetIgnoreFollowers(TRUE);
  SetCatchConsoleBreak(TRUE);
  if (strlen(thisContext) > 0)
  {
    int p;
    if (strlen(thisFecName) == 0)
    {
      strncpy(thisFecName,thisContext,10); thisFecName[10] = 0;
      strcat(thisFecName,"ALMFEC");
    }
    if (thisPortOffset == 0)
    {
      p = GetPortOffset(thisFecName);
      if (p >= 0) thisPortOffset = p;
    }
    sprintf(thisFecDescription,"%.32s Alarm State server",thisContext);
    RegisterFecInformation(thisFecName,thisSubSystem,thisContext,thisFecDescription,thisLocation,"none","administrator",thisPortOffset);
  }
}

void PostSystemInit(void)
{
  RegisterEquipmentModule(ALAEQM_EXPORT,ALAEQM_TAG,ALAEQM_NUMDEVICES,alaeqm,alaeqm_ini,alaeqm_bkg,ALAEQM_RATE,alaeqm_exi);
}
char *usageText = "usage: almstate [/f=<fecname> /c=<context> /p=<port offset> /l=<location> /d=<debug level>";
int main(int argc, char *argv[])
{
  int i,cc;
  char *c, scratch[256];

  for (i=1; i<argc; i++)
  { /* options given */
    c = argv[i];
    if (*c++ != '/') break;
    switch (tolower(*c))
    {
      case 'f':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(thisFecName,c,FEC_NAME_SIZE);
        }
        continue;
      case 'c':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(thisContext,c,CONTEXT_NAME_SIZE);
        }
        continue;
      case 'l':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(thisLocation,c,FEC_LOCATION_SIZE);
        }
        continue;
      case 'p':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(scratch,c,32);
          thisPortOffset = atoi(scratch);      
        }
        continue;
      case 'd':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(scratch,c,32);
          tineDebug = atoi(scratch);      
        }
        continue;
      case '?':
      case 'h':
        printf("%s",usageText);
        exit(0);
      default:
        continue;
    }
  }
  AssignFecApplicationInfo(APPV_MAJOR,APPV_MINOR,APPV_REVISION);
  SetPreSystemInitFunction(PreSystemInit);
  SetPostSystemInitFunction(PostSystemInit);
  if ((cc=SystemInit(TRUE)) != 0)
  {
    printf("initialization error : %s",cc2str(cc));
    exit(1);
  }
  for(;;)
  {
    SystemCycle(TRUE);
  }
  return 0;
}
