# variables with defaults can be overridden by environment variables
#   TINE_INCL
#   TINE_LIBS

TINE_INCL ?= ../../../include
TINE_LIBS ?= ../../../lib

TINEEXE = almstate
TINELIB = libtineg.a

HDRS = ${TINE_INCL}/project.def \
	${TINE_INCL}/prolog.h \
	${TINE_INCL}/srvcore.h \
	${TINE_INCL}/errors.h \
	${TINE_INCL}/tinetype.h \
	${TINE_INCL}/tinedefs.h \
	${TINE_INCL}/dbtools.h \
	${TINE_INCL}/swaplib.h \
	${TINE_INCL}/toolkit.h \
	${TINE_INCL}/hstlib.h \
	${TINE_INCL}/almlib.h

CPP = g++ -I${TINE_INCL}
CC = cc -c -Aa -g -I${TINE_INCL}
CCL = cc -g
LM = -lm

${TINEEXE}: devsrv.o alaeqm.o
	${CCL} -o ${TINEEXE} devsrv.o alaeqm.o  ${TINE_LIBS}/${TINELIB} ${LM}
	chmod a+s ${TINEEXE}

devsrv.o: devsrv.c ${HDRS}
	${CC} devsrv.c

alaeqm.o: alaeqm.c alaeqm.h ${HDRS}
	${CC} alaeqm.c

clean:
	rm *.o
