#INCL = ${TINE_INCL}
#LIBS = ${TINE_LIB}
#just hardwire them
INCL = ../../../include
LIBS = ../../../lib
SRC = ../../../source
ARCSRC = ../../shared
HDRS = ${INCL}/project.def \
	${INCL}/prolog.h \
	${INCL}/srvcore.h \
	${INCL}/srvip.h \
	${INCL}/errors.h \
	${INCL}/tinetype.h \
	${INCL}/tinedefs.h \
	${INCL}/dbtools.h \
	${INCL}/swaplib.h \
	${INCL}/almlib.h

TINELIB = libtinemt.a

CPP = g++ -c -g -I. -I${INCL} -I${ARCSRC}
CC = cc -c -DMULTITHREADED -g -I. -I${INCL} -I${ARCSRC}
CCL = cc -g
LM = -lm -lrt -lpthread

arcwebsrv: websrv.o hsteqm.o hstweb.o archbase.o listener.o
	${CCL} -o arcwebsrv websrv.o hsteqm.o hstweb.o archbase.o listener.o ${LIBS}/${TINELIB} ${LM}
	chmod a+x arcwebsrv

websrv.o: websrv.c app_version.h ${HDRS}
	${CC} websrv.c

hstweb.o: hstweb.c ${ARCSRC}/archive.h fecdef.h ${HDRS}
	${CC} hstweb.c

hsteqm.o: ${ARCSRC}/hsteqm.c ${ARCSRC}/archive.h fecdef.h ${HDRS}
	${CC} ${ARCSRC}/hsteqm.c 

archbase.o: ${ARCSRC}/archbase.c ${ARCSRC}/archive.h fecdef.h ${HDRS}
	${CC} ${ARCSRC}/archbase.c 

listener.o: ${SRC}/listener.c ${INCL}/listener.h ${HDRS}
	${CC} ${SRC}/listener.c

clean:
	rm -f *.o
