/*
 * File fecdef.h
 *
 * Authors Philip Duval (DESY)
 *
 * Copyright (c) Deutsches Elektronen-Synchrotron DESY 1992-2023
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

//#define PKTRSERV
#define MKISERV
//#define MEXSERV
//#define PETSERV

#ifdef PKTRSERV
# define DBFILE "datapktr.csv"
# define DBACQUIRE TRUE
# define SRVPORT 6
# define SRVNAME "MEX-HERA"
#endif
#ifdef MKISERV
# define DBFILE "datamki.csv"
# define DBACQUIRE FALSE
# define SRVPORT 7
# define SRVNAME "MEX-MKI3"
#endif
#ifdef MEXSERV
# define DBFILE "datamex.csv"
# define DBACQUIRE TRUE
# define SRVPORT 8
# define SRVNAME "MEX-GATE"
#endif
#ifdef PETSERV
# define DBFILE "datapet.csv"
# define DBACQUIRE FALSE
# define SRVPORT 9
# define SRVNAME "MEX-PETR"
#endif

