# variables with defaults can be overridden by environment variables
#    TINE_INCL
#    TINE_LIBS
#    TINE_ARCSRC

TINE_INCL ?= ../../../include
TINE_LIBS ?= ../../../lib
TINE_ARCSRC ?= ../../shared

HDRS = ${TINE_INCL}/project.def \
	${TINE_INCL}/prolog.h \
	${TINE_INCL}/srvcore.h \
	${TINE_INCL}/srvip.h \
	${TINE_INCL}/errors.h \
	${TINE_INCL}/tinetype.h \
	${TINE_INCL}/tinedefs.h \
	${TINE_INCL}/dbtools.h \
	${TINE_INCL}/swaplib.h \
	${TINE_INCL}/almlib.h

TINELIB = libtinemt.a

CPP = g++ -c -g -I. -I${TINE_INCL} -I${TINE_ARCSRC}
CC = cc -c -Aa -g -DMULTITHREADED -I. -I${TINE_INCL} -I${TINE_ARCSRC}
CCL = cc -g
LM = -lm -lpthread -lrt

arcsrv: devsrv.o hsteqm.o archbase.o
	${CCL} -o arcsrv devsrv.o hsteqm.o archbase.o ${TINE_LIBS}/${TINELIB} ${LM}
	chmod a+x arcsrv

devsrv.o: devsrv.c app_version.h ${HDRS}
	${CC} devsrv.c

hsteqm.o: ${TINE_ARCSRC}/hsteqm.c ${TINE_ARCSRC}/archive.h fecdef.h ${HDRS}
	${CC} ${TINE_ARCSRC}/hsteqm.c 

archbase.o: ${TINE_ARCSRC}/archbase.c ${TINE_ARCSRC}/archive.h fecdef.h ${HDRS}
	${CC} ${TINE_ARCSRC}/archbase.c 

clean:
	rm -f *.o
