# variables with defaults can be overridden by environment variables
#   TINE_INCL
#   TINE_LIBS
#   TINE_ARCSRC

TINE_INCL ?= ../../../include
TINE_LIBS ?= ../../../lib
TINE_ARCSRC ?= ../../shared

HDRS = ${TINE_INCL}/project.def \
	${TINE_INCL}/prolog.h \
	${TINE_INCL}/srvcore.h \
	${TINE_INCL}/srvip.h \
	${TINE_INCL}/errors.h \
	${TINE_INCL}/tinetype.h \
	${TINE_INCL}/tinedefs.h \
	${TINE_INCL}/dbtools.h \
	${TINE_INCL}/swaplib.h \
	${TINE_INCL}/almlib.h

CPP = g++ -c -g -I. -I${TINE_INCL} -I${TINE_ARCSRC}
CC = cc -c -g -I. -I${TINE_INCL} -I${TINE_ARCSRC}
CCL = cc -g
LM = -lm -lrt

whichrec: whichrec.o archbase.o
	${CCL} -o whichrec whichrec.o archbase.o ${TINE_LIBS}/libtine.a ${LM}
	chmod a+x whichrec

whichrec.o: whichrec.c ${HDRS}
	${CC} whichrec.c

archbase.o: ${TINE_ARCSRC}/archbase.c ${TINE_ARCSRC}/archive.h fecdef.h ${HDRS}
	${CC} ${TINE_ARCSRC}/archbase.c 

clean:
	rm -f *.o
