# variables with defaults can be overridden by environment variables
#   TINE_INCL
#   TINE_LIBS

TINEEXE = availabilityServer
TINELIB = libtinemt.a
TINE_INCL ?= ../../../include
TINE_LIBS ?= ../../../lib

HDRS = ${TINE_INCL}/project.def \
	${TINE_INCL}/prolog.h \
	${TINE_INCL}/srvcore.h \
	${TINE_INCL}/errors.h \
	${TINE_INCL}/tinetype.h \
	${TINE_INCL}/tinedefs.h \
	${TINE_INCL}/swaplib.h \
	${TINE_INCL}/dbtools.h \
	${TINE_INCL}/almlib.h 

CPP = g++ -c -I${TINE_INCL}
CC = cc -c -DMULTITHREADED -g -I${TINE_INCL}
CCL = cc -g
LM = -lm -lrt -lpthread

${TINEEXE}: devsrv.o avaeqm.o availutils.o
	${CCL} -o ${TINEEXE} devsrv.o avaeqm.o availutils.o ${TINE_LIBS}/${TINELIB} ${LM}
	chmod a+x ${TINEEXE}

devsrv.o: devsrv.c ${HDRS}
	${CC} devsrv.c

avaeqm.o: avaeqm.c ${HDRS}
	${CC} avaeqm.c 

availutils.o: availutils.c ${HDRS}
	${CC} availutils.c 

clean:
	rm -f *.o

