#pragma once
#define AVAEQM_TAG "AVAEQM"
#define AVAEQM_MAXDEVICES 10
#define AVAEQM_BKG_RATE 1000

#define PRP_AVAILABILITY 1
#define PRP_SYNCHRONIZE 2
#define PRP_AVAILABILITY_RAW 3
#define PRP_EPOCH 4

#define SRV_FILENAME "availability.log"

extern char thisFecContext[CONTEXT_NAME_SIZE];
extern char thisFecServer[32];
extern char thisFecName[FEC_NAME_SIZE + 4];
extern char thisFecSubsystem[16];
extern char thisFecDescription[FEC_DESC_SIZE];
extern char thisFecLocation[FEC_LOCATION_SIZE];
extern char thisFecResponsible[32];
extern int thisFecPort;

typedef struct ProfileCounts
{
  char name[DEVICE_NAME_SIZE];
  long counts;
  time_t timestamp;
  struct ProfileCounts *nxt;
} ProfileCounts;
typedef struct ProfileState
{
  char name[64];
  long ctsTotal;
  long ctsBeam;
  long ctsErr;
} ProfileState;
typedef struct Profile
{
  char name[64];
  int type;
  int exclude;
  int subtract;
  int nstates;
  long sum;
  long correction;
  ProfileState *states;
} Profile;
typedef struct ProfileConfig
{
  char name[64];
  Profile *profiles;
  int nprofiles;
} ProfileConfig;

#define MAX_PROFILES 10
#define MAX_PROCEDURES 100
extern NAME64 profileConfigNames[MAX_PROFILES];
extern NAME64 procedureNames[MAX_PROCEDURES];
extern int numConfigs;
extern int numProcedures;
extern ProfileConfig *profileConfigs;

extern ProfileCounts *gPrfCntsTbl[LNKTBL_HASH_SIZE];
extern int gPrfCntsTblSize;
ProfileCounts *getPrfCntsLstItemByKey(char *key);
ProfileCounts *getPrfCntsLstItem(char *name, time_t timestamp);
void appendPrfCntsLst(char *key, time_t timestamp);
void rmvPrfCntsLstItem(char *name, time_t timestamp);

int RegisterProperties(void);
int RegisterDevices(void);
void RegisterStructs(void);
void avaeqm_ini(void);
void avaeqm_exi(void);
void avaeqm_bkg(void);
