#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include "tine.h"
#include "avaeqm.h"

#ifdef WIN32
char *gUsageString = "Usage:\n\n\tavailability /s=<server name> [/f=<config file> /n=<fecname> c=<context> /u=<subsystem> /l=<location> /r=<responsible> /p=<port offset> /b=TRUE (run in background) /m=TRUE (run minimized) /e=TRUE (use default value on link error)]\n";
#else
char *gUsageString = "Usage:\n\n\tavailability /s=<server name> [/f=<config file> /n=<fecname> /c=<context> /u=<subsystem> /l=<location> /r=<responsible> /p=<port offset> /e=TRUE (use default value on link error)\n";
#endif

void PostSystemInit(void);
void PreSystemInit(void);
void mycleanup(void)
{
  SystemFreeResources(FALSE);
  printf("bye-bye\n");
}
#ifdef WIN32
int minimize(void)
{
  char t[500];
  HWND hwnd;

  GetConsoleTitleA(t, 500);     // retrieve the text
  hwnd = FindWindowA(NULL, t);  // FindWindowA actually
  ShowWindow(hwnd, SW_MINIMIZE);
  return 0;
}
#endif
int atobool(char *v)
{
  char str[64];
  if (v == NULL) return FALSE;
  strncpy(str, v, 64);
  strtrm(v);
  if (stricmp(v, "TRUE") == 0) return TRUE;
  if (stricmp(v, "YES") == 0) return TRUE;
  if (stricmp(v, "ON") == 0) return TRUE;
  return FALSE;
}
int main(int argc, char *argv[])
{
  int i,cc,n=0;
  char *c;
# ifdef WIN32
  int noConsole = FALSE, minimized = FALSE;
  HWND hwnd = GetConsoleWindow();
  HMENU hmenu = GetSystemMenu(hwnd, FALSE);
  EnableMenuItem(hmenu, SC_CLOSE, MF_GRAYED);
# endif

  for (i = 1; i<argc; i++)
  {
    c = argv[i];
    if (*c++ != '/') continue;
    switch (tolower(*c))
    {
      case 'n':
        if ((c = strchr(c, '=')) != NULL)
        {
          c++;
          strncpy(thisFecName, c, 32);
        }
        continue;
      case 's':
        if ((c = strchr(c, '=')) != NULL)
        {
          c++;
          strncpy(thisFecServer, c, 32);
        }
        continue;
      case 'c':
        if ((c = strchr(c, '=')) != NULL)
        {
          c++;
          strncpy(thisFecContext, c, 32);
        }
        continue;
      case 'u':
        if ((c = strchr(c, '=')) != NULL)
        {
          c++;
          strncpy(thisFecSubsystem, c, 16);
        }
        continue;
      case 'l':
        if ((c = strchr(c, '=')) != NULL)
        {
          c++;
          strncpy(thisFecLocation, c, 32);
        }
        continue;
      case 'r':
        if ((c = strchr(c, '=')) != NULL)
        {
          c++;
          strncpy(thisFecResponsible, c, 32);
        }
        continue;
      case 'p':
        if ((c = strchr(c, '=')) != NULL)
        {
          c++;
          thisFecPort = atoi(c);
        }
        continue;
  #     ifdef WIN32
      case 'b':
        if ((c = strchr(c, '=')) != NULL)
        {
          c++;
          noConsole = atobool(c);
        }
        continue;
      case 'm':
        if ((c = strchr(c, '=')) != NULL)
        {
          c++;
          minimized = atobool(c);
        }
        continue;
  #     endif
      case 'h':
      case '?':
        printf("%s\n",gUsageString);
        exit(0);
      default:
        continue;
    }
  }

# ifdef WIN32
  if (noConsole) FreeConsole();
  else if (minimized) minimize();
# endif

  SetPreSystemInitFunction(PreSystemInit);
  SetPostSystemInitFunction(PostSystemInit);
  SetSystemCleanupFunction(mycleanup);
  SetAppVersion(1, 0, 0);

  if ((cc=SystemInit(TRUE)) != 0) { printf("init error: %s\n",cc2str(cc)); exit(1); }

# ifdef USE_CYCLER
  SystemStartCycleTimer();
  SystemWaitCycleTimer();
# else
  for(;;)
  {
    SystemCycle(TRUE);
  }
# endif
  return 0;
}
