#include <stdio.h>
#include "tbufsrv.h"
#include "threader.h"

int prpHdlr(char *prp,char *dev, void *ref)

RegisterServerCallbackEx(property, prpHdlr, handler)

  float sinbuf[NUM_DEVICES][NUM_VALUES];

  void updateSine(int devnr)
  { /* used internally -> don't bother with bounds checking */
    int i, k;
    float *target = sinbuf[devnr];
    float f = sineInfoTable[devnr].frequency;
    int n = (int)sineInfoTable[devnr].noise;
    int p = (int)sineInfoTable[devnr].phase;
    float a = sineInfoTable[devnr].amplitude;
    float d = sineInfoTable[devnr].damping/(float)100.0;
    for (i=0; i<NUM_VALUES; i++)
    {
      k = (i + p) % NUM_VALUES;
      target[k] = random(n) + (float)(sin(f*i*6.2832/(NUM_VALUES/8))*a);
      if (d > 0.0)
      {
        target[k] *= ((float)1.0 - (d * (float)i)/(float)NUM_VALUES);
      }
    }
    return;
  }
char *sinname[NUM_DEVICES] = {
  "SineGen0","SineGen1","SineGen2","SineGen3","SineGen4",
  "SineGen5","SineGen6","SineGen7","SineGen8","SineGen9" 
};




static int initialized = FALSE;
void update(void)
{
  float v = ((float)(rand()%100))/100.0;
  // fec.xml registers a property called 'Values' and a device called called
  // 'device1'.  Update the associated data:
  pushBufferedData("Values","device1",(BYTE *)&v,1,FALSE);
  if (!initialized)
  {
    initialized = TRUE;
    v = 1.0;
    pushBufferedData("Setting","device1",(BYTE *)&v,1,FALSE);
  }
}
int settingHdlr(void)
{
  // fec.xml registers a property called 'Setting' 
  int cc = 0;
  float val;
  int nr = GetInputDeviceNumber();
  char dev[DEVICE_NAME_SIZE];
  sprintf(dev,"#%d",nr); // the surest way to be independent of whatever names the devices have ...
  if ((cc = pullBufferedData("Setting", dev, (BYTE *)&val, 1)) != 0) goto err;
  // maybe do some range checking, etc. and decide to accept or reject ...
  // push the value back if accepted ...
  if ((cc = pushBufferedData("Setting", dev, (BYTE *)&val, 1, FALSE)) != 0) goto err;
  initialized = TRUE; // in case 'save-and-restore' is in play ...
err:
  return cc;
}
// a very simple example:
int main(int argc,char *argv[])
{
  char c=0;
  // attach to the fec.xml database
  AttachServerFromFecXml();
  // attach a property handler to property 'Setting'
  RegisterServerCallback("Setting", settingHdlr);

  // wait here in a loop: each char input != 'q' will update the data value
  while (c != 'q')
  {
    update();
    ttyoutput("> [press any key to update 'Values' or 'q' to stop server");
    c = getchar();
  }
  // a 'real' server will probably want to launch a thread to do hardware i/o
  // and update the relevant data when necessary.
  // In such a case, remove the above 'while' loop and either sleep(FOREVER) or
  // uncomment out the line below:
  //  SystemWaitCycleTimer();
  return 0;
}
