#include <stdio.h>
#include "tbufsrv.h"
#include "threader.h"

static int initialized = FALSE;
void update(void)
{
  float v = ((float)(rand()%100))/100.0;
  // fec.xml registers a property called 'Values' and a device called called
  // 'device1'.  Update the associated data:
  pushBufferedData("Values","device1",(BYTE *)&v,1,FALSE);
  if (!initialized)
  {
    initialized = TRUE;
    v = 1.0;
    pushBufferedData("Setting","device1",(BYTE *)&v,1,FALSE);
  }
}
int settingHdlr(void)
{
  // fec.xml registers a property called 'Setting' 
  int cc = 0;
  float val;
  int nr = GetInputDeviceNumber();
  char dev[DEVICE_NAME_SIZE];
  sprintf(dev,"#%d",nr); // the surest way to be independent of whatever names the devices have ...
  if ((cc = pullBufferedData("Setting", dev, (BYTE *)&val, 1)) != 0) goto err;
  // maybe do some range checking, etc. and decide to accept or reject ...
  // push the value back if accepted ...
  if ((cc = pushBufferedData("Setting", dev, (BYTE *)&val, 1, FALSE)) != 0) goto err;
  initialized = TRUE; // in case 'save-and-restore' is in play ...
err:
  return cc;
}
// a very simple example:
int main(int argc,char *argv[])
{
  char c=0;
  // attach to the fec.xml database
  AttachServerFromFecXml();
  // attach a property handler to property 'Setting'
  RegisterServerCallback("Setting", settingHdlr);

  // wait here in a loop: each char input != 'q' will update the data value
  while (c != 'q')
  {
    update();
    ttyoutput("> [press any key to update 'Values' or 'q' to stop server");
    c = getchar();
  }
  // a 'real' server will probably want to launch a thread to do hardware i/o
  // and update the relevant data when necessary.
  // In such a case, remove the above 'while' loop and either sleep(FOREVER) or
  // uncomment out the line below:
  //  SystemWaitCycleTimer();
  return 0;
}
