/*
 * devsrv    REVISION HISTORY:
 * Generated by SRVWIZARD on Fri Jan 26 18:01:41 2001
*/

#include "app_version.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <signal.h>
#include "tine.h"
#include "caseqm.h"
#include "arctools.h"
#include "apceqm.h"

extern int g_isTerminating;
extern int needsRestart;
extern char thisFecName[FEC_NAME_SIZE];
extern char thisContext[CONTEXT_NAME_SIZE];
extern char thisLocation[FEC_LOCATION_SIZE];
extern UINT16 thisPortOffset;

void PreSystemInit(void);
void PostSystemInit(void);
void RestartServer(void);

char *usageText = "usage: cas [/f=<fecname> /c=<context> /p=<port offset> /l=<location> /d=<debug level>";
int main(int argc, char *argv[])
{
  int i,cc;
  char *c, scratch[256];

  for (i=1; i<argc; i++)
  { /* options given */
    c = argv[i];
    if (*c++ != '/') break;
    switch (tolower(*c))
    {
      case 'f':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(thisFecName,c,FEC_NAME_SIZE);
        }
        continue;
      case 'c':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(thisContext,c,CONTEXT_NAME_SIZE);
        }
        continue;
      case 'l':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(thisLocation,c,FEC_LOCATION_SIZE);
        }
        continue;
      case 'p':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(scratch,c,32);
          thisPortOffset = atoi(scratch);      
        }
        continue;
      case 'd':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(scratch,c,32);
          tineDebug = atoi(scratch);      
        }
        continue;
      case '?':
      case 'h':
        printf("%s",usageText);
        exit(0);
      default:
        continue;
    }
  }

  AssignFecApplicationInfo(APPV_MAJOR,APPV_MINOR,APPV_REVISION);
  SetPreSystemInitFunction(PreSystemInit);
  SetPostSystemInitFunction(PostSystemInit);
  if ((cc=SystemInit(TRUE)) != 0)
  {
    printf("%.32s",cc2str(cc));
    exit(1);
  }
  for(;;)
  {
    if (g_isTerminating) ttyquit(NULL,NULL);
    SystemCycle(TRUE);
    if (needsRestart) RestartServer();
  }
  return 0;
}
