/*
 * devsrv    REVISION HISTORY:
 * Generated by SRVWIZARD on Fri Sep 14 13:43:20 2007
*/

#define APPV_MAJOR 2
#define APPV_MINOR 0
#define APPV_REVISION 0

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "tine.h"
#include "clseqm.h"

#define CLSEQM_EXPORT "CLOG"
#define CLSFEC_NAME "CLOGFEC"
#define CLSFEC_PORT 40

char thisLocation[FEC_LOCATION_SIZE] = "A central location";
UINT16 thisPortOffset = CLSFEC_PORT;

void PreSystemInit(void)
{
  SetWorkAreaSize(500000);
  SetIgnoreFollowers(TRUE);
  RegisterFecInformation(CLSFEC_NAME,"SER","SITE","Central Logger",thisLocation,"none","administrator",thisPortOffset);
}

void PostSystemInit(void)
{
  RegisterEquipmentModule(CLSEQM_EXPORT,CLSEQM_TAG,0,clseqm,clseqm_ini,clseqm_bkg,CLSEQM_RATE,clseqm_exi);
}
char *usageText = "usage: clog [/p=<port offset> /l=<location> /d=<debug level>";
int main(int argc, char *argv[])
{
  int i,cc;
  char *c, scratch[256];

  for (i=1; i<argc; i++)
  { /* options given */
    c = argv[i];
    if (*c++ != '/') break;
    switch (tolower(*c))
    {
      case 'l':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(thisLocation,c,FEC_LOCATION_SIZE);
        }
        continue;
      case 'p':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(scratch,c,32);
          thisPortOffset = atoi(scratch);      
        }
        continue;
      case 'd':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(scratch,c,32);
          tineDebug = atoi(scratch);      
        }
        continue;
      case '?':
      case 'h':
        printf("%s",usageText);
        exit(0);
      default:
        continue;
    }
  }
  AssignFecApplicationInfo(APPV_MAJOR,APPV_MINOR,APPV_REVISION);
  SetPreSystemInitFunction(PreSystemInit);
  SetPostSystemInitFunction(PostSystemInit);
  if ((cc=SystemInit(TRUE)) != 0)
  {
    printf("initialization error : %s",cc2str(cc));
    exit(1);
  }
  for(;;)
  {
    /* TODO: add any additional non-TINE processing here */
    /*       being careful not to block operations */

    SystemCycle(TRUE);
  }
  return 0;
}
