# variables with defaults can be overridden by environment variables
#   TINE_INCL
#   TINE_LIBS

TINE_INCL ?= ../../../include
TINE_LIBS ?= ../../../lib

TINEEXE = clogsrv
TINELIB = libtine.a

HDRS = ${TINE_INCL}/project.def \
	${TINE_INCL}/prolog.h \
	${TINE_INCL}/errors.h \
	${TINE_INCL}/swaplib.h \
	${TINE_INCL}/toolkit.h


CPP = g++ -I${TINE_INCL}
CC = cc -c -Aa -g -I${TINE_INCL}
CCL = cc -g
LM = -lM

${TINEEXE}: devsrv.o clseqm.o  ${TINE_LIBS}/${TINELIB}
	${CCL} -o ${TINEEXE} devsrv.o clseqm.o  ${TINE_LIBS}/${TINELIB} ${LM}
	chmod a+s ${TINEEXE}

devsrv.o: devsrv.c ${HDRS}
	${CC} devsrv.c

clseqm.o: clseqm.c clseqm.h ${HDRS}
	${CC} clseqm.c

clean:
	rm *.o
