# variables with defaults can be overridden by environment variables
#   TINE_INCL
#   TINE_LIBS

TINE_INCL ?= /usr/include/tine
TINE_LIBS ?= /usr/lib

TINEEXE = csspy
TINELIB = libtine.a

HDRS = ${TINE_INCL}/project.def \
	${TINE_INCL}/prolog.h \
	${TINE_INCL}/srvcore.h \
	${TINE_INCL}/errors.h \
	${TINE_INCL}/tinetype.h \
	${TINE_INCL}/tinedefs.h \
	${TINE_INCL}/dbtools.h \
	${TINE_INCL}/swaplib.h \
	${TINE_INCL}/toolkit.h \
	${TINE_INCL}/hstlib.h \
	${TINE_INCL}/almlib.h

CPP = g++ -I${TINE_INCL}
CC = cc -c -Aa -g -I${TINE_INCL}
CCL = cc -g
LM = -lM

${TINEEXE}: devsrv.o spyeqm.o
	${CCL} -o ${TINEEXE} devsrv.o spyeqm.o  ${TINE_LIBS}/${TINELIB} ${LM}
	chmod a+s ${TINEEXE}

devsrv.o: devsrv.c ${HDRS}
	${CC} devsrv.c

spyeqm.o: spyeqm.c spyeqm.h ${HDRS}
	${CC} spyeqm.c

clean:
	rm *.o
