/*
 * spyeqm.c    REVISION HISTORY:
 * Generated by SRVWIZARD on Fri Dec 17 17:58:37 2004
*/

#include "prolog.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "tine.h"
#include "spyeqm.h"

extern char thisMonitoredContext[CONTEXT_NAME_SIZE];
NAME32 g_controlledfecsBuffer[PRP_CONTROLLEDFECS_SIZE];
NAME32 g_controllablefecsBuffer[PRP_CONTROLLABLEFECS_SIZE];
CsUser csUsers[MAX_CS_USERS],rbCsUsers[MAX_CS_USERS];
int gatheringInformation = 0;
int assignReadbackInfo = TRUE;
int nCsUsers = 0, rbNCsUsers = 0;
int nFilteredCsUsers = 0;

NAME16 stkSubSystems[] = { 
  "RF", "VAC", "MAG", "TIM", "TUN", "QPS", "INJ", "EXP", "DIA", "SUB", "SER"
};
NAME16 *gSubSystems = NULL;
NAME16 rbSubSystems[100];
int nsubsystems = 0;
char *gContext = NULL;
NAME32 g_monitoredSrvs[MAX_MONITORED_FECS];
int nMonitoredSrvs = 0;
NAME16 g_independentFecs[MAX_MONITORED_FECS];
int nIndFecs = 0;
NAME16 g_totalFecs[MAX_TOTAL_FECS];
int nTotalFecs = 0;

ControllableFec *g_controllableFecs=NULL;

BYTE hasAccess(int uid, int fid);
void fillInAllowedNetsInformation(void);
void asyncFillInAllowedUserInformation(int i);
void asyncFillInAllowedNetsInformation(int i);
void getSubSystems(char *context)
{
  DTYPE dout;
  int cc;
  char dev[132];

  memset(&dout,0,sizeof(DTYPE));
  dout.dArrayLength = 100;
  dout.dFormat = CF_NAME16;
  dout.data.vptr = rbSubSystems;
  sprintf(dev,"/SITE/ENS/%.32s",context);
  cc = ExecLink(dev,"SUBSYSTEMS",&dout,NULL,CA_READ|CA_MUTABLE);
  if (cc == 0)
  {
    gSubSystems = rbSubSystems;
    nsubsystems = dout.dArrayLength;
  }
  else
  {
    gSubSystems = stkSubSystems;
    nsubsystems = sizeof(stkSubSystems)/sizeof(stkSubSystems[0]);
  }
  return;
}
int getMonitoredFecs(char *context)
{
  int i,num,cnt,n = 0,rc = 0;
  char target[64];
 
  getSubSystems(context);
  for (i=0; i<nsubsystems-1 && n<MAX_MONITORED_FECS; i++)
  {
    num = MAX_MONITORED_FECS - n;
    sprintf(target,"%s/%s",context,gSubSystems[i].name);
    for (cnt=0,rc=-1; cnt<3 && rc != 0; cnt++)
    {
      rc = GetSystemServers(target,&g_monitoredSrvs[n],&num);
    }
    if (rc == 0) n += num;
  }
  nMonitoredSrvs = n;
  return rc;
}
int getMonitoredSrvIndex(char *name)
{
  int i;
  for (i=0; i<nMonitoredSrvs; i++)
  {
    if (!strncmp(g_monitoredSrvs[i].name,name,32)) return i;
  }
  return -1;
}
void spyeqm_bkg(void)
{
  int i,j;
  static int done = 0, dcnt = 0;

  for (i=0; i<nCsUsers; i++)
  {
    csUsers[i].isPowerUser = FALSE;
    for (j=0; j<csUsers[i].nfecs; j++)
      if (csUsers[i].canAccessFec[j])
    {
      csUsers[i].isPowerUser = -1;
      break;
    }
  }
  if (nCsUsers >= rbNCsUsers) done = FALSE;
  if (dcnt > 30 && nCsUsers > 0) done = FALSE;
  if (assignReadbackInfo)
  {
    assignReadbackInfo = FALSE;
    done = TRUE;
    rbNCsUsers = nCsUsers;
    memcpy(rbCsUsers,csUsers,nCsUsers*sizeof(CsUser));
  }
  if (done) dcnt++; else dcnt = 0;
}

int RegisterSpyeqmProperties(void)
{
  int cc = 0;

  if ((cc=RegisterPropertyEx(SPYEQM_TAG,"ControlledFECs",PRP_CONTROLLEDFECS_SIZE,CF_NAME16,CA_READ,"[0:100 ]FECs where user has access and i",PRP_CONTROLLEDFECS)) < 0) goto err;
  if ((cc=RegisterPropertyEx(SPYEQM_TAG,"ControllableFECs",PRP_CONTROLLABLEFECS_SIZE,CF_NAME16,CA_READ,"[0:100 ]FECs where user has access",PRP_CONTROLLABLEFECS)) < 0) goto err;
  if ((cc=RegisterPropertyEx(SPYEQM_TAG,"STATIONS",PRP_STATIONS_SIZE,CF_NAME16,CA_READ,"[0:100 ]Stations where user is logged in",PRP_STATIONS)) < 0) goto err;
  if ((cc=RegisterPropertyEx(SPYEQM_TAG,"CS-USERS.FILTERED",PRP_CS_USERS_FILTERED_SIZE,CF_NAME16,CA_READ,"[0:100 ]Current Control System Users (FE",PRP_CS_USERS_FILTERED)) < 0) goto err;
  if ((cc=RegisterPropertyEx(SPYEQM_TAG,"CS-USERS",PRP_CS_USERS_SIZE,CF_NAME16,CA_READ,"[0:100 ]Current Control System Users",PRP_CS_USERS)) < 0) goto err;

  if ((cc=RegisterPropertyEx(SPYEQM_TAG,"FECS",PRP_FECS_SIZE,CF_NAME16,CA_READ,"[0:100 ]Current Fecs",PRP_FECS)) < 0) goto err;
  if ((cc=RegisterPropertyEx(SPYEQM_TAG,"ALLOWED-USERS",PRP_ALLOWED_USERS_SIZE,CF_NAME16,CA_READ,"[0:100 ]Priviliged Users",PRP_ALLOWED_USERS)) < 0) goto err; 
  if ((cc=RegisterPropertyEx(SPYEQM_TAG,"CS-FEC-USERS",PRP_CS_USERS_SIZE,CF_NAME16,CA_READ,"[0:100 ]Current Attached FECs",PRP_CS_USERS_FECS)) < 0) goto err;
  if ((cc=RegisterPropertyEx(SPYEQM_TAG,"CS-TRANSIENTUSERS",PRP_CS_USERS_SIZE,CF_NAME16,CA_READ,"[0:100 ]Current Transient Users",PRP_CS_TRANSIENTUSERS)) < 0) goto err;
  if ((cc=RegisterPropertyEx(SPYEQM_TAG,"CS-FECS",MAX_NUM_FECS,CF_NAME16,CA_READ,"[0:100 ]FECs in this context",PRP_CS_FECS)) < 0) goto err;
  if ((cc=RegisterPropertyEx(SPYEQM_TAG,"ALLOWED-NETS",MAX_ALLOWED_NETS,CF_NAME16,CA_READ,"[0:100 ]Priviliged Networks",PRP_ALLOWED_NETS)) < 0) goto err; 
  
err:
  if (cc < 0)
  {
    printf("Can't register property : %s\n>",erlst[-cc]);
  }
  return cc;
}
int getIndFecId(char *name)
{
  int i;
  for (i=0; i<nIndFecs; i++) 
    if (!strnicmp(g_independentFecs[i].name,name,16)) return i;
  return -1;
}
int isFec(char *name)
{
  int i;
  for (i=0; i<nIndFecs; i++) 
    if (!strnicmp(g_independentFecs[i].name,name,16)) return TRUE;
  return FALSE;
}
int isExtFec(char *name)
{
  int i;
  for (i=0; i<nIndFecs; i++) 
    if (!strnicmp(g_independentFecs[i].name,name,16)) return FALSE;
  for (i=0; i<nTotalFecs; i++) 
    if (!strnicmp(g_totalFecs[i].name,name,16)) return TRUE;
  return FALSE;
}
void cbCQS(int id,int cc)
{
  int idx = id-1;
  int i,j,k;
  char station[64];
  ExpDataStruct srvaddr;
  FecAddrStruct fecaddr;

  if (cc != 0)
  {
    //printf("srv %s : %s\n",g_controllableFecs[idx].name,erlst[cc]);
    return;
  }
  if (g_controllableFecs[idx].cqs == NULL) return;
  if (strlen(g_controllableFecs[idx].fecName) == 0)
  {
    if (GetServerAddr(gContext,g_controllableFecs[idx].srvName,&srvaddr,&fecaddr) == 0)
    {
      strncpy(g_controllableFecs[idx].fecName,fecaddr.fecName,16);
    }
  }
  for (i=0; i<g_controllableFecs[idx].nclients; i++)
  {
    for (j=0; j<nCsUsers; j++)
      if (!strncmp(g_controllableFecs[idx].cqs[i].userName,csUsers[j].name,16)) break;
    inet_ntoa_b(g_controllableFecs[idx].cqs[i].IPaddress.sin_addr,station);
    if (j == nCsUsers && nCsUsers < PRP_CS_USERS_SIZE) //didn't find it in list
    {
      if (strlen(g_controllableFecs[idx].cqs[i].userName) == 0) continue;
      strncpy(csUsers[j].name,g_controllableFecs[idx].cqs[i].userName,16); csUsers[j].name[16] = 0;
      csUsers[j].isfec = isFec(g_controllableFecs[idx].cqs[i].userName);
      if (!csUsers[j].isfec) csUsers[j].isextfec = isExtFec(g_controllableFecs[idx].cqs[i].userName);
      nCsUsers++;
      assignReadbackInfo = TRUE;
    }
    for (k=0; k<csUsers[j].nstations; k++)
      if (!strncmp(csUsers[j].stations[k].name,station,16)) break;
    if (k == csUsers[j].nstations && csUsers[j].nstations < MAX_NUM_STATIONS) 
    {
      if (strlen(station) == 0) continue;
      strncpy(csUsers[j].stations[k].name,station,16);
      csUsers[j].nstations++;
    }
    for (k=0; k<csUsers[j].nfecs; k++)
      if (!strncmp(csUsers[j].fecs[k].name,g_controllableFecs[idx].fecName,16)) break;
    if (k == csUsers[j].nfecs && csUsers[j].nfecs < MAX_NUM_FECS) 
    {
      strncpy(csUsers[j].fecs[k].name,g_controllableFecs[idx].fecName,16);
      csUsers[j].nfecs++;
    }
    csUsers[j].canAccessFec[k] = hasAccess(j,idx); 
  }
}
BYTE hasAccess(int uid, int fid)
{
  int i,k,nlen;
  int netAccess=0,usrAccess=0;
  for (i=0; i<MAX_ALLOWED_NETS; i++)
  { 
    if ((nlen=strlen(g_controllableFecs[fid].netNameList[i].name)) == 0) 
    {
      if (i == 0) netAccess = 1; 
      break;
    }
    if (strstr(g_controllableFecs[fid].netNameList[i].name,".255") != NULL) nlen -= 4;
    for (k=0; k<csUsers[uid].nstations; k++)
    {
      if (!strncmp(g_controllableFecs[fid].netNameList[i].name,csUsers[uid].stations[k].name,nlen)) 
      {
        netAccess = 1;
        i = MAX_ALLOWED_NETS;
        break;
      }
    }
  }
  for (i=0; i<MAX_ALLOWED_USERS; i++)
  { 
    if (strlen(g_controllableFecs[fid].usrNameList[i].name) == 0)
    {
      if (i == 0) return netAccess;
      break;
    }
    if (!strncmp(g_controllableFecs[fid].usrNameList[i].name,csUsers[uid].name,16))
    {
      usrAccess = 1;
      break;
    }
  }
  return netAccess | usrAccess;
}
int getClientList(int idx,int num)
{
  DTYPE dout;
  char devnam[64];
  int id;
  if (num == g_controllableFecs[idx].ncqs) return 0; // nothing to do
  if (num > g_controllableFecs[idx].ncqs) 
  {
    if (g_controllableFecs[idx].cqs != NULL) 
    {
      free(g_controllableFecs[idx].cqs);
      g_controllableFecs[idx].cqs = NULL;
    }
    if ((g_controllableFecs[idx].cqs=(CLNQS *)calloc(num,sizeof(CLNQS))) == NULL)
    {
      feclog("getClientList: cannot alloc memory !");
      return out_of_client_memory;
    }
    g_controllableFecs[idx].ncqs = num;
  }
  sprintf(devnam,"/%s/%s/#0",gContext,g_controllableFecs[idx].srvName);
  dout.dArrayLength = num;
  dout.dFormat = CF_STRUCT;
  strncpy(dout.dTag,"CLNQS",8);
  dout.data.vptr = g_controllableFecs[idx].cqs;
  if ((id=AttachLinkEx(devnam,"CLIENTS",&dout,NULL,CA_READ,1000,cbCQS,CM_SINGLE,idx+1)) < 0)
  {
    feclog("Attach to %s : %s",devnam,erlst[-id]);
    return -id;
  }
  g_controllableFecs[idx].nclients = num;
  return 0;
}
void cbLastAccess(int id, int cc)
{
  int i, idx = id-1;
  NAME16 *tmp;

  if (cc != 0)
  {
    switch (cc)
    {
      case non_existent_elem:
      case non_existent:
      case non_existent_server:
      case address_unknown:
        CloseLink(g_controllableFecs[idx].lid1);
    }
    return;
  }
  if (strlen(g_controllableFecs[idx].lastAccess.name) == 0) return;
  for (i=0; i<g_controllableFecs[idx].nconnections; i++)
  { /* don't count persisent entries as transients as well ! */
    if (!strnicmp(g_controllableFecs[idx].lastAccess.name,g_controllableFecs[idx].conTbl[i].name,16)) return;
  }
  for (i=0; i<g_controllableFecs[idx].ntransients; i++)
  { /* already in the table ? */
    if (!strnicmp(g_controllableFecs[idx].lastAccess.name,g_controllableFecs[idx].trnTbl[i].name,16)) return;
  }
  if (i >= g_controllableFecs[idx].trnTblCapacity)
  {
    tmp = (NAME16 *)realloc(g_controllableFecs[idx].trnTbl,(g_controllableFecs[idx].trnTblCapacity+CONNECTIONS_CAPACITY)*sizeof(NAME16));
    if (tmp != NULL)
    {
      g_controllableFecs[idx].trnTbl = tmp;
      g_controllableFecs[idx].trnTblCapacity += CONNECTIONS_CAPACITY;
    }
    else
    {
      feclog("no memory to expand transient client table!");
      return;
    }
  }
  strncpy(g_controllableFecs[idx].trnTbl[i].name,g_controllableFecs[idx].lastAccess.name,16);
  g_controllableFecs[idx].ntransients = i;
}
void cbActivity(int id, int cc)
{
  int idx = id-1;

  if (g_controllableFecs[idx].last_cc != cc)
  {
    g_controllableFecs[idx].last_cc = cc;
    if (cc == 0)
    { /* was in error, now is okay again (reboot?): check if new users list */
      asyncFillInAllowedUserInformation(idx);
      asyncFillInAllowedNetsInformation(idx);
    }
  }
  if (cc != 0)
  {
    g_controllableFecs[idx].errcnt++;
    switch (cc)
    {
      case non_existent_elem:
      case non_existent:
      case non_existent_server:
      case address_unknown:
        CloseLink(g_controllableFecs[idx].lid1);
    }
    return;
  }
  getClientList(idx,g_controllableFecs[idx].aqs.numTotalClients);
}
void spyeqm_ini(void)
{
  char devnam[64];
  int i, n, id, cc = 0;
  DTYPE dout;

  RegisterSpyeqmProperties();

  if (strlen(gDeviceContext) > 0) gContext = gDeviceContext;
  if (strlen(thisMonitoredContext) > 0) gContext = thisMonitoredContext;
  if (gContext == NULL) gContext = "TEST";
  if ((cc=getMonitoredFecs(gContext)) != 0) 
  {
    feclog("can't get servers : %s",erlst[cc]);
  }
  else
  {
    AssignNumDevices(SPYEQM_TAG,nMonitoredSrvs);
  }
  if ((g_controllableFecs=(ControllableFec *)calloc(nMonitoredSrvs,sizeof(ControllableFec))) == NULL)
  {
    feclog("can't allocate controllable FEC table !");
    exit(1);
  }
  n = MAX_MONITORED_FECS;
  if ((cc=GetSystemFecs(gContext,g_independentFecs,&n)) != 0)
    feclog("can't get independent fecs : %s",erlst[cc]);
  nIndFecs = n;

  n = MAX_TOTAL_FECS;
  if ((cc=GetSystemFecs("DEFAULT",g_totalFecs,&n)) != 0)
    feclog("can't get total fecs : %s",erlst[cc]);
  nTotalFecs = n;

  dout.dArrayLength = 1;
  dout.dFormat = CF_STRUCT;
  strncpy(dout.dTag,"AQS",8);
  for (i=0; i<nMonitoredSrvs; i++)
  {
    if (strstr(g_monitoredSrvs[i].name,"CSSPY") != NULL) continue;
    if ((g_controllableFecs[i].conTbl=(NAME16 *)calloc(CONNECTIONS_CAPACITY,sizeof(NAME16))) == NULL)
    {
      feclog("can't allocate connection capacity !");
      exit(1);
    }
    if ((g_controllableFecs[i].trnTbl=(NAME16 *)calloc(CONNECTIONS_CAPACITY,sizeof(NAME16))) == NULL)
    {
      feclog("can't allocate transient connection capacity !");
      exit(1);
    }
    g_controllableFecs[i].conTblCapacity = CONNECTIONS_CAPACITY;
    g_controllableFecs[i].nconnections = 0;
    g_controllableFecs[i].trnTblCapacity = CONNECTIONS_CAPACITY;
    g_controllableFecs[i].ntransients = 0;
    RegisterDeviceName(SPYEQM_TAG,g_monitoredSrvs[i].name,i);
    strncpy(g_controllableFecs[i].srvName,g_monitoredSrvs[i].name,32);
    sprintf(devnam,"/%s/%s/#0",gContext,g_monitoredSrvs[i].name);
    dout.data.vptr = &g_controllableFecs[i].aqs;
    if ((id=AttachLinkEx(devnam,"ACTIVITY",&dout,NULL,CA_READ,30000,cbActivity,CM_POLL,i+1)) < 0)
    {
      feclog("Attach to %s : %s",devnam,erlst[-id]);
    }
    else 
    {
      g_controllableFecs[i].lid1 = id;
    }
  }
  memset(&dout,0,sizeof(DTYPE));
  dout.dArrayLength = 1;
  dout.dFormat = CF_NAME32;
  for (i=0; i<nMonitoredSrvs; i++)
  {
    if (strstr(g_monitoredSrvs[i].name,"CSSPY") != NULL) continue;
    sprintf(devnam,"/%s/%s/#0",gContext,g_monitoredSrvs[i].name);
    dout.data.vptr = &g_controllableFecs[i].lastAccess.name;
    if ((id=AttachLinkEx(devnam,"SRVLASTACCESS",&dout,NULL,CA_READ,30000,cbLastAccess,CM_DATACHANGE,i+1)) < 0)
    {
      feclog("Attach to %s : %s",devnam,erlst[-id]);
    }
    else 
    {
      g_controllableFecs[i].lid2 = id;
    }
    asyncFillInAllowedUserInformation(i);
    asyncFillInAllowedNetsInformation(i);
  }

  if (cc) 
  {
    feclog("init : %s",erlst[cc]);
  }
}
void cbUsers(int id,int cc)
{
  int n, i = id-1;
  
  if (cc) return;
  for (n=0; n<MAX_ALLOWED_USERS && strlen(g_controllableFecs[i].usrNameList[n].name) > 0; n++);
  g_controllableFecs[i].nusers = n;
}
void cbNets(int id,int cc)
{
  int n, i = id-1;
  
  if (cc) return;
  for (n=0; n<MAX_ALLOWED_NETS && strlen(g_controllableFecs[i].netNameList[n].name) > 0; n++);
  g_controllableFecs[i].nnets = n;
}
void asyncFillInAllowedUserInformation(int i)
{
  char devnam[256];
  int id;
  DTYPE dout;

  if (strlen(g_monitoredSrvs[i].name) == 0) return;
  if (strstr(g_monitoredSrvs[i].name,"CSSPY") != NULL) return;
  sprintf(devnam,"/%s/%s/#0",gContext,g_monitoredSrvs[i].name);
  dout.dArrayLength = MAX_ALLOWED_USERS;
  dout.dFormat = CF_NAME16;
  dout.dTag[0] = 0;
  dout.data.vptr = g_controllableFecs[i].usrNameList;
  id = AttachLinkEx(devnam,"USERS",&dout,NULL,CA_READ,1000,cbUsers,CM_SINGLE,i+1);
  if (id < 0) 
  {
    feclog("cannot get USERS list for %s : %s",devnam,cc2str(-id));
  }
}
void asyncFillInAllowedNetsInformation(int i)
{
  char devnam[256];
  int id;
  DTYPE dout;

  if (strlen(g_monitoredSrvs[i].name) == 0) return;
  if (strstr(g_monitoredSrvs[i].name,"CSSPY") != NULL) return;
  sprintf(devnam,"/%s/%s/#0",gContext,g_monitoredSrvs[i].name);
  dout.dArrayLength = MAX_ALLOWED_NETS;
  dout.dFormat = CF_NAME16;
  dout.dTag[0] = 0;
  dout.data.vptr = g_controllableFecs[i].netNameList;
  id = AttachLinkEx(devnam,"IPNETS",&dout,NULL,CA_READ,1000,cbNets,CM_SINGLE,i+1);
  if (id < 0) 
  {
    feclog("cannot get IP NETS list for %s : %s",devnam,cc2str(-id));
  }
}
void spyeqm_exi(void)
{
  /* TODO: put your shutdown routines here */
}

int spyeqm(char *devName,char *devProperty,DTYPE *dout, DTYPE *din,short access)
{
  int devnr,prpid,i,j=0,n,cc;
  char usr[32],fec[32];
  NAME16 fltrs[5];
  int chkusr,chkfec,chkext,chktrn,isfec,isext;

  prpid = GetPropertyId(SPYEQM_TAG,devProperty);
  devnr = GetDeviceNumberEx(SPYEQM_TAG,devName,devProperty);
  switch (prpid)
  {
    case PRP_CONTROLLEDFECS:
        if (access&CA_WRITE) return illegal_read_write;
        if (din->dArrayLength > 0)
        {
          memset(usr,0,32);
          switch (din->dFormat)
          {
            case CF_TEXT: 
              strncpy(usr,din->data.cptr,din->dArrayLength); 
              break;
            case CF_NAME16:
            case CF_NAME32:
              strncpy(usr,din->data.cptr,16);
              break;
          }
        }
        else return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > PRP_CONTROLLEDFECS_SIZE) return dimension_error;
          if (dout->dFormat != CF_NAME16) return illegal_format;
          for (i=0; i<rbNCsUsers; i++) 
            if (!strncmp(rbCsUsers[i].name,usr,16)) break;
          if (i < rbNCsUsers)
          {
            for (j=0,n=0; j<rbCsUsers[i].nfecs && n<(int)dout->dArrayLength; j++)
            {
              if (rbCsUsers[i].canAccessFec[j] == 0) continue;
              strncpy(((NAME16 *)dout->data.vptr)[n++].name,rbCsUsers[i].fecs[j].name,16);
            }
          }
        }
        dout->dArrayLength = n;
        return 0;
    case PRP_CONTROLLABLEFECS:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > PRP_CONTROLLABLEFECS_SIZE) return dimension_error;
          if (dout->dFormat != CF_NAME16) return illegal_format;
          memcpy(dout->data.vptr,g_controllablefecsBuffer,dout->dArrayLength*fmtsizeof(dout->dFormat));
        }
        return 0;
    case PRP_STATIONS:
        if (access&CA_WRITE) return illegal_read_write;
        if (din->dArrayLength > 0)
        {
          memset(usr,0,32);
          switch (din->dFormat)
          {
            case CF_TEXT: 
              strncpy(usr,din->data.cptr,din->dArrayLength); 
              break;
            case CF_NAME16:
            case CF_NAME32:
              strncpy(usr,din->data.cptr,16);
              break;
          }
        }
        else return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > PRP_STATIONS_SIZE) return dimension_error;
          if (dout->dFormat != CF_NAME16) return illegal_format;
          for (i=0; i<rbNCsUsers; i++) 
            if (!strncmp(rbCsUsers[i].name,usr,16)) break;
          if (i < rbNCsUsers)
          {
            for (j=0; j<rbCsUsers[i].nstations && j<(int)dout->dArrayLength; j++)
              strncpy(((NAME16 *)dout->data.vptr)[j].name,rbCsUsers[i].stations[j].name,16);
          }
        }
        dout->dArrayLength = j;
        return 0;
    case PRP_ALLOWED_USERS:
        if (access&CA_WRITE) return illegal_read_write;
        if (din->dArrayLength > 0)
        {
          memset(fec,0,32);
          switch (din->dFormat)
          {
            case CF_TEXT: 
              strncpy(fec,din->data.cptr,din->dArrayLength); 
              break;
            case CF_NAME16:
            case CF_NAME32:
              strncpy(fec,din->data.cptr,16);
              break;
          }
        }
        else 
        {
          strncpy(fec,devName,16);
        }
        if ((n=getMonitoredSrvIndex(fec)) < 0) return non_existent_fec;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)MAX_ALLOWED_USERS) return dimension_error;
          if (dout->dArrayLength > (UINT32)g_controllableFecs[n].nusers)
            dout->dArrayLength = g_controllableFecs[n].nusers;
          if (dout->dFormat != CF_NAME16) return illegal_format;
          for (i=0; i<(int)dout->dArrayLength; i++)
          {
            if (strlen(g_controllableFecs[n].usrNameList[i].name) == 0) break;
            strncpy(((NAME16 *)dout->data.vptr)[i].name,g_controllableFecs[n].usrNameList[i].name,16);
          }
          dout->dArrayLength = i;
        }
        return 0;
    case PRP_ALLOWED_NETS:
        if (access&CA_WRITE) return illegal_read_write;
        if (din->dArrayLength > 0)
        {
          memset(fec,0,32);
          switch (din->dFormat)
          {
            case CF_TEXT: 
              strncpy(fec,din->data.cptr,din->dArrayLength); 
              break;
            case CF_NAME16:
            case CF_NAME32:
              strncpy(fec,din->data.cptr,16);
              break;
          }
        }
        else 
        {
          strncpy(fec,devName,16);
        }
        if ((n=getMonitoredSrvIndex(fec)) < 0) return non_existent_fec;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)MAX_ALLOWED_NETS) return dimension_error;
          if (dout->dArrayLength > (UINT32)g_controllableFecs[n].nnets)
            dout->dArrayLength = g_controllableFecs[n].nnets;
          if (dout->dFormat != CF_NAME16) return illegal_format;
          for (i=0; i<(int)dout->dArrayLength; i++)
          {
            if (strlen(g_controllableFecs[n].netNameList[i].name) == 0) break;
            strncpy(((NAME16 *)dout->data.vptr)[i].name,g_controllableFecs[n].netNameList[i].name,16);
          }
          dout->dArrayLength = i;
        }
        return 0;
    case PRP_FECS:
        if (access&CA_WRITE) return illegal_read_write;
        if (din->dArrayLength > 0)
        {
          memset(usr,0,32);
          switch (din->dFormat)
          {
            case CF_TEXT: 
              strncpy(usr,din->data.cptr,din->dArrayLength); 
              break;
            case CF_NAME16:
            case CF_NAME32:
              strncpy(usr,din->data.cptr,16);
              break;
          }
        }
        else return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > PRP_FECS_SIZE) return dimension_error;
          if (dout->dFormat != CF_NAME16) return illegal_format;
          for (i=0; i<rbNCsUsers; i++) 
            if (!strncmp(rbCsUsers[i].name,usr,16)) break;
          if (i < rbNCsUsers)
          {
            for (j=0; j<rbCsUsers[i].nfecs && j<(int)dout->dArrayLength; j++)
              strncpy(((NAME16 *)dout->data.vptr)[j].name,rbCsUsers[i].fecs[j].name,16);
          }
        }
        dout->dArrayLength = j;
        return 0;
    case PRP_CS_FECS:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > PRP_FECS_SIZE) return dimension_error;
          switch (dout->dFormat)
          {
            case CF_NAME16:
              for (i=0,n=0; i<nIndFecs && n<(int)dout->dArrayLength; i++)
              {
                if (strstr(g_independentFecs[i].name,"SPYFEC") != NULL) continue;
                if (!strcmp(g_independentFecs[i].name,"ENS")) continue;
                if (!strcmp(g_independentFecs[i].name,"GENS")) continue;
                strncpy(((NAME16 *)dout->data.vptr)[n++].name,g_independentFecs[i].name,16);
              }
              break;
            case CF_NAME16I:
              for (i=0,n=0; i<nIndFecs && i<(int)dout->dArrayLength; i++)
              {
                if (strstr(g_independentFecs[i].name,"SPYFEC") != NULL) continue;
                if (!strcmp(g_independentFecs[i].name,"ENS")) continue;
                if (!strcmp(g_independentFecs[i].name,"GENS")) continue;
                ((NAME16I *)dout->data.vptr)[n].ival = 1;
                strncpy(((NAME16I *)dout->data.vptr)[n++].name,g_independentFecs[i].name,16);
              }
              for (i=0; i<rbNCsUsers; i++)
              {
                if (!rbCsUsers[i].isfec) continue;
                j = getIndFecId(rbCsUsers[i].name);
                if (j < 0 || j >= nIndFecs) continue;
                ((NAME16I *)dout->data.vptr)[j].ival = rbCsUsers[i].isPowerUser;
              }
              break;
            default: return illegal_format;
          }
        }
        dout->dArrayLength = n;
        return 0;
    case PRP_CS_USERS_FILTERED:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > PRP_CS_USERS_FILTERED_SIZE) return dimension_error;
          switch (dout->dFormat)
          {
            case CF_NAME16:
              for (i=0,n=0; i<rbNCsUsers && n<(int)dout->dArrayLength; i++)
              {
                if (rbCsUsers[i].isfec) continue;
                if (rbCsUsers[i].isextfec) continue;
                strncpy(((NAME16 *)dout->data.vptr)[n++].name,rbCsUsers[i].name,16);
              }
              break;
            case CF_NAME16I:
              for (i=0,n=0; i<rbNCsUsers && n<(int)dout->dArrayLength; i++)
              {
                if (rbCsUsers[i].isfec) continue;
                if (rbCsUsers[i].isextfec) continue;
                ((NAME16I *)dout->data.vptr)[n].ival = rbCsUsers[i].isPowerUser;
                strncpy(((NAME16I *)dout->data.vptr)[n++].name,rbCsUsers[i].name,16);
              }
              break;
            default: return illegal_format;
          }
          dout->dArrayLength = n;
        }
        return 0;
    case PRP_CS_USERS:
        if (access&CA_WRITE) return illegal_read_write;
        chkusr = chkfec = chkext = chktrn = TRUE;
        if (din->dArrayLength > 0)
        {
          if ((cc=GetValuesAsStringEx(din,fltrs[0].name,CF_NAME16,4,0)) != 0) return cc;
          chkusr = chkfec = chkext = chktrn = FALSE;
          for (i=0; i<(int)din->dArrayLength; i++)
          {
            if (!strnicmp(fltrs[i].name,"USER",4)) chkusr = TRUE;
            else if (!strnicmp(fltrs[i].name,"FEC",3)) chkfec = TRUE;
            else if (!strnicmp(fltrs[i].name,"EXT",3)) chkext = TRUE;
            else if (!strnicmp(fltrs[i].name,"TRAN",4)) chktrn = TRUE;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)PRP_CS_USERS_SIZE) return dimension_error;
          if (dout->dArrayLength > (UINT32)rbNCsUsers) dout->dArrayLength = rbNCsUsers;
          switch (dout->dFormat)
          {
            case CF_NAME16:
              for (i=0,n=0; i<rbNCsUsers && n<(int)dout->dArrayLength; i++)
              {
                if (rbCsUsers[i].isfec && !chkfec) continue;
                if (rbCsUsers[i].isextfec && !chkext) continue;
                if (!rbCsUsers[i].isextfec && !rbCsUsers[i].isfec && !chkusr) continue;
                if (strstr(rbCsUsers[i].name,"SPYFEC") != NULL) continue;
                if (!strcmp(rbCsUsers[i].name,"ENS")) continue;
                if (!strcmp(rbCsUsers[i].name,"GENS")) continue;
                strncpy(((NAME16 *)dout->data.vptr)[n++].name,rbCsUsers[i].name,16);
              }
              break;
            case CF_NAME16I:
              for (i=0,n=0; i<rbNCsUsers && n<(int)dout->dArrayLength; i++)
              {
                if (rbCsUsers[i].isfec && !chkfec) continue;
                if (rbCsUsers[i].isextfec && !chkext) continue;
                if (!rbCsUsers[i].isextfec && !rbCsUsers[i].isfec && !chkusr) continue;
                if (strstr(rbCsUsers[i].name,"SPYFEC") != NULL) continue;
                if (!strcmp(rbCsUsers[i].name,"ENS")) continue;
                if (!strcmp(rbCsUsers[i].name,"GENS")) continue;
                ((NAME16I *)dout->data.vptr)[n].ival = rbCsUsers[i].isPowerUser;
                strncpy(((NAME16I *)dout->data.vptr)[n++].name,rbCsUsers[i].name,16);
              }
              break;
            default: return illegal_format;
          }
          dout->dArrayLength = n;
        }
        return 0;
    case PRP_CS_USERS_FECS:
        if (devnr < 0 || devnr >= nMonitoredSrvs) return illegal_device;
        if (access&CA_WRITE) return illegal_read_write;
        chkusr = chkfec = chkext = chktrn = TRUE;
        if (din->dArrayLength > 0)
        {
          if ((cc=GetValuesAsStringEx(din,fltrs[0].name,CF_NAME16,4,0)) != 0) return cc;
          chkusr = chkfec = chkext = chktrn = FALSE;
          for (i=0; i<(int)din->dArrayLength; i++)
          {
            if (!strnicmp(fltrs[i].name,"USER",4)) chkusr = TRUE;
            else if (!strnicmp(fltrs[i].name,"FEC",3)) chkfec = TRUE;
            else if (!strnicmp(fltrs[i].name,"EXT",3)) chkext = TRUE;
            else if (!strnicmp(fltrs[i].name,"TRAN",4)) chktrn = TRUE;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > PRP_CS_USERS_FILTERED_SIZE) return dimension_error;
          switch (dout->dFormat)
          {
            case CF_NAME16:
              for (i=0,n=0; i<g_controllableFecs[devnr].nclients && n<(int)dout->dArrayLength; i++)
              {
                isfec = isFec(g_controllableFecs[devnr].cqs[i].userName);
                if (!chkfec && isfec) continue;
                isext = isExtFec(g_controllableFecs[devnr].cqs[i].userName);
                if (!chkext && isext) continue;
                if (!isext && !isfec && !chkusr) continue;
                if (strstr(g_controllableFecs[devnr].cqs[i].userName,"SPYFEC") != NULL) continue;
                if (!strcmp(g_independentFecs[i].name,"ENS")) continue;
                if (!strcmp(g_independentFecs[i].name,"GENS")) continue;
                strncpy(((NAME16 *)dout->data.vptr)[n++].name,g_controllableFecs[devnr].cqs[i].userName,16);
              }
              break;
            default: return illegal_format;
          }
          dout->dArrayLength = n;
        }
        return 0;
    case PRP_CS_TRANSIENTUSERS:
        if (access&CA_WRITE) return illegal_read_write;
        if (din->dArrayLength > 0)
        {
          memset(fec,0,32);
          switch (din->dFormat)
          {
            case CF_TEXT: 
              strncpy(fec,din->data.cptr,din->dArrayLength); 
              break;
            case CF_NAME16:
            case CF_NAME32:
              strncpy(fec,din->data.cptr,16);
              break;
          }
        }
        else 
        {
          strncpy(fec,devName,16);
        }
        if ((n=getMonitoredSrvIndex(fec)) < 0) return non_existent_fec;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)PRP_CS_USERS_SIZE) return dimension_error;
          if (dout->dArrayLength > (UINT32)g_controllableFecs[n].ntransients)
            dout->dArrayLength = g_controllableFecs[n].ntransients;
          if (dout->dFormat != CF_NAME16) return illegal_format;
          for (i=0; i<(int)dout->dArrayLength; i++)
          {
            if (strlen(g_controllableFecs[n].trnTbl[i].name) == 0) break;
            if (strstr(g_controllableFecs[n].trnTbl[i].name,"SPYFEC") != NULL) continue;
            if (!strcmp(g_independentFecs[i].name,"ENS")) continue;
            if (!strcmp(g_independentFecs[i].name,"GENS")) continue;
            strncpy(((NAME16 *)dout->data.vptr)[i].name,g_controllableFecs[n].trnTbl[i].name,16);
          }
          dout->dArrayLength = i;
        }
        return 0;
    default:
        return illegal_property;
  }
}
