/*
 * SPYEQM.h    REVISION HISTORY:
 * Generated by SRVWIZARD on Fri Dec 17 17:58:37 2004
*/

#ifndef SPYEQM_H_
#define SPYEQM_H_
#include "tine.h"

#define SPYEQM_EXPORT "CSSPY"
#define SPYEQM_TAG "SPYEQM"
#define SPYEQM_NDEVICES 1000

#define SPYEQM_RATE 1000
#define MAX_CS_USERS 512
#define MAX_NUM_STATIONS 50
#define MAX_NUM_FECS 256
#define MAX_ALLOWED_NETS 25
#define MAX_ALLOWED_USERS 100

#define PRP_ALLOWED_NETS 11
#define PRP_CS_FECS 10
#define PRP_CS_TRANSIENTUSERS 9
#define PRP_CS_USERS_FECS 8
#define PRP_ALLOWED_USERS 7
#define PRP_ALLOWED_USERS_SIZE MAX_ALLOWED_USERS
#define PRP_FECS 6
#define PRP_FECS_SIZE 512
#define PRP_CONTROLLEDFECS 5
#define PRP_CONTROLLEDFECS_SIZE 512
#define PRP_CONTROLLEDFECS_INSIZE 1
#define PRP_CONTROLLABLEFECS 4
#define PRP_CONTROLLABLEFECS_SIZE 512
#define PRP_CONTROLLABLEFECS_INSIZE 1
#define PRP_STATIONS 3
#define PRP_STATIONS_SIZE 512
#define PRP_STATIONS_INSIZE 1
#define PRP_CS_USERS_FILTERED 2
#define PRP_CS_USERS_FILTERED_SIZE 512
#define PRP_CS_USERS 1
#define PRP_CS_USERS_SIZE 512

typedef struct ControllableFecStruct
{
  char srvName[32];
  char fecName[16];
  NAME16 usrNameList[MAX_ALLOWED_USERS];
  NAME16 netNameList[MAX_ALLOWED_NETS];
  ActivityQueryStruct aqs;
  NAME32 lastAccess;
  CLNQS *cqs;
  NAME16 *conTbl;
  NAME16 *trnTbl;
  int conTblCapacity;
  int trnTblCapacity;
  int nclients;
  int nusers;
  int nnets;
  int ncqs;
  int nconnections;
  int ntransients;
  int lid1;
  int lid2;
  int last_cc;
  int errcnt;
} ControllableFec;

typedef struct CsUserStruct
{
  char name[32];
  NAME16 stations[MAX_NUM_STATIONS];
  NAME32 fecs[MAX_NUM_FECS];
  BYTE canAccessFec[MAX_NUM_FECS];
  int isPowerUser;
  int nstations;
  int nfecs;
  int isfec;
  int isextfec;
} CsUser;

#define CONNECTIONS_CAPACITY 100
#define MAX_MONITORED_FECS 500
#define MAX_TOTAL_FECS 2000
extern char subsystems[][4];
extern int nsubsystems;
extern char *gContext;
extern NAME32 g_monitoredSrvs[MAX_MONITORED_FECS];
extern ControllableFec *g_controllableFecs;

extern NAME32 g_controlledfecsBuffer[PRP_CONTROLLEDFECS_SIZE];
extern NAME32 g_controllablefecsBuffer[PRP_CONTROLLABLEFECS_SIZE];
extern NAME16 g_cs_usersBuffer[PRP_CS_USERS_SIZE];

int spyeqm(char *devName,char *devProperty,DTYPE *dout, DTYPE *din,short access);
void spyeqm_bkg(void);
void spyeqm_ini(void);
void spyeqm_exi(void);

int SimulateData(int start,int range);

char *SimulateStringData(int length);

#endif
