# variables with defaults can be overridden by environment variables
#   TINE_INCL
#   TINE_LIBS

TINE_INCL ?= ../../../include
TINE_LIBS ?= ../../../lib

TINEEXE = combobulate
TINELIB = libtinemt.a

HDRS = ${TINE_INCL}/project.def \
	${TINE_INCL}/prolog.h \
	${TINE_INCL}/srvcore.h \
	${TINE_INCL}/srvip.h \
	${TINE_INCL}/errors.h \
	${TINE_INCL}/tinetype.h \
	${TINE_INCL}/tinedefs.h \
	${TINE_INCL}/swaplib.h \
	${TINE_INCL}/dbtools.h \
	${TINE_INCL}/swaplib.h \
	${TINE_INCL}/almlib.h 

CPP = g++ -c -g -I. -I${TINE_INCL}
CC = cc -c -DMULTITHREADED -g -I. -I${TINE_INCL}
CCL = cc -g
LM = -lm -lpthread -lrt

${TINEEXE}: devsrv.o cmbeqm.o
	${CCL} -o ${TINEEXE} devsrv.o cmbeqm.o ${TINE_LIBS}/${TINELIB} ${LM}
	chmod a+x ${TINEEXE}

devsrv.o: devsrv.c ${HDRS}
	${CC} devsrv.c

cmbeqm.o: cmbeqm.c ${HDRS}
	${CC} cmbeqm.c

clean:
	rm -f *.o
