#define APPV_MAJOR 2
#define APPV_MINOR 0
#define APPV_REVISION 0 

#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <sys/types.h>
#include "tine.h"

void PostSystemInit(void);
void PreSystemInit(void);

extern char thisFecName[FEC_NAME_SIZE];
extern char thisLocation[FEC_LOCATION_SIZE];
extern UINT16 thisPortOffset;

char *usageText = "usage: evnsrv [/f=<fecname> /p=<port offset> /l=<location> /d=<debug level>";
int main(int argc, char *argv[])
{
  int i,cc;
  char *c, scratch[256];

  for (i=1; i<argc; i++)
  { /* options given */
    c = argv[i];
    if (*c++ != '/') break;
    switch (tolower(*c))
    {
      case 'f':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(thisFecName,c,FEC_NAME_SIZE);
        }
        continue;
      case 'l':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(thisLocation,c,FEC_LOCATION_SIZE);
        }
        continue;
      case 'p':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(scratch,c,32);
          thisPortOffset = atoi(scratch);      
        }
        continue;
      case 'd':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(scratch,c,32);
          tineDebug = atoi(scratch);      
        }
        continue;
      case '?':
      case 'h':
        printf("%s",usageText);
        exit(0);
      default:
        continue;
    }
  }

  AssignFecApplicationInfo(APPV_MAJOR,APPV_MINOR,APPV_REVISION);
  SetPreSystemInitFunction(PreSystemInit);
  SetPostSystemInitFunction(PostSystemInit);

  if ((cc=SystemInit(TRUE)) != 0) { printf("init error: %s\n",erlst[cc]); exit(1); }
  for(;;)
  {
    SystemCycle(TRUE);
  }
  return 0;
}
