# variables with defaults can be overridden by environment variables
#   TINE_INCL
#   TINE_LIBS
#   TINE_ARCSRC

TINE_INCL ?= ../../../include
TINE_LIBS ?= ../../../lib
TINE_ARCSRC ?= ../../shared

HDRS = ${TINE_INCL}/project.def \
	${TINE_INCL}/prolog.h \
	${TINE_INCL}/srvcore.h \
	${TINE_INCL}/errors.h \
	${TINE_INCL}/tinetype.h \
	${TINE_INCL}/tinedefs.h \
	${TINE_INCL}/swaplib.h \
	${TINE_INCL}/dbtools.h \
	${TINE_INCL}/almlib.h 

TINELIB = libtinemt.a

CPP = g++ -c -g -Wno-deprecated -I. -I${TINE_INCL} -I${TINE_ARCSRC}
CC = cc -c -Aa -DMULTITHREADED -g -I. -I${TINE_INCL} -I${TINE_ARCSRC}
CCL = cc
LM = -lM -lpthread -lrt

evnsrv: devsrv.o evneqm.o apceqm.o arctools.o
	${CCL} -o evnsrv devsrv.o evneqm.o apceqm.o arctools.o ${TINE_LIBS}/${TINELIB} ${LM}
	chmod a+x evnsrv

devsrv.o: devsrv.c ${HDRS}
	${CC} devsrv.c

apceqm.o: ${TINE_ARCSRC}/apceqm.c ${TINE_ARCSRC}/apceqm.h ${TINE_ARCSRC}/arctools.h ${HDRS}
	${CC} ${TINE_ARCSRC}/apceqm.c

evneqm.o: evneqm.c ${TINE_ARCSRC}/apceqm.h ${TINE_ARCSRC}/arctools.h ${HDRS}
	${CC} evneqm.c

arctools.o: ${TINE_ARCSRC}/arctools.c ${TINE_ARCSRC}/arctools.h ${HDRS}
	${CC} ${TINE_ARCSRC}/arctools.c

clean:
	rm -f *.o
