/*
 * devsrv    REVISION HISTORY:
 * Generated by SRVWIZARD on Tue Jun  3 21:21:42 2003
*/

#include "app_version.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "tine.h"
#include "stseqm.h"

char thisFecName[FEC_NAME_SIZE+4] = "";
char thisContext[CONTEXT_NAME_SIZE+4] = "";
char *thisSubSystem = "SER";
char thisFecDescription[FEC_DESC_SIZE] = "";
char thisLocation[FEC_LOCATION_SIZE] = "";
UINT16 thisPortOffset = 0;

void PreSystemInit(void)
{
  /* Some System Parameters and their default values    */
  /* are shown below.  You may change them as necessary */
  FeclogDepth = 1000;
  MaxRPCTransportSize = 65535;
  gRetardSingleContractRemoval = FALSE;
  // useMonthlyHistoryFiles = TRUE; <<- not a good idea; they get big: on 32-bit machines > 2 GBytes !
  AssignFecApplicationInfo(APPV_MAJOR,APPV_MINOR,APPV_REVISION);
  if (strlen(thisContext) > 0)
  {
    int p;
    if (strlen(thisFecName) == 0)
    {
      strncpy(thisFecName,thisContext,10); thisFecName[10] = 0;
      strcat(thisFecName,"STSFEC");
    }
    if (thisPortOffset == 0)
    {
      p = GetPortOffset(thisFecName);
      if (p >= 0) thisPortOffset = p;
    }
    sprintf(thisFecDescription,"%.32s FEC statistics Server",thisContext);
    RegisterFecInformation(thisFecName,thisSubSystem,thisContext,thisFecDescription,thisLocation,"none","administrator",thisPortOffset);
  }
}
extern int nMcaElements;
void PostSystemInit(void)
{
  RegisterEquipmentModule(STSEQM_EXPORT,STSEQM_TAG,nMcaElements,stseqm,stseqm_ini,stseqm_bkg,STSEQM_RATE,stseqm_exi);
}
#if defined(WIN32) || defined(NEED_UNSETENV)
int unsetenv(char *env)
{
  char envstr[128];
  strncpy(envstr,env,120);
  strcat(envstr,"=");
# ifdef WIN32
  return _putenv(envstr);
# else
  return putenv(envstr);
# endif
}
#endif
char *usageText = "usage: fecstats [/f=<fecname> /c=<context> /p=<port offset> /l=<location> /m=<MCA capacity> /d=<debug level>";
int main(int argc, char *argv[])
{
  int i,cc;
  char *c, scratch[256];

  for (i=1; i<argc; i++)
  { /* options given */
    c = argv[i];
    if (*c++ != '/') break;
    switch (tolower(*c))
    {
      case 'f':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(thisFecName,c,FEC_NAME_SIZE);
        }
        continue;
      case 'c':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(thisContext,c,CONTEXT_NAME_SIZE);
        }
        continue;
      case 'l':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(thisLocation,c,FEC_LOCATION_SIZE);
        }
        continue;
      case 'p':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(scratch,c,32);
          thisPortOffset = atoi(scratch);      
        }
        continue;
      case 'm':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(scratch,c,32);
          nMcaElements = atoi(scratch);      
        }
        continue;
      case 'd':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(scratch,c,32);
          tineDebug = atoi(scratch);      
        }
        continue;
      case '?':
      case 'h':
        printf("%s",usageText);
        exit(0);
      default:
        continue;
    }
  }
  /* kill these environment variables if they are set */
  unsetenv("FEC_HOME"); unsetenv("FEC_LOG"); unsetenv("FEC_DB");
  SetPreSystemInitFunction(PreSystemInit);
  SetPostSystemInitFunction(PostSystemInit);
  if ((cc=SystemInit(TRUE)) != 0)
  {
    printf("initialization error : %.32s",cc2str(cc));
    exit(1);
  }
  for(;;)
  {
    SystemCycle(TRUE);
  }
  return 0;
}
