# variables with defaults can be overridden by environment variables
#   TINE_INCL
#   TINE_LIBS

TINE_INCL ?= ../../../include
TINE_LIBS ?= ../../../lib

TINEEXE = fecstats
TINELIB = libtine.a

HDRS = ${TINE_INCL}/project.def \
	${TINE_INCL}/prolog.h \
	${TINE_INCL}/srvcore.h \
	${TINE_INCL}/errors.h \
	${TINE_INCL}/tinetype.h \
	${TINE_INCL}/tinedefs.h \
	${TINE_INCL}/swaplib.h \
	${TINE_INCL}/dbtools.h \
	${TINE_INCL}/almlib.h 

CPP = g++ -I${TINE_INCL}
CC = cc -c -Aa -g -I${TINE_INCL}
CCL = cc -g
LM = -lM -lrt

${TINEEXE}: devsrv.o stseqm.o
	${CCL} -o ${TINEEXE} devsrv.o stseqm.o  ${TINE_LIBS}/${TINELIB} ${LM}
	chmod a+x ${TINEEXE}

devsrv.o: devsrv.c app_version.h ${HDRS}
	${CC} devsrv.c

stseqm.o: stseqm.c stseqm.h ${HDRS}
	${CC} stseqm.c

clean:
	rm -f *.o
