/*
 * stseqm.c    REVISION HISTORY:
 * Generated by SRVWIZARD on Tue Jun  3 21:21:42 2003
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "tine.h"
#include "stseqm.h"


#define IDX_BURSTCNT_PS 25
#define IDX_CONDELAYS_PS 24
#define IDX_CONMISSES_PS 23
#define IDX_CLNRETRIES_PS 22
#define IDX_CLNRECONN_PS 21
#define IDX_CLNMISSES_PS 20
#define IDX_SYNCCALLS_PS 19
#define IDX_MAXCYCCNT_PS 18
#define IDX_CYCLECNT_PS 17
#define IDX_BUSYTIME_PS 16
#define IDX_TIMEOUTCNT 15
#define IDX_REBOOTCNT 14
#define IDX_BURSTCNT 9
#define IDX_CONDELAYS 8
#define IDX_CONMISSES 7
#define IDX_CLNRETRIES 6
#define IDX_CLNRECONN 5
#define IDX_CLNMISSES 4
#define IDX_SYNCCALLS 3
#define IDX_MAXCYCCNTS 2
#define IDX_CYCCNTS 1
#define IDX_BUSYTIME 0

int appendSrvList(int isNew);
int getRebootCounts(void);
int *multiStatArray = NULL;

void stseqm_bkg(void)
{
  static time_t lastt = 0;
  time_t t = time(NULL);
  if (t < lastt + 600) return;
  lastt = t;
  getRebootCounts();
  return;
}

int RegisterStseqmProperties(void)
{
  int cc = 0;
  DTYPE dout;

  memset(&dout,0,sizeof(DTYPE));
  dout.dFormat = CF_INT32;
  dout.dArrayLength = STSEQM_DEVICES_SPACE;
  if ((cc=RegisterPropertyInformation(STSEQM_TAG,"BURSTCNTps",&dout,NULL,
    CA_READ,AT_CHANNEL,0,"[0:1e+10]Burst Limit Reached Count per sec",PRP_BURSTCNTPS,NULL)) < 0) goto err;
  if ((cc=RegisterPropertyInformation(STSEQM_TAG,"CONDELAYSps",&dout,NULL,
    CA_READ,AT_CHANNEL,0,"[0:1e+10]Num Contract Delays per sec",PRP_CONDELAYSPS,NULL)) < 0) goto err;
  if ((cc=RegisterPropertyInformation(STSEQM_TAG,"CONMISSESps",&dout,NULL,
    CA_READ,AT_CHANNEL,0,"[0:1e+10]Num Contract Misses per sec",PRP_CONMISSESPS,NULL)) < 0) goto err;
  if ((cc=RegisterPropertyInformation(STSEQM_TAG,"CLNRETRIESps",&dout,NULL,
    CA_READ,AT_CHANNEL,0,"[0:1e+10]Num Client Retries per sec",PRP_CLNRETRIESPS,NULL)) < 0) goto err;
  if ((cc=RegisterPropertyInformation(STSEQM_TAG,"CLNRECONNECTSps",&dout,NULL,
    CA_READ,AT_CHANNEL,0,"[0:1e+10]Num Client Reconnects per sec",PRP_CLNRECONNECTSPS,NULL)) < 0) goto err;
  if ((cc=RegisterPropertyInformation(STSEQM_TAG,"CLNMISSESps",&dout,NULL,
    CA_READ,AT_CHANNEL,0,"[0:1e+10]Num Client Misses per sec",PRP_CLNMISSESPS,NULL)) < 0) goto err;
  if ((cc=RegisterPropertyInformation(STSEQM_TAG,"SYNCCALLSps",&dout,NULL,
    CA_READ,AT_CHANNEL,0,"[0:1e+10]Num Synchronous Calls per sec",PRP_SYNCCALLSPS,NULL)) < 0) goto err;
  if ((cc=RegisterPropertyInformation(STSEQM_TAG,"MAXCYCLECNTSps",&dout,NULL,
    CA_READ,AT_CHANNEL,0,"[0:1000]Maximum Cycle Counts per sec",PRP_MAXCYCLECNTSPS,NULL)) < 0) goto err;
  if ((cc=RegisterPropertyInformation(STSEQM_TAG,"CYCLECNTSps",&dout,NULL,
    CA_READ,AT_CHANNEL,0,"[0:1000]Average Cycle Counts per sec",PRP_CYCLECNTSPS,NULL)) < 0) goto err;
  if ((cc=RegisterPropertyInformation(STSEQM_TAG,"BUSYTIMEps",&dout,NULL,
    CA_READ,AT_CHANNEL,0,"[0:100]Average Busy Time per sec",PRP_BUSYTIMEPS,NULL)) < 0) goto err;
  if ((cc=RegisterPropertyInformation(STSEQM_TAG,"TIMEOUTCNT",&dout,NULL,
    CA_READ,AT_CHANNEL,0,"[0:1e+10]Timeout Count",PRP_TIMEOUTCNT,NULL)) < 0) goto err;
  if ((cc=RegisterPropertyInformation(STSEQM_TAG,"BURSTCNT",&dout,NULL,
    CA_READ,AT_CHANNEL,0,"[0:1e+10]Burst Limit Reached Count",PRP_BURSTCNT,NULL)) < 0) goto err;
  if ((cc=RegisterPropertyInformation(STSEQM_TAG,"REBOOTCNT",&dout,NULL,
    CA_READ,AT_CHANNEL,0,"[0:1e+10]Server Reboot Count",PRP_REBOOTCNT,NULL)) < 0) goto err;
  if ((cc=RegisterPropertyInformation(STSEQM_TAG,"CONDELAYS",&dout,NULL,
    CA_READ,AT_CHANNEL,0,"[0:1e+10 Num Contract Del]Num Contract Delays",PRP_CONDELAYS,NULL)) < 0) goto err;
  if ((cc=RegisterPropertyInformation(STSEQM_TAG,"CONMISSES",&dout,NULL,
    CA_READ,AT_CHANNEL,0,"[0:1e+10]Num Contract Misses",PRP_CONMISSES,NULL)) < 0) goto err;
  if ((cc=RegisterPropertyInformation(STSEQM_TAG,"CLNRETRIES",&dout,NULL,
    CA_READ,AT_CHANNEL,0,"[0:1e+10 Num Client Retri]Num Client Retries",PRP_CLNRETRIES,NULL)) < 0) goto err;
  if ((cc=RegisterPropertyInformation(STSEQM_TAG,"CLNRECONNECTS",&dout,NULL,
    CA_READ,AT_CHANNEL,0,"[0:1e+10]Num Client Reconnects",PRP_CLNRECONNECTS,NULL)) < 0) goto err;
  if ((cc=RegisterPropertyInformation(STSEQM_TAG,"CLNMISSES",&dout,NULL,
    CA_READ,AT_CHANNEL,0,"[0:1e+10]Num Client Misses",PRP_CLNMISSES,NULL)) < 0) goto err;
  if ((cc=RegisterPropertyInformation(STSEQM_TAG,"SYNCCALLS",&dout,NULL,
    CA_READ,AT_CHANNEL,0,"[0:1e+10]Num Synchronous Calls",PRP_SYNCCALLS,NULL)) < 0) goto err;
  if ((cc=RegisterPropertyInformation(STSEQM_TAG,"MAXCYCLECNTS",&dout,NULL,
    CA_READ,AT_CHANNEL,0,"[0:1000]Maximum Cycle Counts",PRP_MAXCYCLECNTS,NULL)) < 0) goto err;
  if ((cc=RegisterPropertyInformation(STSEQM_TAG,"CYCLECNTS",&dout,NULL,
    CA_READ,AT_CHANNEL,0,"[0:1000 Average Cycle Co]Average Cycle Counts",PRP_CYCLECNTS,NULL)) < 0) goto err;
  if ((cc=RegisterPropertyInformation(STSEQM_TAG,"BUSYTIME",&dout,NULL,
    CA_READ,AT_CHANNEL,0,"[0:100]Average Busy Time",PRP_BUSYTIME,NULL)) < 0) goto err;

  dout.dFormat = CF_NAME32;
  dout.dArrayLength = 10;
  if ((cc=RegisterPropertyInformation(STSEQM_TAG,"ServersOnFec",&dout,NULL,
    CA_READ,AT_COLLECTION,0,"Servers on target FEC",PRP_SRVSONFEC,NULL)) < 0) goto err;

  dout.dFormat = CF_NAME32;
  dout.dArrayLength = STSEQM_DEVICES_SPACE*2;
  if ((cc=RegisterPropertyInformation(STSEQM_TAG,"ServerFecPairs",&dout,NULL,
    CA_READ,AT_DOUBLE,2,"Server/Fec list as double array",PRP_SRVFECPAIRS,NULL)) < 0) goto err;

err:
  if (cc < 0)
  {
    printf("Can't register property : %s\n>",erlst[-cc]);
  }
  return cc;
}
#define SRVDBASE_FILE "srvlist.csv"
typedef struct
{
  char name[32];
  int status[32];
  char fec[16];
  int last[16];
  time_t timestamp;
  int recid;
  int duplicateEntry;
  int defunctEntry;
  int stsId;
  int rbId;
  int nsrvs;
  NAME32 *srvs;
} SRVSTATS;

SRVSTATS *srvList = NULL;
int nServers = 0;
CSVCOLUMN csvSrvColumns[] =
{
  { "NAME","",0,CF_TEXT,32,(BYTE *)OFFSETIN(SRVSTATS,name),NULL },
  { "FEC","",0,CF_TEXT,16,(BYTE *)OFFSETIN(SRVSTATS,fec),NULL },
  { "RECORD","",0,CF_LONG,1,(BYTE *)OFFSETIN(SRVSTATS,recid),NULL }
};
CSVDB csvSrvDb =
{
  csvSrvColumns,
  sizeof(csvSrvColumns)/sizeof(csvSrvColumns[0]),
  0,
  csvStdInit,
  csvStdIterator,
  csvStdExit,
  0,
  NULL,
  sizeof(SRVSTATS),
  0
};

int nMcaElements = STSEQM_DEVICES_SPACE;
int mcaCeiling = 0;

int getAdditionalServers(SRVSTATS *srvLst);
void srvRebootsCb(int id, int cc)
{
  if (cc) return;
}
void srvStatsCb(int id, int cc)
{
  int i = id-1, k, dt, ds;
  time_t ts = time(NULL); 

  switch (cc)
  {
    case non_existent_elem:
    case non_existent:
    case non_existent_server:
    case address_unknown:
      srvList[i].defunctEntry = TRUE;
      CloseLink(srvList[i].stsId);
      return;
    case link_not_open:
      srvList[i].status[IDX_TIMEOUTCNT]++;
      return;
    default:
      break;
  }
  for (k=0; k<12; k++) 
  {
    dt = (int)(ts - srvList[i].timestamp);
    ds = srvList[i].status[k] - srvList[i].last[k];
    if (dt > 0) srvList[i].status[16+k] = ds / dt;
    srvList[i].last[k] = srvList[i].status[k];
  }
  srvList[i].timestamp = ts;
  return;
}
int startMcaHistories(void)
{
  int i, n, cc;
  HistorySpecification hsp;

  memset(&hsp,0,sizeof(hsp));
  hsp.pollingRate = 1000; // msec
  hsp.archiveRate = 60;   // sec
  hsp.depthShort  = 600;  // # entries @ polling rate
  hsp.depthLong   = 1;    // months
  hsp.heartbeat   = 900;  // seconds
  hsp.pTolerance  = 10.0;
  hsp.aTolerance  = 0;

  AppendHistoryInformationEx(STSEQM_TAG,"BUSYTIME","#0",nMcaElements,CF_INT32,1,&hsp,USE_POI_NONE);

  hsp.pTolerance  = 0;
  hsp.aTolerance  = 1;

  AppendHistoryInformationEx(STSEQM_TAG,"SYNCCALLS","#0",nMcaElements,CF_INT32,2,&hsp,USE_POI_NONE);
  AppendHistoryInformationEx(STSEQM_TAG,"CLNRECONNECTS","#0",nMcaElements,CF_INT32,3,&hsp,USE_POI_NONE);
  AppendHistoryInformationEx(STSEQM_TAG,"CONMISSES","#0",nMcaElements,CF_INT32,4,&hsp,USE_POI_NONE);
  AppendHistoryInformationEx(STSEQM_TAG,"TIMEOUTCNT","#0",nMcaElements,CF_INT32,5,&hsp,USE_POI_NONE);
  AppendHistoryInformationEx(STSEQM_TAG,"REBOOTCNT","#0",nMcaElements,CF_INT32,6,&hsp,USE_POI_NONE);

  cc = getLastStoredData(STSEQM_TAG,"TIMEOUTCNT","#0",0,(BYTE *)multiStatArray,CF_INT32,nMcaElements);
  if (cc == 0)
  { // start out with the last timeout data ...
    for (i=0; i<nServers; i++)
    {
      if (srvList[i].duplicateEntry || srvList[i].defunctEntry) continue;
      if ((n=srvList[i].recid) < nMcaElements)
      {
        srvList[i].status[IDX_TIMEOUTCNT] = multiStatArray[n];
      }
    }
  }
  else
  {
    feclog("INIT: can't get last stored TIMEOUTCNT data -> %.32s",erlst[cc]);
  }
  return cc;
}
int keepHistoryOf(char *srv,int id)
{
  HistorySpecification hsp;

  hsp.pollingRate = 1000; // msec
  hsp.archiveRate = 60;   // sec
  hsp.depthShort  = 600;  // # entries @ polling rate
  hsp.depthLong   = 1;    // months
  hsp.heartbeat   = 900;  // seconds
  hsp.pTolerance  = 10.0;
  hsp.aTolerance  = 0;

  AppendHistoryInformationEx(STSEQM_TAG,"BUSYTIME",srv,1,CF_LONG,id++,&hsp,USE_POI_NONE);

  hsp.pTolerance  = 0;
  hsp.aTolerance  = 1;

  AppendHistoryInformationEx(STSEQM_TAG,"SYNCCALLS",srv,1,CF_LONG,id++,&hsp,USE_POI_NONE);
  AppendHistoryInformationEx(STSEQM_TAG,"CLNRECONNECTS",srv,1,CF_LONG,id++,&hsp,USE_POI_NONE);
  AppendHistoryInformationEx(STSEQM_TAG,"CONMISSES",srv,1,CF_LONG,id++,&hsp,USE_POI_NONE);
  AppendHistoryInformationEx(STSEQM_TAG,"TIMEOUTCNT",srv,1,CF_LONG,id++,&hsp,USE_POI_NONE);
  AppendHistoryInformationEx(STSEQM_TAG,"REBOOTCNT",srv,1,CF_LONG,id++,&hsp,USE_POI_NONE);

  return 0;
}
int isInFecList(char *fec,int ceiling)
{
  int i;

  for (i=0; i<ceiling; i++)
  {
    if (strnicmp(srvList[i].fec,fec,FEC_NAME_SIZE)) continue;
    return TRUE;
  }
  return FALSE;
}
int isInServerList(char *srv)
{
  int i;

  for (i=0; i<nServers; i++)
  {
    if (strnicmp(srvList[i].name,srv,EXPORT_NAME_SIZE)) continue;
    return TRUE;
  }
  return FALSE;
}
int readServerList(void)
{
  int i, cc = 0, n = 0, ceiling=-1;
  if (srvList != NULL)
  {
    free(srvList); srvList = NULL;
  }
  switch ((cc=csvReadFile("",SRVDBASE_FILE,&csvSrvDb,(void **)&srvList)))
  {
    case 0:
      nServers = csvSrvDb.siz;
      n = appendSrvList(nServers > 0 ? FALSE : TRUE);
      break;
    case no_such_file:
      n = appendSrvList(TRUE);
      break;
    default:
      feclog("%s : %s\n",SRVDBASE_FILE,erlst[cc]);
      return -cc;
  }

  for (i=1; i<nServers; i++)
  {
    if (isInFecList(srvList[i].fec,i)) srvList[i].duplicateEntry = TRUE;
    else getAdditionalServers(&srvList[i]);
    // recid will be the device number => must be less than array size
    if (srvList[i].recid > ceiling - 1) ceiling = srvList[i].recid + 1;
  }
  if (ceiling >= nMcaElements)
  {
    feclog("number of configured records %d exceeds the MCA array capacity %d!",
      ceiling,nMcaElements);
    ceiling = nMcaElements;
  }
  mcaCeiling = ceiling;
  return n;
}
int getServersOnFec(char *fec,DTYPE *d)
{
  int i,n=0,nlen=fmtsizeof(d->dFormat),clen=MIN(nlen,32);
  int limit = d->dArrayLength;
  char *c = d->data.cptr;
  if (!isSimpleStringFormat(d->dFormat) || d->dFormat == CF_TEXT) return illegal_format;
  for (i=0; i<nServers && n<limit; i++)
  {
    if (strncmp(srvList[i].fec,fec,FEC_NAME_SIZE)) continue;
    if (srvList[i].nsrvs > 0 && srvList[i].srvs != NULL)
    {
      int k;
      for (k=0; k<srvList[i].nsrvs && n<limit; k++)
      {
        strncpy(c+nlen*n++,srvList[i].srvs[k].name,clen);
      }
    }
    else
    {
      strncpy(c+nlen*n++,srvList[i].name,clen);
    }
  }
  d->dArrayLength = n;
  return 0;
}
int getSrvFecPairs(DTYPE *d)
{
  int i,n=0,nlen=fmtsizeof(d->dFormat),clen=MIN(nlen,32);
  int limit = d->dArrayLength;
  char *c = d->data.cptr;
  if (!isSimpleStringFormat(d->dFormat) || d->dFormat == CF_TEXT || d->dFormat == CF_NAME8) 
    return illegal_format;
  for (i=0; i<nServers && n<limit; i++)
  {
    if (srvList[i].duplicateEntry || srvList[i].defunctEntry) continue;
    if (srvList[i].nsrvs > 0 && srvList[i].srvs != NULL)
    {
      int k;
      for (k=0; k<srvList[i].nsrvs && n<limit; k++)
      {
        strncpy(c+nlen*n++,srvList[i].srvs[k].name,clen);
        strncpy(c+nlen*n++,srvList[i].fec,16);
      }
    }
    else
    {
      strncpy(c+nlen*n++,srvList[i].name,clen);
      strncpy(c+nlen*n++,srvList[i].fec,16);
    }
  
  }
  d->dArrayLength = n;
  return 0;
}
int getAdditionalServers(SRVSTATS *srvLst)
{
  NAME16 inp;
  DTYPE dout,din;
  int cc, i;
  char devName[128];
  static NAME16 multiFecs[100];
  static int init_done = FALSE, nMultiFecs = 0;

  if (!init_done)
  {
    strcpy(inp.name,"MULTI");
    din.dArrayLength = 1;
    din.dFormat = CF_NAME16;
    din.data.vptr = &inp;

    dout.dArrayLength = 100;
    dout.dFormat = CF_NAME16;
    dout.data.vptr = multiFecs;

    sprintf(devName,"/SITE/ENS/%s",gDeviceContext);
    cc = ExecLinkEx(devName,"FECS",&dout,&din,CA_READ|CA_RETRY|CA_MUTABLE,500);
    if (cc != 0)
    {
      feclog("could not query ENS for multi-server FECS : %s",erlst[cc]);
      return cc;
    }
    nMultiFecs = dout.dArrayLength;
    init_done = TRUE;
  }
  for (i=0; i<nMultiFecs; i++) if (!strncmp(multiFecs[i].name,srvLst->fec,FEC_NAME_SIZE)) break;
  if (i == nMultiFecs)
  {
    srvLst->srvs = NULL;
    srvLst->nsrvs = 0;
    return 0;
  }
  strncpy(inp.name,srvLst->fec,FEC_NAME_SIZE);
  din.dArrayLength = 1;
  din.dFormat = CF_NAME16;
  din.data.vptr = &inp;

  dout.dArrayLength = 25;
  dout.dFormat = CF_NAME32;
  srvLst->srvs = (NAME32 *)calloc(25,sizeof(NAME32));
  dout.data.vptr = srvLst->srvs;

  sprintf(devName,"/SITE/ENS/%s",gDeviceContext);
  cc = ExecLinkEx(devName,"SERVERS",&dout,&din,CA_READ|CA_RETRY|CA_MUTABLE,500);
  if (cc != 0)
  {
    feclog("could not query ENS for servers on FEC %.16s : %s",inp.name,erlst[cc]);
    return cc;
  }
  srvLst->nsrvs = dout.dArrayLength;
  return 0;
}
int appendSrvList(int isNew)
{
  DTYPE dout,din;
  NAME16 inp[2];
  DUSTRING outp[500];
  char devName[128],srv[32],fec[32],*ptr;
  int cc=0, i, k, num, recid_offset=-1;
  FILE *fp=NULL;

  if (!isNew) 
  { /* if there's already a list, don't query the ENS for new IMPORTANT entries unless env says so */
    if ((ptr=getenv("APPEND_LIST")) == NULL) return nServers;
    if (stricmp(ptr,"TRUE") != 0) return nServers;
    remove("srvlist.bak");
    rename("srvlist.csv","srvlist.bak");
  }

  strcpy(inp[0].name,"ALL");
  strcpy(inp[1].name,"IMPORTANT");
  din.dArrayLength = 2;
  din.dFormat = CF_NAME16;
  din.data.vptr = inp;

  dout.dArrayLength = 500;
  dout.dFormat = CF_USTRING;
  dout.data.vptr = outp;

  sprintf(devName,"/SITE/ENS/%s",gDeviceContext);
  cc = ExecLinkEx(devName,"TAGS",&dout,&din,CA_READ|CA_RETRY|CA_MUTABLE,500);

  if (cc != 0)
  {
    feclog("could not query ENS for important servers : %s",erlst[cc]);
    return cc;
  }

  if ((fp=fopen("srvlist.csv","w")) == NULL)
  {
    feclog("could not create file srvlist.csv !");
    return file_error;
  }
  fprintf(fp,"NAME, FEC, RECORD\n");
  for (i=0; i<nServers; i++)
  { /* any entries already read in ? */
    if (!strcmp(srvList[i].fec,"GENS")) continue; /* don't put the GENS in the list */
    fprintf(fp,"%.32s, %.16s, %d\n",srvList[i].name,srvList[i].fec,srvList[i].recid);
    if (srvList[i].recid > recid_offset) recid_offset = srvList[i].recid;
  }  
  num = dout.dArrayLength;
  for (i=0; i<num; i++)
  {
    sprintf(srv,"%.16s",outp[i].str); srv[16] = 0;
    if (srv[15] == '&') 
    { /* special carrier logic for this exotic format type (a USTRING query to the ENS) */
      srv[15] = 0;
      strncat(srv,&outp[i].str[48],17);
    }
    sprintf(fec,"%.16s",&outp[i].str[32]); fec[16] = 0;
    if (isInFecList(fec,nServers)) continue;
    for (k=0; k<i-1; k++) if (!strncmp(fec,&outp[k].str[32],16)) break;
    if (k < i-1) continue;
    if (!isNew && isInServerList(srv)) continue;
    if (!strcmp(srv,"FECSTATS")) continue; /* don't put myself in the list */
    if (!strcmp(fec,"GENS")) continue; /* don't put the GENS in the list */
    fprintf(fp,"%.32s, %.16s, %d\n",srv,fec,++recid_offset);
  }

  fclose(fp);

  if (srvList != NULL)
  {
    free(srvList); srvList = NULL;
  }
  cc = csvReadFile("",SRVDBASE_FILE,&csvSrvDb,(void **)&srvList);
  return cc == 0 ? csvSrvDb.siz : -cc;
}
void dumpSrvList(void)
{
  FILE *fp=NULL;
  int i;
  if ((fp=fopen("srvlist.csv","w")) == NULL)
  {
    feclog("could not create file srvlist.csv for dump!");
    return;
  }
  fprintf(fp,"NAME, FEC, RECORD\n");
  for (i=0; i<nServers; i++)
  {
    if (srvList[i].duplicateEntry || srvList[i].defunctEntry) continue;
    fprintf(fp,"%.32s, %.16s, %d\n",srvList[i].name,srvList[i].fec,srvList[i].recid);
  }
  fclose(fp);
  return;
}
NAME32I *rbcBuffer = NULL;
int rbcBufferSize = 0;
int rbcArrayLength = 0;
int getRebootCount(char *srv)
{
  int i;
  for (i=0; i<rbcArrayLength; i++)
  {
    if (!strnicmp(srv,rbcBuffer[i].name,32)) return rbcBuffer[i].ival;
  }
  return 0;
}
int getRebootCounts(void)
{
  DTYPE dout;
  char devnam[256];
  int i, cc;

  if (rbcBufferSize == 0)
  {
    rbcBufferSize = nServers*2;
    if (rbcBufferSize < 100) rbcBufferSize = 100;
    rbcBufferSize += 100 - (rbcBufferSize%100);
    if ((rbcBuffer=(NAME32I *)calloc(rbcBufferSize,sizeof(NAME32I))) == NULL)
    {
      tineDebug = 1;
      feclog("cannot alloc reboot count buffer !");
      exit(1);
    }
  }
  memset(&dout,0,sizeof(DTYPE));
  sprintf(devnam,"/SITE/ENS/%.32s",gDeviceContext);
  dout.dFormat = CF_NAME32I;
  dout.dArrayLength = rbcBufferSize;
  dout.data.vptr = rbcBuffer;
  cc = ExecLinkEx(devnam,"REBOOTCOUNT.LIST",&dout,NULL,CA_READ|CA_MUTABLE,1000);
  if (cc != 0) return cc;
  rbcArrayLength = dout.dArrayLength;
  for (i=0; i<nServers; i++)
  {
    srvList[i].status[IDX_REBOOTCNT] = getRebootCount(srvList[i].name);
  }
  return 0;
}

void stseqm_ini(void)
{
  char devnam[128],ddn[64];
  int lnkID,i,k,n,nlast=-1,dumpDb=FALSE;
  DTYPE dout;
# ifdef HISTORY_THE_OLDWAY
  int cc, tmpLong[2];
# endif

  RegisterStseqmProperties();

  /* 
  read database for list of relevant servers and register the
  servers as device names as well as start links for SRVSTATS
  for each ...
  */
  nServers = readServerList();
  if (nServers <= 0) 
  { /* no sense going any further */
    feclog("cannot process server list !");
    nServers = 0;
    return;
  }
//  maxHistoryRecords = nServers * 10;
  AssignNumModules(STSEQM_TAG,mcaCeiling);

  if ((multiStatArray=(int *)calloc(nMcaElements,sizeof(int))) == NULL)
  {
    feclog("cannot allocate multi-channel memory");
    nServers = 0;
    exit(1);
  }

  for (i=0; i<nServers; i++)
  {
    if (srvList[i].duplicateEntry) 
    {
      dumpDb = TRUE;
      continue;
    }
    n = srvList[i].recid;
    if (n != nlast+1)
    { /* these will be in order in the file */
      for (k=nlast+1; k<n; k++) 
      {
        sprintf(ddn,"Reserved%d",k);
        RegisterDeviceName(STSEQM_TAG,ddn,k);
      }
    }
    nlast = n;
    RegisterDeviceName(STSEQM_TAG,srvList[i].fec,n);
    sprintf(devnam,"/%.32s/%.32s",gDeviceContext,srvList[i].name);
    dout.dFormat = CF_LONG;
    dout.dArrayLength = 10;
    dout.data.lptr = (SINT32 *)srvList[i].status;
    srvList[i].status[0] = -1; // use as init flag
    lnkID = AttachLinkEx(devnam,"SRVSTATS",&dout,NULL,CA_READ,5000,srvStatsCb,CM_POLL,i+1);
    if (lnkID < 0)
    {
      feclog("%s : %s",devnam,erlst[-lnkID]);
      srvList[i].defunctEntry = TRUE;
      dumpDb = TRUE;
      continue;
    }
    srvList[i].stsId = lnkID;
#   ifdef HISTORY_THE_OLDWAY
    keepHistoryOf(srvList[i].fec,srvList[i].recid*10);
    cc = getLastStoredData(STSEQM_TAG,"TIMEOUTCNT",srvList[i].name,0,(BYTE *)tmpLong,CF_LONG,2);
    if (cc) 
    {
      feclog("INIT: can't get last stored data -> %.32s",erlst[abs(cc)]);
      srvList[i].status[IDX_TIMEOUTCNT] = 0;
      feclog("INIT: zero timeout counter");
    }
    else
    {
      if (tmpLong[0] > 0) srvList[i].status[IDX_TIMEOUTCNT] = tmpLong[0];
      feclog("INIT: adjust timeout counter to %d",srvList[i].status[IDX_TIMEOUTCNT]);
    }
#   endif
  }
  if (dumpDb) dumpSrvList();

  startMcaHistories();

}

void stseqm_exi(void)
{
  /* TODO: put your shutdown routines here */
}

#define g_burstcntps srvList[devnr].status[16+9]
#define g_condelaysps srvList[devnr].status[16+8]
#define g_conmissesps srvList[devnr].status[16+7]
#define g_clnretriesps srvList[devnr].status[16+6]
#define g_clnreconnectsps srvList[devnr].status[16+5]
#define g_clnmissesps srvList[devnr].status[16+4]
#define g_synccallsps srvList[devnr].status[16+3]
#define g_maxcyclecntsps srvList[devnr].status[16+2]
#define g_cyclecntsps srvList[devnr].status[16+1]
#define g_busytimeps srvList[devnr].status[16]
#define g_timeoutcnt srvList[devnr].status[IDX_TIMEOUTCNT]
#define g_rebootcnt srvList[devnr].status[IDX_REBOOTCNT]
#define g_burstcnt srvList[devnr].status[9]
#define g_condelays srvList[devnr].status[8]
#define g_conmisses srvList[devnr].status[7]
#define g_clnretries srvList[devnr].status[6]
#define g_clnreconnects srvList[devnr].status[5]
#define g_clnmisses srvList[devnr].status[4]
#define g_synccalls srvList[devnr].status[3]
#define g_maxcyclecnts srvList[devnr].status[2]
#define g_cyclecnts srvList[devnr].status[1]
#define g_busytime srvList[devnr].status[0]


int prepMca(int *mca,int index)
{
  int i,n=0;

  if (index < 0 || index > 25) return illegal_property;
  for (i=0; i<nServers; i++)
  {
    if (srvList[i].duplicateEntry || srvList[i].defunctEntry) continue;
    if ((n=srvList[i].recid) < nMcaElements)
    {
      mca[n] = srvList[i].status[index];
    }
  }
  return 0;
}
int getSrvIdxFromDevNr(int devnr)
{
  int i;
  for (i=0; i<nServers && srvList[i].recid != devnr; i++);
  return (i == nServers) ? 0 : i;
}
int stseqm(char *devName,char *devProperty,DTYPE *dout, DTYPE *din,short access)
{
  int devnr,prpid,cc;

  /* get device number from device name  */
  devnr = GetDeviceNumber(STSEQM_TAG,devName);
  /* you may want to make the following check: */
  if (devnr < 0) return illegal_equipment_number;

  prpid = GetPropertyId(STSEQM_TAG,devProperty);

  switch (prpid)
  {
    case PRP_BURSTCNTPS:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength == 1)
          {
            devnr = getSrvIdxFromDevNr(devnr);
            if ((cc=putValuesFromLong(dout,(SINT32 *)&g_burstcntps,1)) != 0) return cc;
          }
          else
          {
            if (dout->dArrayLength > (UINT32)mcaCeiling) dout->dArrayLength = mcaCeiling;
            prepMca(multiStatArray,IDX_BURSTCNT_PS);
            if ((cc=PutValuesFromLongEx(dout,multiStatArray,nMcaElements,devnr)) != 0) return cc;
          }
        }
        return 0;
    case PRP_CONDELAYSPS:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength == 1)
          {
            devnr = getSrvIdxFromDevNr(devnr);
            if ((cc=putValuesFromLong(dout,(SINT32 *)&g_condelaysps,1)) != 0) return cc;
          }
          else
          {
            if (dout->dArrayLength > (UINT32)mcaCeiling) dout->dArrayLength = mcaCeiling;
            prepMca(multiStatArray,IDX_CONDELAYS_PS);
            if ((cc=PutValuesFromLongEx(dout,multiStatArray,nMcaElements,devnr)) != 0) return cc;
          }
        }
        return 0;
    case PRP_CONMISSESPS:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength == 1)
          {
            devnr = getSrvIdxFromDevNr(devnr);
            if ((cc=putValuesFromLong(dout,(SINT32 *)&g_conmissesps,1)) != 0) return cc;
          }
          else
          {
            if (dout->dArrayLength > (UINT32)mcaCeiling) dout->dArrayLength = mcaCeiling;
            prepMca(multiStatArray,IDX_CONMISSES_PS);
            if ((cc=PutValuesFromLongEx(dout,multiStatArray,nMcaElements,devnr)) != 0) return cc;
          }
        }
        return 0;
    case PRP_CLNRETRIESPS:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength == 1)
          {
            devnr = getSrvIdxFromDevNr(devnr);
            if ((cc=putValuesFromLong(dout,(SINT32 *)&g_clnretriesps,1)) != 0) return cc;
          }
          else
          {
            if (dout->dArrayLength > (UINT32)mcaCeiling) dout->dArrayLength = mcaCeiling;
            prepMca(multiStatArray,IDX_CLNRETRIES_PS);
            if ((cc=PutValuesFromLongEx(dout,multiStatArray,nMcaElements,devnr)) != 0) return cc;
          }
        }
        return 0;
    case PRP_CLNRECONNECTSPS:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength == 1)
          {
            devnr = getSrvIdxFromDevNr(devnr);
            if ((cc=putValuesFromLong(dout,(SINT32 *)&g_clnreconnectsps,1)) != 0) return cc;
          }
          else
          {
            if (dout->dArrayLength > (UINT32)mcaCeiling) dout->dArrayLength = mcaCeiling;
            prepMca(multiStatArray,IDX_CLNRECONN_PS);
            if ((cc=PutValuesFromLongEx(dout,multiStatArray,nMcaElements,devnr)) != 0) return cc;
          }
        }
        return 0;
    case PRP_CLNMISSESPS:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength == 1)
          {
            devnr = getSrvIdxFromDevNr(devnr);
            if ((cc=putValuesFromLong(dout,(SINT32 *)&g_clnmissesps,1)) != 0) return cc;
          }
          else
          {
            if (dout->dArrayLength > (UINT32)mcaCeiling) dout->dArrayLength = mcaCeiling;
            prepMca(multiStatArray,IDX_CLNMISSES_PS);
            if ((cc=PutValuesFromLongEx(dout,multiStatArray,nMcaElements,devnr)) != 0) return cc;
          }
        }
        return 0;
    case PRP_SYNCCALLSPS:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength == 1)
          {
            devnr = getSrvIdxFromDevNr(devnr);
            if ((cc=putValuesFromLong(dout,(SINT32 *)&g_synccallsps,1)) != 0) return cc;
          }
          else
          {
            if (dout->dArrayLength > (UINT32)mcaCeiling) dout->dArrayLength = mcaCeiling;
            prepMca(multiStatArray,IDX_SYNCCALLS_PS);
            if ((cc=PutValuesFromLongEx(dout,multiStatArray,nMcaElements,devnr)) != 0) return cc;
          }
        }
        return 0;
    case PRP_MAXCYCLECNTSPS:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength == 1)
          {
            devnr = getSrvIdxFromDevNr(devnr);
            if ((cc=putValuesFromLong(dout,(SINT32 *)&g_maxcyclecntsps,1)) != 0) return cc;
          }
          else
          {
            if (dout->dArrayLength > (UINT32)mcaCeiling) dout->dArrayLength = mcaCeiling;
            prepMca(multiStatArray,IDX_MAXCYCCNT_PS);
            if ((cc=PutValuesFromLongEx(dout,multiStatArray,nMcaElements,devnr)) != 0) return cc;
          }
        }
        return 0;
    case PRP_CYCLECNTSPS:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength == 1)
          {
            devnr = getSrvIdxFromDevNr(devnr);
            if ((cc=putValuesFromLong(dout,(SINT32 *)&g_cyclecntsps,1)) != 0) return cc;
          }
          else
          {
            if (dout->dArrayLength > (UINT32)mcaCeiling) dout->dArrayLength = mcaCeiling;
            prepMca(multiStatArray,IDX_CYCLECNT_PS);
            if ((cc=PutValuesFromLongEx(dout,multiStatArray,nMcaElements,devnr)) != 0) return cc;
          }
        }
        return 0;
    case PRP_BUSYTIMEPS:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength == 1)
          {
            devnr = getSrvIdxFromDevNr(devnr);
            if ((cc=putValuesFromLong(dout,(SINT32 *)&g_busytimeps,1)) != 0) return cc;
          }
          else
          {
            if (dout->dArrayLength > (UINT32)mcaCeiling) dout->dArrayLength = mcaCeiling;
            prepMca(multiStatArray,IDX_BUSYTIME_PS);
            if ((cc=PutValuesFromLongEx(dout,multiStatArray,nMcaElements,devnr)) != 0) return cc;
          }
        }
        return 0;
    case PRP_TIMEOUTCNT:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength == 1)
          {
            devnr = getSrvIdxFromDevNr(devnr);
            if ((cc=putValuesFromLong(dout,(SINT32 *)&g_timeoutcnt,1)) != 0) return cc;
          }
          else
          {
            if (dout->dArrayLength > (UINT32)mcaCeiling) dout->dArrayLength = mcaCeiling;
            prepMca(multiStatArray,IDX_TIMEOUTCNT);
            if ((cc=PutValuesFromLongEx(dout,multiStatArray,nMcaElements,devnr)) != 0) return cc;
          }
        }
        return 0;
    case PRP_BURSTCNT:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength == 1)
          {
            devnr = getSrvIdxFromDevNr(devnr);
            if ((cc=putValuesFromLong(dout,(SINT32 *)&g_burstcnt,1)) != 0) return cc;
          }
          else
          {
            if (dout->dArrayLength > (UINT32)mcaCeiling) dout->dArrayLength = mcaCeiling;
            prepMca(multiStatArray,IDX_BURSTCNT);
            if ((cc=PutValuesFromLongEx(dout,multiStatArray,nMcaElements,devnr)) != 0) return cc;
          }
        }
        return 0;
    case PRP_CONDELAYS:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength == 1)
          {
            devnr = getSrvIdxFromDevNr(devnr);
            if ((cc=putValuesFromLong(dout,(SINT32 *)&g_condelays,1)) != 0) return cc;
          }
          else
          {
            if (dout->dArrayLength > (UINT32)mcaCeiling) dout->dArrayLength = mcaCeiling;
            prepMca(multiStatArray,IDX_CONDELAYS);
            if ((cc=PutValuesFromLongEx(dout,multiStatArray,nMcaElements,devnr)) != 0) return cc;
          }
        }
        return 0;
    case PRP_CONMISSES:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength == 1)
          {
            devnr = getSrvIdxFromDevNr(devnr);
            if ((cc=putValuesFromLong(dout,(SINT32 *)&g_conmisses,1)) != 0) return cc;
          }
          else
          {
            if (dout->dArrayLength > (UINT32)mcaCeiling) dout->dArrayLength = mcaCeiling;
            prepMca(multiStatArray,IDX_CONMISSES);
            if ((cc=PutValuesFromLongEx(dout,multiStatArray,nMcaElements,devnr)) != 0) return cc;
          }
        }
        return 0;
    case PRP_CLNRETRIES:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength == 1)
          {
            devnr = getSrvIdxFromDevNr(devnr);
            if ((cc=putValuesFromLong(dout,(SINT32 *)&g_clnretries,1)) != 0) return cc;
          }
          else
          {
            if (dout->dArrayLength > (UINT32)mcaCeiling) dout->dArrayLength = mcaCeiling;
            prepMca(multiStatArray,IDX_CLNRETRIES);
            if ((cc=PutValuesFromLongEx(dout,multiStatArray,nMcaElements,devnr)) != 0) return cc;
          }
        }
        return 0;
    case PRP_CLNRECONNECTS:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength == 1)
          {
            devnr = getSrvIdxFromDevNr(devnr);
            if ((cc=putValuesFromLong(dout,(SINT32 *)&g_clnreconnects,1)) != 0) return cc;
          }
          else
          {
            if (dout->dArrayLength > (UINT32)mcaCeiling) dout->dArrayLength = mcaCeiling;
            prepMca(multiStatArray,IDX_CLNRECONN);
            if ((cc=PutValuesFromLongEx(dout,multiStatArray,nMcaElements,devnr)) != 0) return cc;
          }
        }
        return 0;
    case PRP_CLNMISSES:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength == 1)
          {
            devnr = getSrvIdxFromDevNr(devnr);
            if ((cc=putValuesFromLong(dout,(SINT32 *)&g_clnmisses,1)) != 0) return cc;
          }
          else
          {
            if (dout->dArrayLength > (UINT32)mcaCeiling) dout->dArrayLength = mcaCeiling;
            prepMca(multiStatArray,IDX_CLNMISSES);
            if ((cc=PutValuesFromLongEx(dout,multiStatArray,nMcaElements,devnr)) != 0) return cc;
          }
        }
        return 0;
    case PRP_SYNCCALLS:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength == 1)
          {
            devnr = getSrvIdxFromDevNr(devnr);
            if ((cc=putValuesFromLong(dout,(SINT32 *)&g_synccalls,1)) != 0) return cc;
          }
          else
          {
            if (dout->dArrayLength > (UINT32)mcaCeiling) dout->dArrayLength = mcaCeiling;
            prepMca(multiStatArray,IDX_SYNCCALLS);
            if ((cc=PutValuesFromLongEx(dout,multiStatArray,nMcaElements,devnr)) != 0) return cc;
          }
        }
        return 0;
    case PRP_MAXCYCLECNTS:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength == 1)
          {
            devnr = getSrvIdxFromDevNr(devnr);
            if ((cc=putValuesFromLong(dout,(SINT32 *)&g_maxcyclecnts,1)) != 0) return cc;
          }
          else
          {
            if (dout->dArrayLength > (UINT32)mcaCeiling) dout->dArrayLength = mcaCeiling;
            prepMca(multiStatArray,IDX_MAXCYCCNTS);
            if ((cc=PutValuesFromLongEx(dout,multiStatArray,nMcaElements,devnr)) != 0) return cc;
          }
        }
        return 0;
    case PRP_CYCLECNTS:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength == 1)
          {
            devnr = getSrvIdxFromDevNr(devnr);
            if ((cc=putValuesFromLong(dout,(SINT32 *)&g_cyclecnts,1)) != 0) return cc;
          }
          else
          {
            if (dout->dArrayLength > (UINT32)mcaCeiling) dout->dArrayLength = mcaCeiling;
            prepMca(multiStatArray,IDX_CYCCNTS);
            if ((cc=PutValuesFromLongEx(dout,multiStatArray,nMcaElements,devnr)) != 0) return cc;
          }
        }
        return 0;
    case PRP_REBOOTCNT:
        if (access&CA_WRITE) return illegal_read_write;
        if (srvList[devnr].status[IDX_REBOOTCNT] == -1) return not_posted;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength == 1)
          {
            devnr = getSrvIdxFromDevNr(devnr);
            if ((cc=putValuesFromLong(dout,(SINT32 *)&g_rebootcnt,1)) != 0) return cc;
          }
          else
          {
            if (dout->dArrayLength > (UINT32)mcaCeiling) dout->dArrayLength = mcaCeiling;
            prepMca(multiStatArray,IDX_REBOOTCNT);
            if ((cc=PutValuesFromLongEx(dout,multiStatArray,nMcaElements,devnr)) != 0) return cc;
          }
        }
        return 0;
    case PRP_BUSYTIME:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength == 1)
          {
            devnr = getSrvIdxFromDevNr(devnr);
            if ((cc=putValuesFromLong(dout,(SINT32 *)&g_busytime,1)) != 0) return cc;
          }
          else
          {
            if (dout->dArrayLength > (UINT32)mcaCeiling) dout->dArrayLength = mcaCeiling;
            prepMca(multiStatArray,IDX_BUSYTIME);
            if ((cc=PutValuesFromLongEx(dout,multiStatArray,nMcaElements,devnr)) != 0) return cc;
          }
        }
        return 0;
    case PRP_SRVSONFEC:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          return getServersOnFec(devName,dout);
        }
        return 0;
    case PRP_SRVFECPAIRS:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          return getSrvFecPairs(dout);
        }
        return 0;
    default:
        return illegal_property;
  }
}
