# variables with defaults can be overridden by environment variables
#   TINE_INCL
#   TINE_LIBS
#   TINE_ARCSRC

TINE_INCL ?= ../../../include
TINE_LIBS ?= ../../../lib
TINE_ARCSRC ?= ../../shared

HDRS = ${TINE_INCL}/project.def \
	${TINE_INCL}/prolog.h \
	${TINE_INCL}/srvcore.h \
	${TINE_INCL}/srvip.h \
	${TINE_INCL}/errors.h \
	${TINE_INCL}/tinetype.h \
	${TINE_INCL}/tinedefs.h \
	${TINE_INCL}/dbtools.h \
	${TINE_INCL}/swaplib.h \
	${TINE_INCL}/almlib.h

TINELIB = libtine.a

CC = cc -c -Aa -g -I. -I${TINE_INCL} -I${TINE_ARCSRC}
CCL = cc -g
LM = -lM -lrt

glbsrv: devsrv.o statebase.o mexeqm.o archbase.o archlib.o
	${CCL} -o glbsrv devsrv.o statebase.o mexeqm.o archbase.o archlib.o ${TINE_LIBS}/${TINELIB} ${LM}
	chmod a+x glbsrv

devsrv.o: devsrv.c app_version.h ${HDRS}
	${CC} devsrv.c

statebase.o: ${TINE_ARCSRC}/statebase.c ${TINE_ARCSRC}/archive.h ${HDRS}
	${CC} ${TINE_ARCSRC}/statebase.c 

mexeqm.o: ${TINE_ARCSRC}/mexeqm.c ${TINE_ARCSRC}/archive.h ${HDRS}
	${CC} ${TINE_ARCSRC}/mexeqm.c 

archbase.o: ${TINE_ARCSRC}/archbase.c ${TINE_ARCSRC}/archive.h ${HDRS}
	${CC} ${TINE_ARCSRC}/archbase.c 

archlib.o: ${TINE_ARCSRC}/archlib.c ${TINE_ARCSRC}/archive.h ${HDRS}
	${CC} ${TINE_ARCSRC}/archlib.c 

clean:
	rm -f *.o
