/*
 * msteqm.c    REVISION HISTORY:
 * Generated by SRVWIZARD on Mon Dec 18 15:39:21 2006
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "tine.h"
#include "msteqm.h"
#include "mstlib.h"

short g_statusBuffer[NUM_MSTEQM_DEVICES];
short g_onlineBuffer[NUM_MSTEQM_DEVICES];
double g_spmBuffer[NUM_MSTEQM_DEVICES];
double g_sprBuffer[NUM_MSTEQM_DEVICES];
UINT32 g_mspsBuffer[NUM_MSTEQM_DEVICES];
NAME16 g_unitsBuffer[NUM_MSTEQM_DEVICES];

double g_tgtPositionBuffer[NUM_MSTEQM_DEVICES];
UINT32 g_tgtMicroPositionBuffer[NUM_MSTEQM_DEVICES];
double g_positionBuffer[NUM_MSTEQM_DEVICES];
double g_PositionMaximumBuffer[NUM_MSTEQM_DEVICES];
double g_PositionMinimumBuffer[NUM_MSTEQM_DEVICES];
double g_PositionOffsetBuffer[NUM_MSTEQM_DEVICES];
double g_PositionScaleBuffer[NUM_MSTEQM_DEVICES];
short g_IncrementMoveIdleCondition;
short g_IncrementMoveProcessLevel;
short g_IncrementMoveNumProcessSteps = 5;
double g_limitsBuffer[NUM_MSTEQM_DEVICES][3];
short g_GroupMoveIdleCondition;
short g_GroupMoveProcessLevel;
short g_GroupMoveNumProcessSteps = 1;
short g_MoveToIdleCondition;
short g_MoveToProcessLevel;
short g_MoveToNumProcessSteps = 5;
double g_acceleration[NUM_MSTEQM_DEVICES];
double g_velocity[NUM_MSTEQM_DEVICES];
double g_current[NUM_MSTEQM_DEVICES];
double g_runcurrent;
UINT32 g_rotationmoveallowed[NUM_MSTEQM_DEVICES];
UINT32 g_stepcounter[NUM_MSTEQM_DEVICES];
UINT32 g_microstepcounter[NUM_MSTEQM_DEVICES];

int gNumMotors = 0;
NAME64 *gMotorNames = NULL;
char gMotorServerExportName[EXPORT_NAME_SIZE] = "MotorSteering";
char gMotorServerContext[CONTEXT_NAME_SIZE] = "TEST";
void loadMotorLib(void);

CSVCOLUMN csvMstGroupInfoConfigColumns[] =
{
  { "GROUP_NAME","Group",0,CF_TEXT,DEVICE_NAME_SIZE,(BYTE *)OFFSETIN(MstGroupInfoStruct,name),NULL,0 },
  { "MOTOR_NUMBER","",0,CF_INT32,1,(BYTE *)OFFSETIN(MstGroupInfoStruct,motorNr),NULL,0 },
  { "SCALE","1",0,CF_FLOAT,1,(BYTE *)OFFSETIN(MstGroupInfoStruct,scale),NULL,0 },
  { "OFFSET","1",0,CF_FLOAT,1,(BYTE *)OFFSETIN(MstGroupInfoStruct,offset),NULL,0 },
};
CSVDB csvMstGroupInfoConfigDb =
{
  csvMstGroupInfoConfigColumns,
  sizeof(csvMstGroupInfoConfigColumns)/sizeof(csvMstGroupInfoConfigColumns[0]),
  0,
  csvStdInit,
  csvStdIterator,
  csvStdExit,
  0,
  NULL,
  sizeof(MstGroupInfoStruct),
  0
};

MstGroupDevice *mstGroupTbl = NULL;
int mstGroupTblSize = 0;
extern char gMotorLib[256];
extern char gMstFecName[32];
extern int gMstFecPortOffset;

void PreSystemInit(void)
{
  char usrnam[32];
  char *usr = getenv("USERNAME");
  if (usr == NULL)
  {
    usr = "UNKNOWN";
  }
  strncpy(usrnam,usr,32);
  if (strlen(gMstFecName) > 0)
  { /* passed at the command line (so register FEC info here) */
    RegisterFecInformation(gMstFecName,"MST",gMotorServerContext,
      "Motor Steering server","","CDI",usrnam,(UINT16)gMstFecPortOffset);
  }
}

void PostSystemInit(void)
{
  registerStructs();
  RegisterEquipmentModule(gMotorServerExportName,MSTEQM_TAG,NUM_MSTEQM_DEVICES,msteqm,msteqm_ini,msteqm_bkg,MSTEQM_RATE,msteqm_exi);
  SetExportedContext(MSTEQM_TAG,gMotorServerContext);
  loadMotorLib();
}

double steps2mm(int motorNr,int nsteps)
{
  return g_spmBuffer[motorNr] > 0 ? (nsteps / g_spmBuffer[motorNr]) : 0;
}
int mm2steps(int motorNr,double mm)
{
  return (int)(g_spmBuffer[motorNr] * mm); 
}
void msteqm_bkg(void)
{
  int i,ival;

  ClearAlarm(MSTEQM_TAG,-1);

  for (i=0; i<NUM_MSTEQM_DEVICES; i++)
  {
    if (getMotorOnlineFcn != NULL) 
    {
      if (getMotorOnlineFcn(i,&ival) == 0) g_onlineBuffer[i] = ival;
    }
    if (g_onlineBuffer[i] == FALSE) continue;
    g_statusBuffer[i] = getMotorStatus(i);
    g_positionBuffer[i] = getMotorPosition(i);
    g_tgtMicroPositionBuffer[i] = getMotorTargetMicroPosition(i);
    g_tgtPositionBuffer[i] = getMotorTargetPosition(i);
  }

  /* make use of SetAlarm() as needed :

  SetAlarm(MSTEQM_TAG,devNr,almCode,almFlag);

  */
}
int RegisterMsteqmProperties(void)
{
  int cc = 0;
  short access;
  char desc[128];
  DTYPE dout,din;

  memset(&dout,0,sizeof(DTYPE)); memset(&din,0,sizeof(DTYPE));
  if (getMotorStepsPerMMFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_DOUBLE;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"MicroStepsPerMillimeter",&dout,&din,CA_READ,AT_CHANNEL,0,"Motor steps per millimeter",PRP_STEPS_PER_MM,"")) < 0) goto err;
  }
  if (getMotorStepsPerRadianFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_DOUBLE;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"MicroStepsPerRadian",&dout,&din,CA_READ,AT_CHANNEL,0,"Motor steps per radian",PRP_STEPS_PER_RADIAN,"")) < 0) goto err;
  }
  if (getMotorMicroStepsPerStepFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"MicroStepsPerStep",&dout,&din,CA_READ,AT_CHANNEL,0,"Motor micro steps per step",PRP_MICROSTEPS_PER_STEP,"")) < 0) goto err;
  }
  
  if (calibrateMotorFcn != NULL)
  {
    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    if (calibrateToOffsetFcn != NULL)
    {
      din.dArrayLength = 1;
      din.dFormat = CF_DOUBLE;
      sprintf(desc,"[%d:%d %.16s]calibrate motor to given offset",
        g_PositionMinimumBuffer[0],g_PositionMaximumBuffer[0],g_unitsBuffer[0].name);
    }
    else
    {
      din.dArrayLength = 0;
      din.dFormat = CF_NULL;
      strcpy(desc,"calibrate motor");
    }
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Calibrate",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,desc,PRP_CALIBRATE,"")) < 0) goto err;
  }  
  if (resetMotorFcn != NULL)
  {
    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Reset",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Reset Motor",PRP_RESET,"")) < 0) goto err;
  }
  if (getMotorPositionFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_DOUBLE;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    sprintf(desc,"[%d:%d %.16s]motor position",
      g_PositionMinimumBuffer[0],g_PositionMaximumBuffer[0],g_unitsBuffer[0].name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Position",&dout,&din,CA_READ,AT_CHANNEL,0,desc,PRP_POSITION,"")) < 0) goto err;
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_USTRING;
    sprintf(desc,"Motor position units");
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Position.EGU",&dout,&din,CA_READ,AT_CHANNEL,0,desc,PRP_POSITION_EGU,"")) < 0) goto err;
  }
  if (setIncrementMoveStatusFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementMove.STATUS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Status of Increment Move to target",PRP_INCR_MOVE_STATUS,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementMove.RESUME",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Resume Increment Move to target",PRP_INCR_MOVE_RESUME,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementMove.PAUSE",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Pause Increment Move to target",PRP_INCR_MOVE_PAUSE,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementMove.STOP",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Stop Increment Move to target",PRP_INCR_MOVE_STOP,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 1;
    din.dFormat = CF_DOUBLE;
    sprintf(desc,"[%d:%d %.16s]start Increment Move to target position",
      g_PositionMinimumBuffer[0],g_PositionMaximumBuffer[0],g_unitsBuffer[0].name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementMove.START",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,desc,PRP_INCR_MOVE_START,"")) < 0) goto err;
  }
  if (getMotorPositionMinimumFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_DOUBLE;
    sprintf(desc,"[%d:%d %.16s]motor position lower limit",
      g_PositionMinimumBuffer[0],g_PositionMaximumBuffer[0],g_unitsBuffer[0].name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"PositionMinimum",&dout,&din,CA_READ,AT_SCALAR,0,desc,PRP_LIMITS_POS_LWR,"")) < 0) goto err;
  }
  if (getMotorPositionMaximumFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_DOUBLE;
    sprintf(desc,"[%d:%d %.16s]motor position upper limit",
      g_PositionMinimumBuffer[0],g_PositionMaximumBuffer[0],g_unitsBuffer[0].name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"PositionMaximum",&dout,&din,CA_READ,AT_SCALAR,0,desc,PRP_LIMITS_POS_UPR,"")) < 0) goto err;
  }
  if (getMotorPositionOffsetFcn != NULL)
  {
    access = CA_READ;
    if (setMotorPositionOffsetFcn != NULL) access |= CA_WRITE;
    dout.dArrayLength = 1;
    dout.dFormat = CF_DOUBLE;
    sprintf(desc,"[%d:%d %.16s]motor position offset",
      g_PositionMinimumBuffer[0],g_PositionMaximumBuffer[0],g_unitsBuffer[0].name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"PositionOffset",&dout,&din,access,AT_SCALAR,0,desc,PRP_POSITION_OFFSET,"")) < 0) goto err;
  }
  if (getMotorPositionScaleFcn != NULL)
  {
    access = CA_READ;
    if (setMotorPositionScaleFcn != NULL) access |= CA_WRITE;
    dout.dArrayLength = 1;
    dout.dFormat = CF_DOUBLE;
    sprintf(desc,"[%d:%d %.16s]motor position scale",
      g_PositionMinimumBuffer[0],g_PositionMaximumBuffer[0],g_unitsBuffer[0].name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"PositionScale",&dout,&din,access,AT_SCALAR,0,desc,PRP_POSITION_SCALE,"")) < 0) goto err;
  }
  if (getMotorVelocityLowerLimitFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_LONG;
    din.dArrayLength = 1;
    din.dFormat = CF_LONG;
    sprintf(desc,"[0:100 %.16s/sec]motor velocity lower limit",g_unitsBuffer[0].name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"VeloctityMinimum",&dout,&din,CA_READ|CA_WRITE,AT_SCALAR,0,desc,PRP_LIMITS_VEL_LWR,"")) < 0) goto err;
  }
  if (getMotorVelocityUpperLimitFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_LONG;
    din.dArrayLength = 1;
    din.dFormat = CF_LONG;
    sprintf(desc,"[0:100 %.16s/sec]motor velocity upper limit",g_unitsBuffer[0].name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"VeloctityMaximum",&dout,&din,CA_READ|CA_WRITE,AT_SCALAR,0,desc,PRP_LIMITS_VEL_UPR,"")) < 0) goto err;
  }
  if (getMotorAccelerationUpperLimitFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_LONG;
    din.dArrayLength = 1;
    din.dFormat = CF_LONG;
    sprintf(desc,"[0:100 %.16s/sec^2]motor acceleration upper limit",g_unitsBuffer[0].name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"AccelerationMaximum",&dout,&din,CA_READ,AT_SCALAR,0,desc,PRP_LIMITS_ACC_UPR,"")) < 0) goto err;
  }
  if (setControlGroupMoveStatusFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ControlledGroupMove.STATUS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Status of Controlled Group Move",PRP_CTRL_GRP_MOVE_STATUS,"")) < 0) goto err;

    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ControlledGroupMove.PROGRESS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Progress (seconds remaining) of Controlled Group Move",PRP_CTRL_GRP_MOVE_PROGRESS,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ControlledGroupMove.RESUME",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Resume Controlled Group Move",PRP_CTRL_GRP_MOVE_RESUME,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ControlledGroupMove.PAUSE",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Pause Controlled Group Move",PRP_CTRL_GRP_MOVE_PAUSE,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ControlledGroupMove.STOP",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Stop Controlled Group Move",PRP_CTRL_GRP_MOVE_STOP,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ControlledGroupMove.START",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Start Controlled Group Move",PRP_CTRL_GRP_MOVE_START,"")) < 0) goto err;
  }
  if (setGroupMoveStatusFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"GroupMove.STATUS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Status of Group Move",PRP_GRP_MOVE_STATUS,"")) < 0) goto err;

    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"GroupMove.PROGRESS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Progress (seconds remaining) of Group Move",PRP_GRP_MOVE_PROGRESS,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"GroupMove.RESUME",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Resume Group Move",PRP_GRP_MOVE_RESUME,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"GroupMove.PAUSE",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Pause Group Move",PRP_GRP_MOVE_PAUSE,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"GroupMove.STOP",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Stop Group Move",PRP_GRP_MOVE_STOP,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"GroupMove.START",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Start Group Move",PRP_GRP_MOVE_START,"")) < 0) goto err;
  }
  if (setIncrementGroupMoveStatusFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementGroupMove.STATUS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Status of Group Move",PRP_INCR_GRP_MOVE_STATUS,"")) < 0) goto err;

    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementGroupMove.PROGRESS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Progress (seconds remaining) of Group Move",PRP_INCR_GRP_MOVE_PROGRESS,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementGroupMove.RESUME",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Resume Group Move",PRP_INCR_GRP_MOVE_RESUME,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementGroupMove.PAUSE",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Pause Group Move",PRP_INCR_GRP_MOVE_PAUSE,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementGroupMove.STOP",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Stop Group Move",PRP_INCR_GRP_MOVE_STOP,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementGroupMove.START",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Start Group Move",PRP_INCR_GRP_MOVE_START,"")) < 0) goto err;
  }
  if (setMoveToStatusFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Move.STATUS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Status of Move to target",PRP_MOVE_STATUS,"")) < 0) goto err;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"StepMove.STATUS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Status of Move to target",PRP_STEP_STATUS,"")) < 0) goto err;

    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Move.PROGRESS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Progress (seconds remaining) of Move to target",PRP_MOVE_PROGRESS,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Move.RESUME",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Resume Move to target",PRP_MOVE_RESUME,"")) < 0) goto err;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"StepMove.RESUME",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Resume Move to target",PRP_STEP_RESUME,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Move.PAUSE",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Pause Move to target",PRP_MOVE_PAUSE,"")) < 0) goto err;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"StepMove.PAUSE",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Pause Move to target",PRP_STEP_PAUSE,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Move.STOP",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Stop Move to target",PRP_MOVE_STOP,"")) < 0) goto err;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"StepMove.STOP",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Stop Move to target",PRP_STEP_STOP,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 1;
    din.dFormat = CF_DOUBLE;
    sprintf(desc,"[%d:%d %.16s]start Move to target position",
      g_PositionMinimumBuffer[0],g_PositionMaximumBuffer[0],g_unitsBuffer[0].name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Move.START",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,desc,PRP_MOVE_START,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 1;
    din.dFormat = CF_INT32;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"StepMove.START",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"[0:32767 steps]Start Move to target position (steps)",PRP_STEP_START,"")) < 0) goto err;
  }
  if (setScanMoveToStatusFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMove.STATUS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Status of Scan Move to target",PRP_SCANMOVE_STATUS,"")) < 0) goto err;

    dout.dArrayLength = 10000;
    dout.dFormat = CF_FLOAT;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMove.STATUS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Scan Status Arrays (as double array)",PRP_SCANMOVE_STATUS,"")) < 0) goto err;

    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMove.PROGRESS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Progress (seconds remaining) of Scan Move to target",PRP_SCANMOVE_PROGRESS,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMove.RESUME",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Resume Scan Move to target",PRP_SCANMOVE_RESUME,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMove.PAUSE",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Pause Scan Move to target",PRP_SCANMOVE_PAUSE,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMove.STOP",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Stop Scan Move to target",PRP_SCANMOVE_STOP,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 1;
    din.dFormat = CF_DOUBLE;
    sprintf(desc,"[%d:%d %.16s]start Scan move",
      g_PositionMinimumBuffer[0],g_PositionMaximumBuffer[0],g_unitsBuffer[0].name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMove.START",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,desc,PRP_SCANMOVE_START,"")) < 0) goto err;
  }
  if (setFreeMoveToStatusFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FreeMove.STATUS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Status of Free Move (no endswitch control) to target",PRP_FREE_MOVE_STATUS,"")) < 0) goto err;

    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FreeMove.PROGRESS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Progress (seconds remaining) of Free Move (no endswitch control) to target",PRP_FREE_MOVE_PROGRESS,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FreeMove.RESUME",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Resume Free Move (no endswitch control) to target",PRP_FREE_MOVE_RESUME,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FreeMove.PAUSE",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Pause Free Move (no endswitch control) to target",PRP_FREE_MOVE_PAUSE,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FreeMove.STOP",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Stop Free Move (no endswitch control) to target",PRP_FREE_MOVE_STOP,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 1;
    din.dFormat = CF_DOUBLE;
    sprintf(desc,"[%d:%d %.16s]start free move (no endswitch control) to target position",
      g_PositionMinimumBuffer[0],g_PositionMaximumBuffer[0],g_unitsBuffer[0].name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FreeMove.START",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,desc,PRP_FREE_MOVE_START,"")) < 0) goto err;
  }
  if (getMotorStatusFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Status",&dout,&din,CA_READ,AT_CHANNEL,0,"[0:1 ]Get Motor Status",PRP_STATUS,"")) < 0) goto err;
  }
  if (getMotorStatusBlockFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_STRUCT;
    strcpy(dout.dTag,"MotSts");
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"StatusInfo",&dout,&din,CA_READ,AT_CHANNEL,0,"[0:1 ]Get Motor Status Information (atomic structure)",PRP_STATUS_BLOCK,"")) < 0) goto err;
    memset(&dout,0,sizeof(DTYPE));
  }
  dout.dArrayLength = gNumMotors;
  dout.dFormat = CF_INT32;
  din.dArrayLength = 1;
  din.dFormat = CF_INT32;
  if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"OnLine",&dout,&din,CA_READ,AT_CHANNEL,0,"[0:1 ]Get/Set Motor On-Line Status",PRP_ONLINE,"")) < 0) goto err;
  if (getMotorTargetPositionFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_DOUBLE;
    access = CA_READ;
    if (setMotorTargetPositionFcn != NULL)
    {
      din.dArrayLength = 1;
      din.dFormat = CF_DOUBLE;
      access |= CA_WRITE;
    }
    else
    {
      din.dArrayLength = 0;
      din.dFormat = CF_NULL;
    }
    sprintf(desc,"[%d:%d %.16s]get/set Motor Target Position",
      g_PositionMinimumBuffer[0],g_PositionMaximumBuffer[0],g_unitsBuffer[0].name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"TargetPosition",&dout,&din,access,AT_CHANNEL,0,desc,PRP_TARGET_POSITION,"")) < 0) goto err;
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_USTRING;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    sprintf(desc,"Motor position units");
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"TargetPosition.EGU",&dout,&din,CA_READ,AT_CHANNEL,0,desc,PRP_TARGET_POSITION_EGU,"")) < 0) goto err;
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_INT32;
    access = CA_READ;
    if (setMotorTargetPositionFcn != NULL)
    {
      din.dArrayLength = 1;
      din.dFormat = CF_INT32;
      access |= CA_WRITE;
    }
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"TargetSteps",&dout,&din,access,AT_CHANNEL,0,"[0:32767 steps]get/set Motor Target Position in steps",PRP_TARGET_STEPS,"")) < 0) goto err;
  }
  if (getMotorTargetMicroPositionFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_INT32;
    access = CA_READ;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"TargetMicroPosition",&dout,&din,access,AT_CHANNEL,0,"[0:32767 microsteps]Get/Set Motor Target Position",PRP_TARGET_MICROSTEPS,"")) < 0) goto err;
  }
  if (getMotorAccelerationFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_DOUBLE;
    access = CA_READ;
    if (setMotorAccelerationFcn != NULL)
    {
      din.dArrayLength = 1;
      din.dFormat = CF_DOUBLE;
      access |= CA_WRITE;
    }
    else
    {
      din.dArrayLength = 0;
      din.dFormat = CF_NULL;
    }
    sprintf(desc,"[0:1 %.16s/sec^2]get/set Motor Acceleration",g_unitsBuffer[0].name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Acceleration",&dout,&din,access,AT_CHANNEL,0,desc,PRP_ACCELERATION,"")) < 0) goto err;
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_USTRING;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    sprintf(desc,"Motor Acceleration units");
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Acceleration.EGU",&dout,&din,CA_READ,AT_CHANNEL,0,desc,PRP_ACCELERATION_EGU,"")) < 0) goto err;
  }
  if (getMotorVelocityFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_DOUBLE;
    access = CA_READ;
    if (setMotorVelocityFcn != NULL)
    {
      din.dArrayLength = 1;
      din.dFormat = CF_DOUBLE;
      access |= CA_WRITE;
    }
    else
    {
      din.dArrayLength = 0;
      din.dFormat = CF_NULL;
    }
    sprintf(desc,"[0:100 %.16s/sec]get/set Motor Velocity",g_unitsBuffer[0].name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Velocity",&dout,&din,access,AT_CHANNEL,0,desc,PRP_VELOCITY,"")) < 0) goto err;
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_USTRING;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    sprintf(desc,"Motor Velocity units");
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Velocity.EGU",&dout,&din,CA_READ,AT_CHANNEL,0,desc,PRP_VELOCITY_EGU,"")) < 0) goto err;
  }
  if (getMotorCurrentFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_DOUBLE;
    access = CA_READ;
    if (setMotorCurrentFcn != NULL)
    {
      din.dArrayLength = 1;
      din.dFormat = CF_DOUBLE;
      access |= CA_WRITE;
    }
    else
    {
      din.dArrayLength = 0;
      din.dFormat = CF_NULL;
    }
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Current",&dout,&din,access,AT_CHANNEL,0,"[0:1 mA]Motor Current",PRP_CURRENT,"")) < 0) goto err;
  }
  dout.dArrayLength = gNumMotors;
  dout.dFormat = CF_LONG;
  din.dArrayLength = 1;
  din.dFormat = CF_LONG;
  if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"RotationMoveAllowed",&dout,&din,CA_READ|CA_WRITE,AT_CHANNEL,0,"[0:1 ]Linear Rotation Moves (end switc",PRP_ROTATIONMOVEALLOWED,"")) < 0) goto err;

  dout.dArrayLength = 0;
  dout.dFormat = CF_NULL;
  din.dArrayLength = 1;
  din.dFormat = CF_LONG;
  if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"MicroStep",&dout,&din,CA_READ|CA_WRITE,AT_CHANNEL,0,"[0:100 steps]Move Micro Step",PRP_MICROSTEP,"")) < 0) goto err;

  dout.dArrayLength = gNumMotors;
  dout.dFormat = CF_LONG;
  din.dArrayLength = 1;
  din.dFormat = CF_LONG;
  if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"StepCounter",&dout,&din,CA_READ|CA_WRITE,AT_CHANNEL,0,"[0:100 steps]Set/Read Step Counter",PRP_STEPCOUNTER,"")) < 0) goto err;

  dout.dArrayLength = gNumMotors;
  dout.dFormat = CF_LONG;
  din.dArrayLength = 1;
  din.dFormat = CF_LONG;
  if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"MicroStepCounter",&dout,&din,CA_READ|CA_WRITE,AT_CHANNEL,0,"[0:100 micro-steps]Set/Read Micro Step Counter",PRP_MICROSTEPCOUNTER,"")) < 0) goto err;

  dout.dArrayLength = 32;
  dout.dFormat = CF_NAME32;
  din.dArrayLength = 0;
  din.dFormat = CF_NULL;
  if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"StatusBits",&dout,&din,CA_READ,AT_UNKNOWN,0,"motor status bit definitions",PRP_STATUSBIT_LIST,"")) < 0) goto err;

err:
  if (cc < 0)
  {
    feclog("Can't register property : %s\n>",erlst[-cc]);
  }
  return cc;
}
void acquireStaticMotorInfo(int i)
{
  if (getMotorUnits(i,&g_unitsBuffer[i]) != 0) strcpy(g_unitsBuffer[i].name,"none");
  g_spmBuffer[i] = getStepsPerMM(i);
  g_sprBuffer[i] = getStepsPerRadian(i);
  g_mspsBuffer[i] =  getMicroStepsPerStep(i);
  g_statusBuffer[i] = getMotorStatus(i);
  // get limits 
  g_limitsBuffer[i][VEL_LWR_IDX] = getMotorVelocityLowerLimit(i);
  g_limitsBuffer[i][VEL_UPR_IDX] = getMotorVelocityUpperLimit(i);
  g_limitsBuffer[i][ACC_UPR_IDX] = getMotorAccelerationUpperLimit(i);
  // get current settings (velocity, acceleration, target, current positions)
  g_velocity[i] = getMotorVelocity(i);
  g_acceleration[i] = getMotorAcceleration(i);
  g_PositionMinimumBuffer[i] = getMotorPositionMinimum(i);
  g_PositionMaximumBuffer[i] = getMotorPositionMaximum(i);
  g_PositionOffsetBuffer[i] = getMotorPositionOffset(i);
  g_PositionScaleBuffer[i] = getMotorPositionScale(i);
}
void msteqm_ini(void)
{
  int i, k, p, n, cc;
  MstGroupInfoStruct *mstInfoTbl = NULL;

  if ((cc=initializeMotorHardware()) != 0)
  {
    feclog("error in initializing motor steering hardware : %s",erlst[cc]);
  }
  getMotorList(&gMotorNames,&gNumMotors);

  for (i=0; i<gNumMotors; i++)
  {
    if ((cc=RegisterDeviceName(MSTEQM_TAG,gMotorNames[i].name,i)) != 0) 
      feclog("cannot register device %s : %s",gMotorNames[i].name,erlst[cc]);
    acquireStaticMotorInfo(i);
    g_onlineBuffer[i] = TRUE; // is device on line ?
  }

  RegisterMsteqmProperties();

  if ((cc=csvReadFile(NULL,MST_GROUP_FILE,&csvMstGroupInfoConfigDb,(void **)&mstInfoTbl)) == 0) 
  { /* need to congifure group devices */
    feclog("motor group database found");
    n = csvMstGroupInfoConfigDb.siz;
    /* worst case allocation : */
    if ((mstGroupTbl=(MstGroupDevice *)calloc(n,sizeof(MstGroupDevice))) == NULL)
    { 
      feclog("cannot allocate group motor device table : aborting");
      exit(1);
    }
    for (i=0; i<n; i++)
    { /* scan thru and look for the defined groups */
      for (k=0; k<mstGroupTblSize; k++) if (strnicmp(mstGroupTbl[k].name,mstInfoTbl[i].name,DEVICE_NAME_SIZE) == 0) break;
      if (k == mstGroupTblSize)
      { /* new group */
        strncpy(mstGroupTbl[k].name,mstInfoTbl[i].name,DEVICE_NAME_SIZE);
        mstGroupTblSize++;
      }
      p = mstGroupTbl[k].numberInGroup;
      mstGroupTbl[k].members[p] = &mstInfoTbl[i];
      mstGroupTbl[k].numberInGroup++;
    }
    for (i=0; i<mstGroupTblSize; i++)
    {
      if ((cc=RegisterDeviceName(MSTEQM_TAG,mstGroupTbl[i].name,gNumMotors+i)) != 0) 
        feclog("cannot register motor group device %s : %s",mstGroupTbl[i].name,erlst[cc]);
    }
  }
  /* now fix the number of exported devices ... */
  AssignNumDevices(MSTEQM_TAG,gNumMotors+mstGroupTblSize);
}

void msteqm_exi(void)
{
  /* TODO: put your shutdown routines here */
}

int msteqm(char *devName,char *devProperty,DTYPE *dout, DTYPE *din,short access)
{
  int i,m,len,devnr,grpnr=-1,prpid,grpid=-1,cc;
  int isGroupedCall=FALSE, isGroupedDevice=FALSE;
  short sval;
  double dval, dvalArray[NUM_MSTEQM_DEVICES];
  UINT32 lval, lvalArray[NUM_MSTEQM_DEVICES];
  char grpdevs[1048],grpprp[PROPERTY_NAME_SIZE+8];
  char *g=NULL,*cp=NULL,*unitscat=NULL;
  int numInGroup=NUM_MOTORS_MAX;
  int motorsInGroup[NUM_MOTORS_MAX];

  devnr = GetDeviceNumberEx(MSTEQM_TAG,devName,devProperty);
  if (devnr < 0) 
  { /* possibly a group call ? */
    if ((cc=mstSplitGroupFromList(devName,&numInGroup,motorsInGroup)) != 0) return cc;
    grpid = mstGetMotorGroup(numInGroup,motorsInGroup);
    isGroupedCall = TRUE;
    devnr = motorsInGroup[0];
  }
  if (devnr < 0 && grpid < 0) 
  { /* definitely not valid */
    return illegal_device;
  }
  if (devnr >= gNumMotors) 
  { /* a registered motor group device */
    isGroupedDevice = TRUE;
    grpnr = devnr - gNumMotors;
    /* find a representative motor for 'status' calls */
    devnr = mstGroupTbl[grpnr].members[0]->motorNr - 1;
    /* prepare the group ... */
    grpdevs[0] = 0; 
    for (i=0; i<mstGroupTbl[grpnr].numberInGroup; i++)
    {
      motorsInGroup[i] = m = mstGroupTbl[grpnr].members[i]->motorNr - 1;
      len = DEVICE_NAME_SIZE;
      if (strlen(grpdevs) + len > 1048) return string_too_long;
      strncat(grpdevs,gMotorNames[m].name,len);
      if (i<mstGroupTbl[grpnr].numberInGroup-1) strcat(grpdevs,",");
    }
    grpid = mstGetMotorGroupFromList(grpdevs);
    numInGroup = mstGroupTbl[grpnr].numberInGroup;
    isGroupedCall = TRUE;
    if (strnicmp(devProperty,"Move.",5) == 0)
    { /* re-wire a simple "Move" command */
      strncpy(grpprp,devProperty,PROPERTY_NAME_SIZE);
      sprintf(devProperty,"Group%.32s",grpprp);
    }
    if (strnicmp(devProperty,"IncrementMove.",5) == 0)
    { /* re-wire a simple "Move" command */
      strncpy(grpprp,devProperty,PROPERTY_NAME_SIZE);
      sprintf(devProperty,"IncrementGroupMove%.32s",grpprp);
    }
  }
  prpid = GetPropertyId(MSTEQM_TAG,devProperty);

  switch (prpid)
  {
    case PRP_STEPS_PER_MM:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromDoubleEx(dout,g_spmBuffer,gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_STEPS_PER_RADIAN:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromDoubleEx(dout,g_sprBuffer,gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_MICROSTEPS_PER_STEP:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromLongEx(dout,g_mspsBuffer,gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_STATUS:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (isGroupedCall) dout->dArrayLength = 1;
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromShortEx(dout,g_statusBuffer,gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_STATUS_BLOCK:
        if (access&CA_WRITE) return illegal_read_write;
        if (isGroupedCall) return illegal_device;
        if (dout->dArrayLength > 0)
        {
          if (dout->dFormat != CF_STRUCT) return illegal_format;
          if (strcmp(dout->dTag,"MotSts")) return invalid_structure_tag;
          for (i=0,m=devnr; i<(int)dout->dArrayLength && m<gNumMotors; i++,m++)
          {
            cc = getMotorStatusBlockFcn(m,&((MotorStatus *)dout->data.vptr)[i]);
            if (cc != 0) return cc;
          }
          dout->dArrayLength = i;
        }
        return 0;
    case PRP_ONLINE:
        if (isGroupedCall) return illegal_device;
        if (isGroupedDevice) return illegal_device;
        if (access&CA_WRITE) 
        {
          if (din->dArrayLength > 0)
          {
            if ((cc=GetValuesAsShort(din,&sval,1)) != 0) return cc;
            if (setMotorOnlineFcn != NULL) setMotorOnlineFcn(devnr,sval);
            g_onlineBuffer[devnr] = sval;
            feclog("motor %s set to %s",devName,sval ? "on line" : "off line");
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromShortEx(dout,g_onlineBuffer,gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_CALIBRATE:
        if (isGroupedCall) return illegal_device;
        if (isGroupedDevice) return illegal_device;
        if (access&CA_WRITE)
        {
           if (din->dArrayLength > 0) 
           {
             if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
             if ((cc=calibrateToOffset(devnr,dval)) != 0) return cc;
           }
           else
           {
             if ((cc=calibrateMotor(devnr)) != 0) return cc;
             dval = 0;
           }
           g_stepcounter[devnr] = mm2steps(devnr,dval);
           g_microstepcounter[devnr] = g_stepcounter[devnr]*g_mspsBuffer[devnr];
           g_tgtPositionBuffer[devnr] = dval;
           g_tgtMicroPositionBuffer[devnr] = g_microstepcounter[devnr];
           feclog("motor %s has been reset",devName);
        }
        return 0;

    case PRP_RESET:
        if (isGroupedCall) return illegal_device;
        if (isGroupedDevice) return illegal_device;
        if (access&CA_WRITE)
        {
           if (din->dArrayLength > 0) return illegal_read_write;
           if ((cc=resetMotor(devnr)) != 0) return cc;
           g_stepcounter[devnr] = g_microstepcounter[devnr] = 0;
           feclog("motor %s has been reset",devName);
        }
        return 0;
    case PRP_TARGET_POSITION:
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if ((cc=GetValuesAsDouble(din,dvalArray,NUM_MSTEQM_DEVICES)) != 0) return cc;
            if (isGroupedDevice)
            { /* passed as a registered motor device group: target applies to all member of the group */
              if (din->dArrayLength != 1) return dimension_error;
              dval = dvalArray[0];
              for (i=0; i<mstGroupTbl[grpnr].numberInGroup; i++)
              {
                dvalArray[i] = dval * mstGroupTbl[grpnr].members[i]->scale + mstGroupTbl[grpnr].members[i]->offset;
                m = mstGroupTbl[grpnr].members[i]->motorNr - 1;
                if ((cc=setMotorTargetPosition(m,dvalArray[i])) != 0) return cc;
                g_tgtPositionBuffer[m] = dvalArray[i];
              }
            }
            else if (isGroupedCall)
            { /* passed as a sequence of motors */
              if (din->dArrayLength != (UINT32)numInGroup) return dimension_error;
              for (i=0; i<numInGroup; i++)
              {
                m = motorsInGroup[i];
                if ((cc=setMotorTargetPosition(m,dvalArray[i])) != 0) return cc;
                g_tgtPositionBuffer[m] = dvalArray[i];
              }
            }
            else
            { /* normal: not a motor device group ! */
              for (i=0; i<(int)din->dArrayLength; i++)
              {
                if (devnr + i >= gNumMotors) continue;
                if ((cc=setMotorTargetPosition(devnr+i,dvalArray[i])) != 0) return cc;
                g_tgtPositionBuffer[devnr+i] = dvalArray[i];
              }
            }
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if (isGroupedDevice) 
          { /* cut to the chase */
            dout->dArrayLength = 1;
          }
          else if (isGroupedCall)
          { /* return them in the order specified */
            if (dout->dArrayLength != (UINT32)numInGroup) return dimension_error;
            for (i=0; i<numInGroup; i++) 
            {
              m = motorsInGroup[i];
              dvalArray[i] = g_tgtPositionBuffer[m];
              return PutValuesFromDoubleEx(dout,dvalArray,numInGroup,0);
            }
          }
          if ((cc=PutValuesFromDoubleEx(dout,g_tgtPositionBuffer,gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_TARGET_STEPS:
        if (isGroupedCall) return illegal_device;
        if (isGroupedDevice) return illegal_device;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if ((cc=GetValuesAsLong(din,&lval,1)) != 0) return cc;
            dval = steps2mm(devnr,lval);
            if ((cc=setMotorTargetPosition(devnr,dval)) != 0) return cc;
            g_tgtPositionBuffer[devnr] = dval;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          for (i=0; i<gNumMotors; i++) lvalArray[i] = (UINT32)mm2steps(devnr,g_tgtPositionBuffer[i]);
          if ((cc=PutValuesFromDoubleEx(dout,g_tgtPositionBuffer,gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_TARGET_MICROSTEPS:
        if (isGroupedCall) return illegal_device;
        if (isGroupedDevice) return illegal_device;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if ((cc=GetValuesAsLong(din,&lval,1)) != 0) return cc;
            if ((cc=setMotorTargetMicroPosition(devnr,lval)) != 0) return cc;
            g_tgtMicroPositionBuffer[devnr] = lval;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromLongEx(dout,g_tgtMicroPositionBuffer,gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_POSITION:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (isGroupedDevice) 
          { /* cut to the chase */
            dout->dArrayLength = 1;
          }
          else if (isGroupedCall)
          { /* return them in the order specified */
            if (dout->dArrayLength != (UINT32)numInGroup) return dimension_error;
            for (i=0; i<numInGroup; i++) 
            {
              m = motorsInGroup[i];
              dvalArray[i] = g_positionBuffer[m];
              return PutValuesFromDoubleEx(dout,dvalArray,numInGroup,0);
            }
          }
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromDoubleEx(dout,g_positionBuffer,gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_VELOCITY_EGU: unitscat = "/sec";
    case PRP_ACCELERATION_EGU: if (unitscat == NULL) unitscat = "/sec^2";
    case PRP_MOVE_START_EGU:
    case PRP_INCR_MOVE_START_EGU:
    case PRP_FREE_MOVE_START_EGU:
    case PRP_LIMITS_VEL_LWR_EGU:
    case PRP_LIMITS_VEL_UPR_EGU:
    case PRP_LIMITS_ACC_UPR_EGU:
    case PRP_POSITION_EGU:
    case PRP_TARGET_POSITION_EGU:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          int nlen;
          if (dout->dArrayLength > (UINT32)(devnr + gNumMotors)) dout->dArrayLength = (UINT32)(devnr + gNumMotors);
          switch (dout->dFormat)
          {
            case CF_USTRING:
              for (i=0; i<(int)dout->dArrayLength; i++)
              {
                strncpy(((DUSTRING *)dout->data.vptr)[i].str,g_unitsBuffer[devnr+i].name,16);
                if (unitscat != NULL) strncat(((DUSTRING *)dout->data.vptr)[i].str,unitscat,6);
                ((DUSTRING *)dout->data.vptr)[i].f1val = (float)g_PositionMinimumBuffer[devnr+1];
                ((DUSTRING *)dout->data.vptr)[i].f2val = (float)g_PositionMaximumBuffer[devnr+1];
              }
              break;
            case CF_NAME16:
            case CF_NAME32:
            case CF_NAME48:
            case CF_NAME64:
              nlen = fmtsizeof(dout->dFormat);
              for (i=0; i<(int)dout->dArrayLength; i++)
              {
                strncpy(dout->data.cptr+i*nlen,g_unitsBuffer[devnr+i].name,10);
                if (unitscat != NULL) strncat(dout->data.cptr+i*nlen,unitscat,6);
              }
              break;
            default:
              return illegal_format;
          }
        }
        return 0;
    case PRP_INCR_MOVE_STATUS:
        if (isGroupedCall) return illegal_device;
        if (getIncrementMoveStatusFcn == NULL) return not_implemented;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=getIncrementMoveStatusFcn(devnr,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_INCR_MOVE_RESUME:
        if (isGroupedCall) return illegal_device;
        if (setIncrementMoveStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setIncrementMoveStatusFcn(devnr,PROC_STS_RESUME);
        }
        return cc;
    case PRP_INCR_MOVE_PAUSE:
        if (isGroupedCall) return illegal_device;
        if (setIncrementMoveStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setIncrementMoveStatusFcn(devnr,PROC_STS_PAUSE);
        }
        return cc;
    case PRP_INCR_MOVE_STOP:
        if (isGroupedCall) return illegal_device;
        if (setIncrementMoveStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setIncrementMoveStatusFcn(devnr,PROC_STS_STOP);
        }
        return cc;
    case PRP_INCR_MOVE_START:
        if (isGroupedCall) return illegal_device;
        if (setIncrementMoveStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
            dval += g_tgtPositionBuffer[devnr];
            if ((cc=setMotorTargetPosition(devnr,dval)) != 0) return cc;
            g_tgtPositionBuffer[devnr] = dval;
            //millisleep(100);
          }
          cc = setIncrementMoveStatusFcn(devnr,PROC_STS_START);
        }
        return cc;
    case PRP_LIMITS_VEL_LWR:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=PutValuesFromDouble(dout,&g_limitsBuffer[devnr][VEL_LWR_IDX],1)) != 0) return cc;
        }
        return 0;
    case PRP_LIMITS_VEL_UPR:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=PutValuesFromDouble(dout,&g_limitsBuffer[devnr][VEL_UPR_IDX],1)) != 0) return cc;
        }
        return 0;
    case PRP_LIMITS_ACC_UPR:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=PutValuesFromDouble(dout,&g_limitsBuffer[devnr][ACC_UPR_IDX],1)) != 0) return cc;
        }
        return 0;
    case PRP_GRP_MOVE_STATUS:
        if (getGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) 
        { /* a single device passed as group ? */
          grpid = mstGetMotorGroupFromList(devName);
        }
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=getGroupMoveStatusFcn(grpid,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_GRP_MOVE_PROGRESS:
        if (getGroupMoveProgressFcn == NULL) return not_implemented;
        if (!isGroupedCall) 
        { /* a single device passed as group ? */
          grpid = mstGetMotorGroupFromList(devName);
        }
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=getGroupMoveProgressFcn(grpid,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_GRP_MOVE_RESUME:
        if (setGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) 
        { /* a single device passed as group ? */
          grpid = mstGetMotorGroupFromList(devName);
        }
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setGroupMoveStatusFcn(grpid,PROC_STS_RESUME);
        }
        return cc;
    case PRP_GRP_MOVE_PAUSE:
        if (setGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) 
        { /* a single device passed as group ? */
          grpid = mstGetMotorGroupFromList(devName);
        }
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setGroupMoveStatusFcn(grpid,PROC_STS_PAUSE);
        }
        return cc;
    case PRP_GRP_MOVE_STOP:
        if (setGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) 
        { /* a single device passed as group ? */
          grpid = mstGetMotorGroupFromList(devName);
        }
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setGroupMoveStatusFcn(grpid,PROC_STS_STOP);
        }
        return cc;
    case PRP_GRP_MOVE_START:
        if (setGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) 
        { /* a single device passed as group ? */
          grpid = mstGetMotorGroupFromList(devName);
        }
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          { 
            if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
            if ((cc=setGroupMotorTargetPosition(grpid,dval)) != 0) return cc;
          }
          cc = setGroupMoveStatusFcn(grpid,PROC_STS_START);
        }
        return cc;
    
    case PRP_INCR_GRP_MOVE_STATUS:
        if (getGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) 
        { /* a single device passed as group ? */
          grpid = mstGetMotorGroupFromList(devName);
        }
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=getGroupMoveStatusFcn(grpid,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_INCR_GRP_MOVE_PROGRESS:
        if (getIncrementGroupMoveProgressFcn == NULL) return not_implemented;
        if (!isGroupedCall) 
        { /* a single device passed as group ? */
          grpid = mstGetMotorGroupFromList(devName);
        }
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=getIncrementGroupMoveProgressFcn(grpid,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_INCR_GRP_MOVE_RESUME:
        if (setIncrementGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) 
        { /* a single device passed as group ? */
          grpid = mstGetMotorGroupFromList(devName);
        }
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setIncrementGroupMoveStatusFcn(grpid,PROC_STS_RESUME);
        }
        return cc;
    case PRP_INCR_GRP_MOVE_PAUSE:
        if (setIncrementGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) 
        { /* a single device passed as group ? */
          grpid = mstGetMotorGroupFromList(devName);
        }
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setIncrementGroupMoveStatusFcn(grpid,PROC_STS_PAUSE);
        }
        return cc;
    case PRP_INCR_GRP_MOVE_STOP:
        if (setIncrementGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) 
        { /* a single device passed as group ? */
          grpid = mstGetMotorGroupFromList(devName);
        }
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setIncrementGroupMoveStatusFcn(grpid,PROC_STS_STOP);
        }
        return cc;
    case PRP_INCR_GRP_MOVE_START:
        if (setIncrementGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) 
        { /* a single device passed as group ? */
          grpid = mstGetMotorGroupFromList(devName);
        }
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setIncrementGroupMoveStatusFcn(grpid,PROC_STS_START);
        }
        return cc;

    case PRP_MOVE_STATUS:
    case PRP_FREE_MOVE_STATUS:
        if (isGroupedCall) return illegal_device;
        if (getMoveToStatusFcn == NULL) return not_implemented;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=getMoveToStatusFcn(devnr,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_FREE_MOVE_PROGRESS:
    case PRP_MOVE_PROGRESS:
        if (isGroupedCall) return illegal_device;
        if (getMoveToProgressFcn == NULL) return not_implemented;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=getMoveToProgressFcn(devnr,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_MOVE_RESUME:
        if (isGroupedCall) return illegal_device;
        if (setMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setMoveToStatusFcn(devnr,PROC_STS_RESUME);
        }
        return cc;
    case PRP_MOVE_PAUSE:
        if (isGroupedCall) return illegal_device;
        if (setMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setMoveToStatusFcn(devnr,PROC_STS_PAUSE);
        }
        return cc;
    case PRP_MOVE_STOP:
        if (isGroupedCall) return illegal_device;
        if (setMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setMoveToStatusFcn(devnr,PROC_STS_STOP);
        }
        return cc;
    case PRP_MOVE_START:
        if (isGroupedCall) return illegal_device;
        if (setMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
            if ((cc=setMotorTargetPosition(devnr,dval)) != 0) return cc;
            g_tgtPositionBuffer[devnr] = dval;
          }
          cc = setMoveToStatusFcn(devnr,PROC_STS_START);
        }
        return cc;
    case PRP_FREE_MOVE_RESUME:
        if (isGroupedCall) return illegal_device;
        if (setFreeMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setFreeMoveToStatusFcn(devnr,PROC_STS_RESUME);
        }
        return cc;
    case PRP_FREE_MOVE_PAUSE:
        if (isGroupedCall) return illegal_device;
        if (setFreeMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setFreeMoveToStatusFcn(devnr,PROC_STS_PAUSE);
        }
        return cc;
    case PRP_FREE_MOVE_STOP:
        if (isGroupedCall) return illegal_device;
        if (setFreeMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setFreeMoveToStatusFcn(devnr,PROC_STS_STOP);
        }
        return cc;
    case PRP_FREE_MOVE_START:
        if (isGroupedCall) return illegal_device;
        if (setFreeMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
            if ((cc=setMotorTargetPosition(devnr,dval)) != 0) return cc;
            g_tgtPositionBuffer[devnr] = dval;
          }
          cc = setFreeMoveToStatusFcn(devnr,PROC_STS_START);
        }
        return cc;
    case PRP_STEP_START:
        if (isGroupedCall) return illegal_device;
        if (setMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if ((cc=GetValuesAsLong(din,&lval,1)) != 0) return cc;
            dval = steps2mm(devnr,lval);
            if ((cc=setMotorTargetPosition(devnr,dval)) != 0) return cc;
            g_tgtPositionBuffer[devnr] = dval;
          }
          cc = setMoveToStatusFcn(devnr,PROC_STS_START);
        }
        return cc;
    case PRP_CTRL_GRP_MOVE_STATUS:
        if (getControlGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) 
        { /* a single device passed as group ? */
          grpid = mstGetMotorGroupFromList(devName);
        }
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=getControlGroupMoveStatusFcn(grpid,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_CTRL_GRP_MOVE_PROGRESS:
        if (getControlGroupMoveProgressFcn == NULL) return not_implemented;
        if (!isGroupedCall) 
        { /* a single device passed as group ? */
          grpid = mstGetMotorGroupFromList(devName);
        }
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=getControlGroupMoveProgressFcn(grpid,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_CTRL_GRP_MOVE_RESUME:
        if (setControlGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) 
        { /* a single device passed as group ? */
          grpid = mstGetMotorGroupFromList(devName);
        }
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setControlGroupMoveStatusFcn(grpid,PROC_STS_RESUME);
        }
        return cc;
    case PRP_CTRL_GRP_MOVE_PAUSE:
        if (setControlGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) 
        { /* a single device passed as group ? */
          grpid = mstGetMotorGroupFromList(devName);
        }
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setControlGroupMoveStatusFcn(grpid,PROC_STS_PAUSE);
        }
        return cc;
    case PRP_CTRL_GRP_MOVE_STOP:
        if (setControlGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) 
        { /* a single device passed as group ? */
          grpid = mstGetMotorGroupFromList(devName);
        }
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setControlGroupMoveStatusFcn(grpid,PROC_STS_STOP);
        }
        return cc;
    case PRP_CTRL_GRP_MOVE_START:
        if (setControlGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) 
        { /* a single device passed as group ? */
          grpid = mstGetMotorGroupFromList(devName);
        }
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setControlGroupMoveStatusFcn(grpid,PROC_STS_START);
        }
        return cc;    
    case PRP_SCANMOVE_STATUS:
        if (getScanMoveToStatusFcn == NULL) return not_implemented;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (isGroupedCall) 
          {
            if (getScanGroupMoveToStatusFcn == NULL) return not_implemented;
            cc = getScanGroupMoveToStatusFcn(grpid,dout);
          }
          else
          {
            if ((cc=getScanMoveToStatusFcn(devnr,dout)) != 0) return cc;
          }
        }
        return 0;
    case PRP_SCANMOVE_PAUSE:
        if (setScanMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          if (isGroupedCall) 
          {
            if (setScanGroupMoveToStatusFcn == NULL) return not_implemented;
            cc = setScanGroupMoveToStatusFcn(grpid,PROC_STS_PAUSE,NULL);
          }
          else
          {
            cc = setScanMoveToStatusFcn(devnr,PROC_STS_PAUSE,NULL);
          }
        }
        return cc;
    case PRP_SCANMOVE_PROGRESS:
        if (getScanMoveToProgressFcn == NULL) return not_implemented;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=getScanMoveToProgressFcn(devnr,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_SCANMOVE_RESUME:
        //if (isGroupedCall) return illegal_device;
        if (setScanMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          if (isGroupedCall) 
          {
            if (setScanGroupMoveToStatusFcn == NULL) return not_implemented;
            cc = setScanGroupMoveToStatusFcn(grpid,PROC_STS_RESUME,din);
          }
          else
          {
            cc = setScanMoveToStatusFcn(devnr,PROC_STS_RESUME,din);
          }
        }
        return cc;
    case PRP_SCANMOVE_STOP:
        if (setScanMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          if (isGroupedCall) 
          {
            if (setScanGroupMoveToStatusFcn == NULL) return not_implemented;
            cc = setScanGroupMoveToStatusFcn(grpid,PROC_STS_STOP,NULL);
          }
          else
          {
            cc = setScanMoveToStatusFcn(devnr,PROC_STS_STOP,NULL);
          }
        }
        return cc;
    case PRP_SCANMOVE_START:
        if (setScanMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          if (isGroupedCall) 
          {
            if (setScanGroupMoveToStatusFcn == NULL) return not_implemented;
            cc = setScanGroupMoveToStatusFcn(grpid,PROC_STS_START,din);
          }
          else
          {
            cc = setScanMoveToStatusFcn(devnr,PROC_STS_START,din);
          }
        }
        return cc;    
    case PRP_ACCELERATION:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength > 1) return dimension_error;
            if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
            if (dval > g_limitsBuffer[devnr][ACC_UPR_IDX]) return out_of_range;
            if (dval < 0) return out_of_range;
            cc = setMotorAcceleration(devnr,dval);
            if (cc == 0) g_acceleration[devnr] = dval; else return cc;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromDouble(dout,&g_acceleration[devnr],gNumMotors)) != 0) return cc;
        }
        return 0;
    case PRP_VELOCITY:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength > 1) return dimension_error;
            if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
            if (dval > g_limitsBuffer[devnr][VEL_UPR_IDX]) return out_of_range;
            if (dval < g_limitsBuffer[devnr][VEL_LWR_IDX]) return out_of_range;
            cc = setMotorVelocity(devnr,dval);
            if (cc == 0) g_velocity[devnr] = dval; else return cc;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromDouble(dout,&g_velocity[devnr],gNumMotors)) != 0) return cc;
        }
        return 0;
    case PRP_CURRENT:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength > 1) return dimension_error;
            if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
            if ((cc=setMotorCurrent(devnr,dval)) != 0) return cc;
            g_current[devnr] = dval;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromDouble(dout,&g_current[devnr],gNumMotors)) != 0) return cc;
        }
        return 0;
    case PRP_ROTATIONMOVEALLOWED:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength > 1) return dimension_error;
            if ((cc=GetValuesAsLong(din,&lval,1)) != 0) return cc;
            g_rotationmoveallowed[devnr] = lval;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromLong(dout,g_rotationmoveallowed,gNumMotors)) != 0) return cc;
        }
        return 0;
    case PRP_MICROSTEP:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE)
        {
          if (setMicroMoveStatusFcn == NULL) return not_implemented;
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength > 1) return dimension_error;
            if ((cc=GetValuesAsLong(din,&lval,1)) != 0) return cc;
            if (lval > PRP_MICROSTEP_UPR_LIMIT) return out_of_range;
            if (lval < PRP_MICROSTEP_LWR_LIMIT) return out_of_range;
            if ((cc=setMotorTargetMicroPosition(devnr,lval)) != 0) return cc;
          }
          else
          {
            lval = g_tgtMicroPositionBuffer[devnr] + 1;
          }
          if ((cc=setMotorTargetMicroPosition(devnr,lval)) != 0) return cc;
          g_tgtMicroPositionBuffer[devnr] = lval;
          if ((cc=setMicroMoveStatusFcn(devnr,PROC_STS_START)) != 0) return cc;
        }
        return 0;
    case PRP_MICROSTEPCOUNTER:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength > 1) return dimension_error;
            if ((cc=GetValuesAsLong(din,&lval,1)) != 0) return cc;
            if (lval > PRP_STEPCOUNTER_UPR_LIMIT) return out_of_range;
            if (lval < PRP_STEPCOUNTER_LWR_LIMIT) return out_of_range;
            g_microstepcounter[devnr] = lval;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromLong(dout,g_microstepcounter,gNumMotors)) != 0) return cc;
        }
        return 0;
    case PRP_STEPCOUNTER:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength > 1) return dimension_error;
            if ((cc=GetValuesAsLong(din,&lval,1)) != 0) return cc;
            if (lval > PRP_STEPCOUNTER_UPR_LIMIT) return out_of_range;
            if (lval < PRP_STEPCOUNTER_LWR_LIMIT) return out_of_range;
            g_stepcounter[devnr] = lval;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromLong(dout,g_stepcounter,gNumMotors)) != 0) return cc;
        }
        return 0;
    case PRP_STATUSBIT_LIST:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if ((cc=PutValuesFromString(dout,(char *)mstStsList,CF_NAME32,sizMstStsList,0)) != 0) return cc;
        }
        return 0;
    case PRP_LIMITS_POS_LWR:
        if (access&CA_WRITE) return illegal_read_write;
        if (isGroupedCall) return illegal_device;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromDoubleEx(dout,g_PositionMinimumBuffer,gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_LIMITS_POS_UPR:
        if (access&CA_WRITE) return illegal_read_write;
        if (isGroupedCall) return illegal_device;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromDoubleEx(dout,g_PositionMaximumBuffer,gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_POSITION_OFFSET:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE) 
        {
          if (setMotorPositionOffsetFcn == NULL) return illegal_read_write;
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength != 1) return dimension_error;
            if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
            if ((cc=setMotorPositionOffset(devnr,dval)) != 0) return cc;
            acquireStaticMotorInfo(devnr);
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromDoubleEx(dout,g_PositionOffsetBuffer,gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_POSITION_SCALE:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE) 
        {
          if (setMotorPositionScaleFcn == NULL) return illegal_read_write;
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength != 1) return dimension_error;
            if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
            if ((cc=setMotorPositionScale(devnr,dval)) != 0) return cc;
            acquireStaticMotorInfo(devnr);
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromDoubleEx(dout,g_PositionScaleBuffer,gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    default:
        return illegal_property;
  }
}
