/*
 * msteqm.c    REVISION HISTORY:
 * Generated by SRVWIZARD on Mon Dec 18 15:39:21 2006
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#ifdef WIN32
# include "direct.h"
char *delStr = "\\";
#else
# include "dirent.h"
char *delStr = "/";
#endif
#include "tine.h"
#include "msteqm.h"
#include "mstlib.h"

Motor mstTbl[NUM_MSTEQM_DEVICES];

short g_IncrementMoveIdleCondition;
short g_IncrementMoveProcessLevel;
short g_IncrementMoveNumProcessSteps = 5;
short g_GroupMoveIdleCondition;
short g_GroupMoveProcessLevel;
short g_GroupMoveNumProcessSteps = 1;
short g_MoveToIdleCondition;
short g_MoveToProcessLevel;
short g_MoveToNumProcessSteps = 5;
double g_runcurrent;

int motorServerInitialized = FALSE;
int gNumMotors = 0;
NAME64 *gMotorNames = NULL;
char gMotorServerExportName[EXPORT_NAME_SIZE] = "MotorSteering";
char gMotorServerContext[CONTEXT_NAME_SIZE] = "TEST";
char gMotorServerGroup[EXPORT_NAME_SIZE] = "";
int gMotorGroupMetric = 0;
void loadMotorLib(void);
void initializedMotorServer(void);

CSVCOLUMN csvMstMonitorInfoConfigColumns[] =
{
  { "MOTOR_NAME","",0,CF_TEXT,DEVICE_NAME_SIZE,(BYTE *)OFFSETIN(MonitorInfo,nam),NULL,0 },
  { "MONITOR_DEVICE","",0,CF_TEXT,132,(BYTE *)OFFSETIN(MonitorInfo,dev),NULL,0 },
  { "MONITOR_PROPERTY","",0,CF_TEXT,PROPERTY_NAME_SIZE,(BYTE *)OFFSETIN(MonitorInfo,prp),NULL,0 },
  { "MONITOR_FORMAT","float",0,CF_TEXT,16,(BYTE *)OFFSETIN(MonitorInfo,fmt),NULL,0 },
  { "MONITOR_SIZE","1",0,CF_INT32,1,(BYTE *)OFFSETIN(MonitorInfo,len),NULL,0 },
  { "MONITOR_TIMER","1000",0,CF_INT32,1,(BYTE *)OFFSETIN(MonitorInfo,tmr),NULL,0 },
  { "STEP_DELAY","100",0,CF_INT32,1,(BYTE *)OFFSETIN(MonitorInfo,dly),NULL,0 },
  { "STEP_INCREMENT","1000",0,CF_INT32,1,(BYTE *)OFFSETIN(MonitorInfo,inc),NULL,0 },
};
CSVDB csvMstMonitorInfoConfigDb =
{
  csvMstMonitorInfoConfigColumns,
  sizeof(csvMstMonitorInfoConfigColumns)/sizeof(csvMstMonitorInfoConfigColumns[0]),
  0,
  csvStdInit,
  csvStdIterator,
  csvStdExit,
  0,
  NULL,
  sizeof(MonitorInfo),
  0
};

CSVCOLUMN csvMstGroupInfoConfigColumns[] =
{
  { "GROUP_NAME","Group",0,CF_TEXT,DEVICE_NAME_SIZE,(BYTE *)OFFSETIN(MstGroupInfoStruct,name),NULL,0 },
  { "GROUP_ID","-1",0,CF_INT32,1,(BYTE *)OFFSETIN(MstGroupInfoStruct,groupId),NULL,0 },
  { "MOTOR_NUMBER","",0,CF_INT32,1,(BYTE *)OFFSETIN(MstGroupInfoStruct,motorNr),NULL,0 },
  { "GEAR_RATIO","1",0,CF_FLOAT,1,(BYTE *)OFFSETIN(MstGroupInfoStruct,gearRatio),NULL,0 },
  { "SCALE","1",0,CF_FLOAT,1,(BYTE *)OFFSETIN(MstGroupInfoStruct,scale),NULL,0 },
  { "OFFSET","1",0,CF_FLOAT,1,(BYTE *)OFFSETIN(MstGroupInfoStruct,offset),NULL,0 },
  { "WEIGHT","1",0,CF_FLOAT,1,(BYTE *)OFFSETIN(MstGroupInfoStruct,weight),NULL,0 },
};
CSVDB csvMstGroupInfoConfigDb =
{
  csvMstGroupInfoConfigColumns,
  sizeof(csvMstGroupInfoConfigColumns)/sizeof(csvMstGroupInfoConfigColumns[0]),
  0,
  csvStdInit,
  csvStdIterator,
  csvStdExit,
  0,
  NULL,
  sizeof(MstGroupInfoStruct),
  0
};

MstGroupDevice *mstGroupTbl = NULL;
int mstGroupTblSize = 0;
extern char gMotorLib[256];
extern char gMstFecName[32];
extern int gMstFecPortOffset;
extern int gIsSmarPod;
float *scanbuffer = NULL;
char scanFilesPath[256] = "../SCANFILES";
int makeDirPath(char *fname)
{
# if defined(UNIX)
  DIR *dp;
# elif defined(WIN32)
  char fn[256];
  struct _finddata_t fp;
# endif
  char *c,tmpname[256],dirname[256];

  strncpy(tmpname,fname,256); dirname[0] = 0;
  for (c=strtok(tmpname,delStr); c != NULL; c=strtok(NULL,delStr))
  {
    strcat(dirname,c);
    if (!strncmp(dirname,fname,256)) /* okay the directory should be there */
    {
      return 0;
    }
    strcat(dirname,delStr);
#   if defined(UNIX)
    if ((dp=opendir(dirname)) != NULL) 
    {
      closedir(dp);
    }
    else
    {
      if (mkdir(dirname,S_IWUSR|S_IRUSR|S_IXUSR|S_IWGRP|S_IRGRP|S_IXGRP|S_IROTH|S_IXOTH)) return 0;
    }
#   elif defined(WIN32)
    sprintf(fn,"%s*.*",dirname);
    if (_findfirst(fn, &fp) == -1)
    {
      if (mkdir(dirname)) return 0;
    }
#   endif
  }
  return -1;
}
int saveScanFileDataEx(const char *fn,MonitorScan *ms)
{
  FILE *fp=NULL;
  int i, k, len, cc = 0;
  char *c, *fnp, filename[512];
  MonitorParams *mp = NULL;

  if (ms == NULL || fn == NULL) ccerr(invalid_parameter);
  if ((len=ms->length) == 0) ccerr(dimension_error);
  if (ms->xAxis == NULL || ms->yAxis == NULL) ccerr(not_implemented);
  if ((mp=ms->params) == NULL) ccerr(not_implemented);
  fnp = (char *)fn;
  if ((c=strstr(fnp,scanFilesPath)) != NULL) fnp = c + strlen(scanFilesPath);
  sprintf(filename,"%.255s%s%.255s",scanFilesPath,delStr,fnp);
  if ((c=strrchr(filename,'.')) == NULL || stricmp(c,".csv") != 0) strcat(filename,".csv");
  makeDirPath(filename);
  if ((fp=fopen(filename,"w")) == NULL) ccerr(file_error);
  fprintf(fp,"X-Axis, Y-Axis\n");
  for (i=0; i<len; i++)
  {
    fprintf(fp,"%g,",ms->xAxis[i]);
    for (k=0; k<mp->len; k++) fprintf(fp," %g",ms->yAxis[k+i*mp->len]);
    fprintf(fp,"\n");
  }
err:
  if (fp != NULL) fclose(fp);
  return cc;
}
int saveScanFileData(const char *fn,float *buf,int buflen)
{
  FILE *fp=NULL;
  int i, cc = 0;
  char *c, *fnp, filename[512];

  if (buf == NULL || fn == NULL) ccerr(invalid_parameter);
  if (buflen == 0) ccerr(dimension_error);
  fnp = (char *)fn;
  if ((c=strstr(fnp,scanFilesPath)) != NULL) fnp = c + strlen(scanFilesPath);
  sprintf(filename,"%.255s%s%.255s",scanFilesPath,delStr,fnp);
  if ((c=strrchr(filename,'.')) == NULL || stricmp(c,".csv") != 0) strcat(filename,".csv");
  makeDirPath(filename);
  if ((fp=fopen(filename,"w")) == NULL) ccerr(file_error);
  fprintf(fp,"X-Axis, Y-Axis\n");
  for (i=0; i<buflen/2; i++)
  {
    fprintf(fp,"%g, %g\n",buf[i],buf[i+buflen/2]);
  }

err:
  if (fp != NULL) fclose(fp);
  return cc;
}
int getScanFileData(const char *fn,const char *colhdr,float *buf,int *buflen,int index)
{
  FILE *fp=NULL;
  int i = 0, k, done = 0, cc = 0, limit;
  char *c,*cp=NULL,str[1024],scratch[512];
  int col = -1;
  float fval = 0;
  char filename[512];

  if (buf == NULL || colhdr == NULL || buflen == NULL || fn == NULL) ccerr(invalid_parameter);
  if (buflen == 0) ccerr(dimension_error);
  sprintf(filename,"%.255s%s%.255s",scanFilesPath,delStr,fn);
  if ((c=strrchr(filename,'.')) == NULL || stricmp(c,".csv") != 0) strcat(filename,".csv");
  if ((fp=fopen(filename,"r")) == NULL) ccerr(file_error);
  limit = *buflen;
  while (fgets(str,1024,fp) != NULL )
  {
    if (strlen(str) == 0) continue;
    if (strchr("%;#\n",str[0])) continue;      /* comment line(s) */
    if (!done)
    {
      if ((col=GetCsvColumnIndex(str,colhdr)) < 0) ccerr(no_such_line);
      done = 1;
      continue;
    }    
    if (i < limit)
    {
      strncpy(scratch,GetCsvColumnString(col,str),512);
      if (index > 0)
      {
        for (c=strtok_r(scratch," ",&cp), k=0; c != NULL; c=strtok_r(NULL," ",&cp), k++)
        {
          fval = (float)strtod(c,NULL);
          if (k >= index) break;
        }
      }
      else
      {
        fval = (float)strtod(scratch,&cp);
      }
      buf[i++] = fval;
    }
    else
    {
      break;
    }
  }
  *buflen = i;
err:
  if (fp != NULL) fclose(fp);
  return cc;
}
int getScanFileSet(NAME64 *files,int *nfiles)
{
# define fpat ".csv"
  int i=0, maxfiles;
  char dirname[128];
# if defined(UNIX)
  DIR *dp;
  struct dirent *dirp;
# elif defined(WIN32)
  struct _finddata_t fd;
# ifndef OS_64BIT
  long hfp;
# else
  intptr_t hfp;
# endif
# endif

  if (files == NULL || nfiles == NULL) return argument_list_error;
  maxfiles = *nfiles;
  *nfiles = 0;
# if defined(UNIX)
  strncpy(dirname,scanFilesPath,96); dirname[96] = 0;
  if ((dp=opendir(dirname)) == NULL) return no_such_file;
  while ((dirp=readdir(dp)) != NULL)
  {
    if (strstr(dirp->d_name,fpat) == NULL) continue;
    strncpy(files[i].name,dirp->d_name,64);
# elif defined(WIN32)
  sprintf(dirname,"%s\\*.*",scanFilesPath);
  if ((hfp=_findfirst(dirname, &fd)) == -1) return no_such_file;
  do
  {
    if (strstr(fd.name,fpat) == NULL) continue;
    strncpy(files[i].name,fd.name,64);
# endif
    if (++i == maxfiles) break;
# if defined(UNIX)
  }
  closedir(dp);
# elif defined(WIN32)
  } while (_findnext(hfp,&fd) != -1);
# endif
  *nfiles = i;
  return 0;
}

void PreSystemInit(void)
{
  int slen;
  char usrnam[32];
  char *usr = getenv("USERNAME");
  char *sfp = getenv("MST_SCANFILE_PATH");
  if (usr == NULL)
  {
    usr = "UNKNOWN";
  }
  strncpy(usrnam,usr,32);
  if (strlen(gMstFecName) > 0)
  { /* passed at the command line (so register FEC info here) */
    RegisterFecInformation(gMstFecName,"MST",gMotorServerContext,
      "Motor Steering server","","CDI",usrnam,(UINT16)gMstFecPortOffset);
  }
  if (sfp != NULL) 
  {
    strncpy(scanFilesPath,sfp,256);
    if ((slen=(int)strlen(scanFilesPath)) > 0)
    {
      if (scanFilesPath[slen-1] == FS_DELIMITER) scanFilesPath[slen-1] = 0;
    }
  }
}

void PostSystemInit(void)
{
  registerStructs();
  SetCatchConsoleBreak(TRUE);
  RegisterEquipmentModule(gMotorServerExportName,MSTEQM_TAG,NUM_MSTEQM_DEVICES,msteqm,msteqm_ini,msteqm_bkg,MSTEQM_RATE,msteqm_exi);
  SetExportedContext(MSTEQM_TAG,gMotorServerContext);
  if (strlen(gMotorServerGroup) > 0)
  {
    JoinEquipmentGroup(MSTEQM_TAG,gMotorServerGroup,gMotorGroupMetric);
  }
  loadMotorLib();
  SetEnforceMultiChannelAccess(FALSE);
}

double steps2mu(int mot,int nsteps)
{
  return mstTbl[mot].spmu > 0 ? (nsteps / mstTbl[mot].spmu) : 0;
}
int mu2steps(int mot,double mu)
{
  return (int)(mstTbl[mot].spmu * mu); 
}
void msteqm_bkg(void)
{
  int i,ival;

  if (!FecIsInitialized()) return;
  if (!motorServerInitialized) initializedMotorServer();
  ClearAlarm(MSTEQM_TAG,-1);

  for (i=0; i<gNumMotors; i++)
  {
    if (getMotorOnlineFcn != NULL) 
    {
      if (getMotorOnlineFcn(i,&ival) == 0) mstTbl[i].online = ival;
      else mstTbl[i].online = FALSE;
    }
    /* if (mstTbl[i].online == FALSE) continue; */
    mstTbl[i].status = getMotorStatus(i);
    mstTbl[i].position = getMotorPosition(i);
    if (getMotorTargetMicroPositionFcn != NULL) mstTbl[i].tgtMicroPosition = getMotorTargetMicroPosition(i);
    mstTbl[i].tgtPosition = getMotorTargetPosition(i);
  }
}
int RegisterMsteqmProperties(void)
{
  int cc = 0;
  short access;
  char desc[256];
  DTYPE dout,din;

  memset(&dout,0,sizeof(DTYPE)); memset(&din,0,sizeof(DTYPE));
  if (getMotorStepsPerMUFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_DOUBLE;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"MicroStepsPerMotorUnit",&dout,&din,CA_READ,AT_CHANNEL,0,"Motor steps per millimeter",PRP_STEPS_PER_MU,"")) < 0) goto err;
  }
  if (getMotorStepsPerRadianFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_DOUBLE;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"MicroStepsPerRadian",&dout,&din,CA_READ,AT_CHANNEL,0,"Motor steps per radian",PRP_STEPS_PER_RADIAN,"")) < 0) goto err;
  }
  if (getMotorMicroStepsPerStepFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"MicroStepsPerStep",&dout,&din,CA_READ,AT_CHANNEL,0,"Motor micro steps per step",PRP_MICROSTEPS_PER_STEP,"")) < 0) goto err;
  }
  
  if (calibrateMotorFcn != NULL)
  {
    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    if (calibrateToOffsetFcn != NULL)
    {
      din.dArrayLength = 1;
      din.dFormat = CF_DOUBLE;
      sprintf(desc,"[%g:%g %.16s]calibrate motor to given offset",
        mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    }
    else
    {
      din.dArrayLength = 0;
      din.dFormat = CF_NULL;
      strcpy(desc,"calibrate motor");
    }
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Calibrate",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,desc,PRP_CALIBRATE,"")) < 0) goto err;
  }  
  if (resetMotorFcn != NULL)
  {
    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Reset",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Reset Motor",PRP_RESET,"")) < 0) goto err;
  }
  if (getMotorPositionFcn != NULL)
  {
    HistorySpecification hspec =
    {
      HRS_DEFAULT_POLL_RATE,HRS_DEFAULT_ARCHIVE_RATE,HRS_DEFAULT_DEPTHSHORT,HRS_DEFAULT_DEPTHLONG,
      HRS_DEFAULT_HEARTBEAT,HRS_DEFAULT_REL_TOLERANCE,HRS_DEFAULT_ABS_TOLERANCE,NULL,NULL
    };
    access = CA_READ|CA_HIST;
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_DOUBLE;
    if (setMotorPositionFcn != NULL)
    {
      din.dArrayLength = 1;
      din.dFormat = CF_INT32;
      access |= CA_WRITE;
    }
    else
    {
      din.dArrayLength = 0;
      din.dFormat = CF_NULL;
    }
    sprintf(desc,"[%g:%g %.16s]motor position",
      mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Position",&dout,&din,access,AT_CHANNEL,0,desc,PRP_POSITION,"")) < 0) goto err;
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_USTRING;
    sprintf(desc,"Motor position units");
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Position.EGU",&dout,&din,CA_READ,AT_CHANNEL,0,desc,PRP_POSITION_EGU,"")) < 0) goto err;
    AppendHistoryInformation(MSTEQM_TAG, "Position", gMotorNames[0].name, gNumMotors, CF_DOUBLE, 1, &hspec);
  }
  if (setIncrementMoveStatusFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementMove.STATUS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Status of Increment Move to target",PRP_INCR_MOVE_STATUS,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementMove.RESUME",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Resume Increment Move to target",PRP_INCR_MOVE_RESUME,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementMove.PAUSE",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Pause Increment Move to target",PRP_INCR_MOVE_PAUSE,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementMove.STOP",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Stop Increment Move to target",PRP_INCR_MOVE_STOP,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 1;
    din.dFormat = CF_DOUBLE;
    sprintf(desc,"[%g:%g %.16s]start Increment Move to target position",
      mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementMove.START",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,desc,PRP_INCR_MOVE_START,"")) < 0) goto err;
  }
  if (getMotorPositionMinimumFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_DOUBLE;
    sprintf(desc,"[%g:%g %.16s]motor position lower limit",
      mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"PositionMinimum",&dout,&din,CA_READ,AT_SCALAR,0,desc,PRP_LIMITS_POS_LWR,"")) < 0) goto err;
  }
  if (getMotorPositionMaximumFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_DOUBLE;
    sprintf(desc,"[%g:%g %.16s]motor position upper limit",
      mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"PositionMaximum",&dout,&din,CA_READ,AT_SCALAR,0,desc,PRP_LIMITS_POS_UPR,"")) < 0) goto err;
  }
  if (getMotorPositionOffsetFcn != NULL)
  {
    access = CA_READ;
    if (setMotorPositionOffsetFcn != NULL) access |= CA_WRITE;
    dout.dArrayLength = 1;
    dout.dFormat = CF_DOUBLE;
    sprintf(desc,"[%g:%g %.16s]motor position offset",
      mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"PositionOffset",&dout,&din,access,AT_SCALAR,0,desc,PRP_POSITION_OFFSET,"")) < 0) goto err;
  }
  if (getMotorPositionScaleFcn != NULL)
  {
    access = CA_READ;
    if (setMotorPositionScaleFcn != NULL) access |= CA_WRITE;
    dout.dArrayLength = 1;
    dout.dFormat = CF_DOUBLE;
    sprintf(desc,"[%g:%g %.16s]motor position scale",
      mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"PositionScale",&dout,&din,access,AT_SCALAR,0,desc,PRP_POSITION_SCALE,"")) < 0) goto err;
  }
  if (getMotorVelocityLowerLimitFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_DOUBLE;
    din.dArrayLength = 1;
    din.dFormat = CF_DOUBLE;
    sprintf(desc,"[0:100 %.16s/sec]motor velocity lower limit",mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"VeloctityMinimum",&dout,&din,CA_READ|CA_WRITE,AT_SCALAR,0,desc,PRP_LIMITS_VEL_LWR,"")) < 0) goto err;
  }
  if (getMotorVelocityUpperLimitFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_DOUBLE;
    din.dArrayLength = 1;
    din.dFormat = CF_DOUBLE;
    sprintf(desc,"[0:100 %.16s/sec]motor velocity upper limit",mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"VeloctityMaximum",&dout,&din,CA_READ|CA_WRITE,AT_SCALAR,0,desc,PRP_LIMITS_VEL_UPR,"")) < 0) goto err;
  }
  if (getMotorAccelerationUpperLimitFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_DOUBLE;
    din.dArrayLength = 1;
    din.dFormat = CF_DOUBLE;
    sprintf(desc,"[0:100 %.16s/sec^2]motor acceleration upper limit",mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"AccelerationMaximum",&dout,&din,CA_READ,AT_SCALAR,0,desc,PRP_LIMITS_ACC_UPR,"")) < 0) goto err;
  }
  if (setControlGroupMoveStatusFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ControlledGroupMove.STATUS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Status of Controlled Group Move",PRP_CTRL_GRP_MOVE_STATUS,"")) < 0) goto err;

    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ControlledGroupMove.PROGRESS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Progress (seconds remaining) of Controlled Group Move",PRP_CTRL_GRP_MOVE_PROGRESS,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ControlledGroupMove.RESUME",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Resume Controlled Group Move",PRP_CTRL_GRP_MOVE_RESUME,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ControlledGroupMove.PAUSE",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Pause Controlled Group Move",PRP_CTRL_GRP_MOVE_PAUSE,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ControlledGroupMove.STOP",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Stop Controlled Group Move",PRP_CTRL_GRP_MOVE_STOP,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ControlledGroupMove.START",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Start Controlled Group Move",PRP_CTRL_GRP_MOVE_START,"")) < 0) goto err;
  }
  if (setGroupMoveStatusFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"GroupMove.STATUS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Status of Group Move",PRP_GRP_MOVE_STATUS,"")) < 0) goto err;

    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"GroupMove.PROGRESS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Progress (seconds remaining) of Group Move",PRP_GRP_MOVE_PROGRESS,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"GroupMove.RESUME",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Resume Group Move",PRP_GRP_MOVE_RESUME,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"GroupMove.PAUSE",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Pause Group Move",PRP_GRP_MOVE_PAUSE,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"GroupMove.STOP",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Stop Group Move",PRP_GRP_MOVE_STOP,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"GroupMove.START",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Start Group Move",PRP_GRP_MOVE_START,"")) < 0) goto err;
  }
  if (setIncrementGroupMoveStatusFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementGroupMove.STATUS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Status of Group Move",PRP_INCR_GRP_MOVE_STATUS,"")) < 0) goto err;

    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementGroupMove.PROGRESS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Progress (seconds remaining) of Group Move",PRP_INCR_GRP_MOVE_PROGRESS,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementGroupMove.RESUME",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Resume Group Move",PRP_INCR_GRP_MOVE_RESUME,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementGroupMove.PAUSE",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Pause Group Move",PRP_INCR_GRP_MOVE_PAUSE,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementGroupMove.STOP",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Stop Group Move",PRP_INCR_GRP_MOVE_STOP,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementGroupMove.START",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Start Group Move",PRP_INCR_GRP_MOVE_START,"")) < 0) goto err;
  }
  if (setMoveToStatusFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Move.STATUS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Status of Move to target",PRP_MOVE_STATUS,"")) < 0) goto err;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"StepMove.STATUS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Status of Move to target",PRP_STEP_STATUS,"")) < 0) goto err;

    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Move.PROGRESS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Progress (seconds remaining) of Move to target",PRP_MOVE_PROGRESS,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Move.RESUME",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Resume Move to target",PRP_MOVE_RESUME,"")) < 0) goto err;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"StepMove.RESUME",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Resume Move to target",PRP_STEP_RESUME,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Move.PAUSE",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Pause Move to target",PRP_MOVE_PAUSE,"")) < 0) goto err;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"StepMove.PAUSE",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Pause Move to target",PRP_STEP_PAUSE,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Move.STOP",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Stop Move to target",PRP_MOVE_STOP,"")) < 0) goto err;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"StepMove.STOP",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Stop Move to target",PRP_STEP_STOP,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 1;
    din.dFormat = CF_DOUBLE;
    sprintf(desc,"[%g:%g %.16s]start Move to target position",
      mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Move.START",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,desc,PRP_MOVE_START,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 1;
    din.dFormat = CF_INT32;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"StepMove.START",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"[0:32767 steps]Start Move to target position (steps)",PRP_STEP_START,"")) < 0) goto err;
    
    dout.dArrayLength = 1;
    dout.dFormat = CF_DOUBLE;
    din.dArrayLength = 1;
    din.dFormat = CF_DOUBLE;
    if ((cc = RegisterPropertyInformation(MSTEQM_TAG, "StepSize", &dout, &din, CA_READ | CA_WRITE, AT_UNKNOWN, 0, "Size of a step", PRP_STEPSIZE, "")) < 0) goto err;

    /* now the scan and monitor properties */
  
    dout.dArrayLength = 256;
    dout.dFormat = CF_TEXT;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    sprintf(desc,"current monitor parameters for requested motor");
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMonitor.PARAMS",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,desc,PRP_SCANMONITOR,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 1;
    din.dFormat = CF_DOUBLE;
    sprintf(desc,"[%g:%g %.16s]mon scan steps (default monitor); in: target position",
      mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMonitor.START",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,desc,PRP_SCANMONITOR_START,"")) < 0) goto err;
    sprintf(desc,"[%g:%g %.16s]fast scan move (default monitor); in: target position",
      mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FastScanMonitor.START",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,desc,PRP_FASTSCANMONITOR_START,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 256;
    din.dFormat = CF_TEXT;
    sprintf(desc,"[%g:%g %.16s]scan and step; in: -m=tgtName -p=pos -g=gr -s=siz -f=fmt -t=tmr",
      mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMonitor.START",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,desc,PRP_SCANMONITOR_START,"")) < 0) goto err;
    sprintf(desc,"[%g:%g %.16s]scan and move; in: -m=tgtName -p=pos -g=gr -s=siz -f=fmt -t=tmr",
      mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FastScanMonitor.START",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,desc,PRP_FASTSCANMONITOR_START,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMonitor.STOP",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Stop Step to target and monitor",PRP_SCANMONITOR_STOP,"")) < 0) goto err;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FastScanMonitor.STOP",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Stop Move to target and monitor",PRP_FASTSCANMONITOR_STOP,"")) < 0) goto err;
  
    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMonitor.PAUSE",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Pause Step to target with monitor",PRP_SCANMONITOR_PAUSE,"")) < 0) goto err;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FastScanMonitor.PAUSE",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Pause Move to target with monitor",PRP_FASTSCANMONITOR_PAUSE,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMonitor.RESUME",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Resume Step to target with monitor",PRP_SCANMONITOR_RESUME,"")) < 0) goto err;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FastScanMonitor.RESUME",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Resume Move to target with monitor",PRP_FASTSCANMONITOR_RESUME,"")) < 0) goto err;

    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMonitor.STATUS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Status of Step to target with monitor",PRP_SCANMONITOR_STATUS,"")) < 0) goto err;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FastScanMonitor.STATUS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Status of Move to target with monitor",PRP_FASTSCANMONITOR_STATUS,"")) < 0) goto err;

    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMonitor.PROGRESS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Progress (seconds remaining) of Step to target with monitor",PRP_SCANMONITOR_PROGRESS,"")) < 0) goto err;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FastScanMonitor.PROGRESS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Progress (seconds remaining) of Move to target with monitor",PRP_FASTSCANMONITOR_PROGRESS,"")) < 0) goto err;

    dout.dArrayLength = 10000;
    dout.dFormat = CF_FLOAT;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMonitor.X",&dout,&din,CA_READ,AT_UNKNOWN,0,"Scan Array X axis",PRP_SCANMONITOR_X,"")) < 0) goto err;

    dout.dArrayLength = 10000;
    dout.dFormat = CF_FLOAT;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMonitor.Y",&dout,&din,CA_READ,AT_UNKNOWN,0,"Scan Array Y axis",PRP_SCANMONITOR_Y,"")) < 0) goto err;

    dout.dArrayLength = 256;
    dout.dFormat = CF_TEXT;
    din.dArrayLength = 256;
    din.dFormat = CF_TEXT;
    sprintf(desc,"save current Monitor Scan to File");
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMonitorSave",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,desc,PRP_SAVESCANMONITOR,"")) < 0) goto err;

    dout.dArrayLength = 10000;
    dout.dFormat = CF_FLOAT;
    din.dArrayLength = 256;
    din.dFormat = CF_TEXT;
    sprintf(desc,"get scan Array X axis from file");
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanFile.X",&dout,&din,CA_READ,AT_UNKNOWN,0,desc,PRP_GETSCAN_X,"")) < 0) goto err;

    dout.dArrayLength = 10000;
    dout.dFormat = CF_FLOAT;
    din.dArrayLength = 256;
    din.dFormat = CF_TEXT;
    sprintf(desc,"get scan Array Y axis from file");
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanFile.Y",&dout,&din,CA_READ,AT_UNKNOWN,0,desc,PRP_GETSCAN_Y,"")) < 0) goto err;

    dout.dArrayLength = 1000;
    dout.dFormat = CF_NAME64;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    sprintf(desc,"get list of stored scan files");
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanFile.List",&dout,&din,CA_READ,AT_UNKNOWN,0,desc,PRP_GETSCANFILELIST,"")) < 0) goto err;
  }
  if (setScanMoveToStatusFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMove.STATUS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Status of Scan Move to target",PRP_SCANMOVE_STATUS,"")) < 0) goto err;

    dout.dArrayLength = 10000;
    dout.dFormat = CF_FLOAT;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMove.STATUS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Scan Status Arrays (as double array)",PRP_SCANMOVE_STATUS,"")) < 0) goto err;

    dout.dArrayLength = 10000;
    dout.dFormat = CF_FLOAT;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMove.X",&dout,&din,CA_READ,AT_UNKNOWN,0,"Scan Array X axis",PRP_SCANMOVE_X,"")) < 0) goto err;

    dout.dArrayLength = 10000;
    dout.dFormat = CF_FLOAT;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMove.Y",&dout,&din,CA_READ,AT_UNKNOWN,0,"Scan Array Y axis",PRP_SCANMOVE_Y,"")) < 0) goto err;

    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMove.PROGRESS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Progress (seconds remaining) of Scan Move to target",PRP_SCANMOVE_PROGRESS,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMove.RESUME",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Resume Scan Move to target",PRP_SCANMOVE_RESUME,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMove.PAUSE",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Pause Scan Move to target",PRP_SCANMOVE_PAUSE,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMove.STOP",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Stop Scan Move to target",PRP_SCANMOVE_STOP,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 1;
    din.dFormat = CF_DOUBLE;
    sprintf(desc,"[%g:%g %.16s]start Scan move (fast scan)",
      mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanMove.START",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,desc,PRP_SCANMOVE_START,"")) < 0) goto err;

    dout.dArrayLength = 256;
    dout.dFormat = CF_TEXT;
    din.dArrayLength = 256;
    din.dFormat = CF_TEXT;
    sprintf(desc,"save current Scan to File");
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"ScanSave",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,desc,PRP_SAVESCAN,"")) < 0) goto err;

    if ((scanbuffer=(float *)calloc(10000,sizeof(float))) == NULL) ccerr(out_of_server_memory);
  }
  if (setFreeMoveToStatusFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FreeMove.STATUS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Status of Free Move (no endswitch control) to target",PRP_FREE_MOVE_STATUS,"")) < 0) goto err;

    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FreeMove.PROGRESS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Progress (seconds remaining) of Free Move (no endswitch control) to target",PRP_FREE_MOVE_PROGRESS,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FreeMove.RESUME",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Resume Free Move (no endswitch control) to target",PRP_FREE_MOVE_RESUME,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FreeMove.PAUSE",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Pause Free Move (no endswitch control) to target",PRP_FREE_MOVE_PAUSE,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FreeMove.STOP",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Stop Free Move (no endswitch control) to target",PRP_FREE_MOVE_STOP,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 1;
    din.dFormat = CF_DOUBLE;
    sprintf(desc,"[%g:%g %.16s]start free move (no endswitch control) to target position",
      mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FreeMove.START",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,desc,PRP_FREE_MOVE_START,"")) < 0) goto err;
  }
  if (getMotorStatusFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Status",&dout,&din,CA_READ,AT_CHANNEL,0,"[0:1 ]Get Motor Status",PRP_STATUS,"")) < 0) goto err;
  }
  if (getMotorStatusBlockFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_STRUCT;
    strcpy(dout.dTag,"MotSts");
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"StatusInfo",&dout,&din,CA_READ,AT_CHANNEL,0,"[0:1 ]Get Motor Status Information (atomic structure)",PRP_STATUS_BLOCK,"")) < 0) goto err;
    memset(&dout,0,sizeof(DTYPE));
  }
  dout.dArrayLength = gNumMotors;
  dout.dFormat = CF_INT32;
  din.dArrayLength = 1;
  din.dFormat = CF_INT32;
  if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"OnLine",&dout,&din,CA_READ,AT_CHANNEL,0,"[0:1 ]Get/Set Motor On-Line Status",PRP_ONLINE,"")) < 0) goto err;
  if (getMotorTargetPositionFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_DOUBLE;
    access = CA_READ;
    if (setMotorTargetPositionFcn != NULL)
    {
      din.dArrayLength = 1;
      din.dFormat = CF_DOUBLE;
      access |= CA_WRITE;
    }
    else
    {
      din.dArrayLength = 0;
      din.dFormat = CF_NULL;
    }
    sprintf(desc,"[%g:%g %.16s]get/set Motor Target Position",
      mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"TargetPosition",&dout,&din,access,AT_CHANNEL,0,desc,PRP_TARGET_POSITION,"")) < 0) goto err;
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_USTRING;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    sprintf(desc,"Motor position units");
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"TargetPosition.EGU",&dout,&din,CA_READ,AT_CHANNEL,0,desc,PRP_TARGET_POSITION_EGU,"")) < 0) goto err;
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_INT32;
    access = CA_READ;
    if (setMotorTargetPositionFcn != NULL)
    {
      din.dArrayLength = 1;
      din.dFormat = CF_INT32;
      access |= CA_WRITE;
    }
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"TargetSteps",&dout,&din,access,AT_CHANNEL,0,"[0:32767 steps]get/set Motor Target Position in steps",PRP_TARGET_STEPS,"")) < 0) goto err;
  }
  if (getGroupGearRatioFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_DOUBLE;
    access = CA_READ;
    if (setGroupGearRatioFcn != NULL)
    {
      din.dArrayLength = 1;
      din.dFormat = CF_DOUBLE;
      access |= CA_WRITE;
    }
    else
    {
      din.dArrayLength = 0;
      din.dFormat = CF_NULL;
    }
    sprintf(desc,"[0.01:100]get/set Motor Group Gear Ratio");
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"GearRatio",&dout,&din,access,AT_CHANNEL,0,desc,PRP_GROUP_GEAR_RATIO,"")) < 0) goto err;
  }

  if (getMotorTargetMicroPositionFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_INT32;
    access = CA_READ;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"TargetMicroPosition",&dout,&din,access,AT_CHANNEL,0,"[0:32767 microsteps]Get/Set Motor Target Position",PRP_TARGET_MICROSTEPS,"")) < 0) goto err;
  }
  if (getMotorAccelerationFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_DOUBLE;
    access = CA_READ;
    if (setMotorAccelerationFcn != NULL)
    {
      din.dArrayLength = 1;
      din.dFormat = CF_DOUBLE;
      access |= CA_WRITE;
    }
    else
    {
      din.dArrayLength = 0;
      din.dFormat = CF_NULL;
    }
    sprintf(desc,"[0:1 %.16s/sec^2]get/set Motor Acceleration",mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Acceleration",&dout,&din,access,AT_CHANNEL,0,desc,PRP_ACCELERATION,"")) < 0) goto err;
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_USTRING;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    sprintf(desc,"Motor Acceleration units");
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Acceleration.EGU",&dout,&din,CA_READ,AT_CHANNEL,0,desc,PRP_ACCELERATION_EGU,"")) < 0) goto err;
  }
  if (getMotorVelocityFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_DOUBLE;
    access = CA_READ;
    if (setMotorVelocityFcn != NULL)
    {
      din.dArrayLength = 1;
      din.dFormat = CF_DOUBLE;
      access |= CA_WRITE;
    }
    else
    {
      din.dArrayLength = 0;
      din.dFormat = CF_NULL;
    }
    sprintf(desc,"[0:100 %.16s/sec]get/set Motor Velocity",mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Velocity",&dout,&din,access,AT_CHANNEL,0,desc,PRP_VELOCITY,"")) < 0) goto err;
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_USTRING;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    sprintf(desc,"Motor Velocity units");
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Velocity.EGU",&dout,&din,CA_READ,AT_CHANNEL,0,desc,PRP_VELOCITY_EGU,"")) < 0) goto err;
  }
  if (getMotorCurrentFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_DOUBLE;
    access = CA_READ;
    if (setMotorCurrentFcn != NULL)
    {
      din.dArrayLength = 1;
      din.dFormat = CF_DOUBLE;
      access |= CA_WRITE;
    }
    else
    {
      din.dArrayLength = 0;
      din.dFormat = CF_NULL;
    }
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Current",&dout,&din,access,AT_CHANNEL,0,"[0:1 mA]Motor Current",PRP_CURRENT,"")) < 0) goto err;
  }
  if (getLastHdwErrFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_NAME64;
    access = CA_READ;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"LastHardwareError",&dout,&din,access,AT_CHANNEL,0,"Last Hardware Error",PRP_LASTHDWERR,"")) < 0) goto err;
  }

  dout.dArrayLength = gNumMotors;
  dout.dFormat = CF_LONG;
  din.dArrayLength = 1;
  din.dFormat = CF_LONG;
  if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"RotationMoveAllowed",&dout,&din,CA_READ|CA_WRITE,AT_CHANNEL,0,"[0:1 ]Linear Rotation Moves (end switc",PRP_ROTATIONMOVEALLOWED,"")) < 0) goto err;

  dout.dArrayLength = 0;
  dout.dFormat = CF_NULL;
  din.dArrayLength = 1;
  din.dFormat = CF_LONG;
  if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"MicroStep",&dout,&din,CA_READ|CA_WRITE,AT_CHANNEL,0,"[0:100 steps]Move Micro Step",PRP_MICROSTEP,"")) < 0) goto err;

  dout.dArrayLength = gNumMotors;
  dout.dFormat = CF_LONG;
  din.dArrayLength = 1;
  din.dFormat = CF_LONG;
  if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"StepCounter",&dout,&din,CA_READ|CA_WRITE,AT_CHANNEL,0,"[0:100 steps]Set/Read Step Counter",PRP_STEPCOUNTER,"")) < 0) goto err;

  dout.dArrayLength = gNumMotors;
  dout.dFormat = CF_LONG;
  din.dArrayLength = 1;
  din.dFormat = CF_LONG;
  if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"MicroStepCounter",&dout,&din,CA_READ|CA_WRITE,AT_CHANNEL,0,"[0:100 micro-steps]Set/Read Micro Step Counter",PRP_MICROSTEPCOUNTER,"")) < 0) goto err;

  dout.dArrayLength = 32;
  dout.dFormat = CF_NAME32;
  din.dArrayLength = 0;
  din.dFormat = CF_NULL;
  if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"StatusBits",&dout,&din,CA_READ,AT_UNKNOWN,0,"motor status bit definitions",PRP_STATUSBIT_LIST,"")) < 0) goto err;

err:
  if (cc < 0)
  {
    feclog("Can't register property : %s",erlst[-cc]);
  }
  return cc;
}

void getDefaultMonitors(void)
{
  MonitorInfo *minf = NULL;
  MonitorParams *mp = NULL;
  int i, k, n = 0;

  if (csvReadFile(NULL,MST_MONITOR_FILE,&csvMstMonitorInfoConfigDb,(void **)&minf) == 0) 
  { /* need to configure default monitors */
    feclog("motor monitor scan database found");
    n = csvMstMonitorInfoConfigDb.siz;
    for (i=0; i<n; i++) for (k=0; k<gNumMotors; k++)
    {
      if (!strnicmp(minf[i].nam,gMotorNames[k].name,DEVICE_NAME_SIZE))
      { /* found motor specific default scan info */
        if ((mp=getMonitorParams(minf[i].dev,minf[i].prp,
                (int)GetFormatFromString(minf[i].fmt),minf[i].len,minf[i].tmr,minf[i].dly,minf[i].inc)) == NULL)
        {
          feclog("failed to get monitor parameters for %.64s",minf[i].nam);
          continue;
        }
        mstTbl[k].monScan.params = mp;
        mstTbl[k].monScan.length = mp->len;
        mstTbl[k].monScan.mot = k;
        mstTbl[k].monScan.grp = -1;
      }
    }
    for (i=0; i<n; i++) for (k=0; k<mstGroupTblSize; k++)
    {
      if (!strnicmp(minf[i].nam,mstGroupTbl[k].name,DEVICE_NAME_SIZE))
      { /* found motor group specific default scan info */
        if ((mp=getMonitorParams(minf[i].dev,minf[i].prp,
                (int)GetFormatFromString(minf[i].fmt),minf[i].len,minf[i].tmr,minf[i].dly,minf[i].inc)) == NULL)
        {
          feclog("failed to get monitor parameters for %.64s",minf[i].nam);
          continue;
        }
        mstGroupTbl[k].monScan.params = mp;
        mstGroupTbl[k].monScan.length = mp->len;
        mstGroupTbl[k].monScan.mot = -1;
        mstGroupTbl[k].monScan.grp = k;
      }
    }
  }
  /*
  NOTE: the minf reference can be freed just prior to returning from csvReadFile, but WINDOWS is determined to
  have a heap valid assertion failure if you try to do it here ! (conclusion: just forget it)
  if (minf != NULL) free(minf);
  */
}
void acquireStaticMotorInfo(int i)
{
  if (getMotorUnits(i,&mstTbl[i].units) != 0) 
  { /* no units function available ! */
    strcpy(mstTbl[i].units.name,"none");
    mstTbl[i].ztol = 1;
  }
  else
  {
    switch (tolower((int)mstTbl[i].units.name[0]))
    {
      case 'p': // pico-meters (get serious!)
        mstTbl[i].ztol = 1000; break;
      case 'n': // nano-meters (typical of attocube)
        mstTbl[i].ztol = 100; break;
      case 'u': // micro-meters (typical of attocube)
        mstTbl[i].ztol = 10; break;
      case 'm': // milli-meters (quasi-normal)
      default:
        mstTbl[i].ztol = 1; break;
    }
  }
  mstTbl[i].spmu = getStepsPerMU(i);
  mstTbl[i].spr = getStepsPerRadian(i);
  mstTbl[i].msps =  getMicroStepsPerStep(i);
  mstTbl[i].status = getMotorStatus(i);
  // get limits 
  mstTbl[i].limits[VEL_LWR_IDX] = getMotorVelocityLowerLimit(i);
  mstTbl[i].limits[VEL_UPR_IDX] = getMotorVelocityUpperLimit(i);
  mstTbl[i].limits[ACC_UPR_IDX] = getMotorAccelerationUpperLimit(i);
  // get current settings (velocity, acceleration, target, current positions)
  mstTbl[i].velocity = getMotorVelocity(i);
  mstTbl[i].acceleration = getMotorAcceleration(i);
  mstTbl[i].positionMinimum = getMotorPositionMinimum(i);
  mstTbl[i].positionMaximum = getMotorPositionMaximum(i);
  mstTbl[i].positionOffset = getMotorPositionOffset(i);
  mstTbl[i].positionScale = getMotorPositionScale(i);
}
void initializedMotorServer(void)
{
  int i, k, p, n, cc;
  MstGroupInfoStruct *mstInfoTbl = NULL;
  char grpdevs[1048];

  if (motorServerInitialized) return;
  motorServerInitialized = TRUE;
  if ((cc=initializeMotorHardware()) != 0)
  {
    feclog("error in initializing motor steering hardware : %s",erlst[cc]);
  }
  getMotorList(&gMotorNames,&gNumMotors);

  if (gNumMotors < 1) 
  { // configuration error
    feclog("no configured motors");
    printf("There are no configured motors !\n");
    return; 
  }
  for (i=0; i<gNumMotors; i++)
  {
    if ((cc=RegisterDeviceName(MSTEQM_TAG,gMotorNames[i].name,i)) != 0) 
      feclog("cannot register device %s : %s",gMotorNames[i].name,erlst[cc]);
    acquireStaticMotorInfo(i);
    mstTbl[i].online = TRUE; // is device on line ?
  }

  RegisterMsteqmProperties();

  if ((cc=csvReadFile(NULL,MST_GROUP_FILE,&csvMstGroupInfoConfigDb,(void **)&mstInfoTbl)) == 0) 
  { /* need to configure group devices */
    feclog("motor group database found");
    n = csvMstGroupInfoConfigDb.siz;
    /* worst case allocation : */
    if ((mstGroupTbl=(MstGroupDevice *)calloc(n,sizeof(MstGroupDevice))) == NULL)
    { 
      feclog("cannot allocate group motor device table : aborting");
      exit(1);
    }
    for (i=0; i<n; i++)
    { /* scan thru and look for the defined groups */
      for (k=0; k<mstGroupTblSize; k++) if (strnicmp(mstGroupTbl[k].name,mstInfoTbl[i].name,DEVICE_NAME_SIZE) == 0) break;
      if (k == mstGroupTblSize)
      { /* new group */
        strncpy(mstGroupTbl[k].name,mstInfoTbl[i].name,DEVICE_NAME_SIZE);
        mstGroupTblSize++;
      }
      p = mstGroupTbl[k].numberInGroup;
      mstGroupTbl[k].members[p] = &mstInfoTbl[i];
      mstGroupTbl[k].gearRatio = mstInfoTbl[i].gearRatio;
      mstGroupTbl[k].groupId = mstInfoTbl[i].groupId;
      mstGroupTbl[k].numberInGroup++;
    }
    for (i=0; i<mstGroupTblSize; i++)
    {
      if ((cc=RegisterDeviceName(MSTEQM_TAG,mstGroupTbl[i].name,gNumMotors+i)) != 0) 
        feclog("cannot register motor group device %s : %s",mstGroupTbl[i].name,erlst[cc]);
      /* now register the group with the motor library */
      grpdevs[0] = 0; 
      for (k=0; k<mstGroupTbl[i].numberInGroup; k++)
      {
        if (strlen(grpdevs) + DEVICE_NAME_SIZE > 1048) 
        {
          feclog("motor group %s has too many motors (or composite string is too long)",mstGroupTbl[k].name);
          break;
        }
        strncat(grpdevs,gMotorNames[mstGroupTbl[i].members[k]->motorNr-1].name,DEVICE_NAME_SIZE);
        if (k<mstGroupTbl[i].numberInGroup-1) strcat(grpdevs,",");
      }
      if (mstGroupTbl[i].groupId < 0)
      { /* use what was entered or make one on the fly */
        mstGroupTbl[i].groupId = mstGetMotorGroupFromList(grpdevs,mstGroupTbl[i].name);
      }
      else
      {
        if (mstGroupTbl[i].groupId < MST_DYNAGRP_OFFST)
        {
          mstAddPseudoAxisMotorGroup(mstGroupTbl[i].name,mstGroupTbl[i].groupId);
        }
      }
      if (mstGroupTbl[i].members[0] != NULL)
      {
        mstSetGroupHead(mstGroupTbl[i].groupId,mstGroupTbl[i].members[0]->motorNr);
        setGroupGearRatio(mstGroupTbl[i].groupId,mstGroupTbl[i].gearRatio);
      }
    }
  }
  /* any default monitor information from 'motorscans.csv' ? */
  getDefaultMonitors();
  /* now fix the number of exported devices ... */
  AssignNumDevices(MSTEQM_TAG,gNumMotors+mstGroupTblSize);
}
void msteqm_ini(void)
{
# ifdef EAGER_INIT
  initializedMotorServer();
# endif
}
void msteqm_exi(void)
{
  /* TODO: put your shutdown routines here */
}
void stopScanMonitor(MonitorScan *ms)
{
  MonitorParams *mp = NULL;
  if (ms == NULL || (mp=ms->params) == NULL) return;
  ms->stop = MakeDataTimeStamp();
  ms->length = mp->idx;
  if (mp->err < ms->length) ms->sts = 0;
  CloseLink(ms->id);
}
int gPauseStepScan = FALSE;
int gAbortStepScan = FALSE;
#define MAX_MONITOR_ERRORS 10
void cbScanMonitor(int id,int cc,void *ref)
{
  MonitorScan *ms = (MonitorScan *)ref;
  MonitorParams *mp = NULL;
  int sts, idx, nsteps = 1, mot = -1;
  double tgt, pos, tol;
  DTYPE din;
  
  if (ms == NULL || (mp=ms->params) == NULL) cc = invalid_parameter;
  
  if (cc != 0)
  {
    mp->err++;
    ms->sts = cc;
    if (mp->cle++ > MAX_MONITOR_ERRORS) goto stopScan;
    return;
  }
  mp->ts = GetCurrentDataTimeStamp(id);
  idx = mp->idx;
  mot = ms->mot;
  if (mot < 0) 
  {
    if (mstGroupTblSize == 0) goto stopScan;
    mot = mstGroupTbl[ms->grp].members[0]->motorNr - 1;
  }
  sts = getMotorStatus(mot);
  if (ms->isStepping)
  { // step scanning 
    if (gAbortStepScan) goto stopScan;
    if (gPauseStepScan) return;
    if (setStepToStatusFcn != NULL)
    {
      if (mp->ts <= ms->ts) return;
      if (sts == MTR_STEP) return;
    }
    else
    { // move in incremental steps
      if (sts & MTR_MOVE) return;
      sts &= ~(MTR_ISCLBR);
      if (sts != MTR_IDLE) goto stopScan;
      if (ms->tsStep < 0) ms->tsStep = MakeDataTimeStamp();
      if (mp->ts <= ms->tsStep + mp->dly) return;
    }
  }
  else
  { // fast scanning
    if (sts == MTR_IDLE) goto stopScan;
  }
  ms->xAxis[idx] = pos = (double)getMotorPosition(mot);
  ms->ts = MakeDataTimeStamp();
  memset(&din,0,sizeof(DTYPE));
  din.dArrayLength = mp->len;
  din.dFormat = mp->fmt;
  din.data.bptr = mp->dat;
  GetValuesAsDouble(&din,&ms->yAxis[idx*mp->len],mp->len);
  if (ms->isStepping)
  { // finished this step => next step
    if (setStepToStatusFcn != NULL)
    { // has a stepto function in the motor plug
      tol = mstTbl[mot].spmu > 0 ? 1.0/mstTbl[mot].spmu : mstTbl[mot].ztol;
      tgt = mstTbl[mot].tgtPosition;
      if (fabs(pos - tgt) < tol) goto stopScan; 
      nsteps = (tgt < pos) ? -1 : 1;
      if ((cc=setMotorTargetSteps(mot,nsteps)) != 0) goto stopScan;
      if ((cc=setStepToStatusFcn(mot,PROC_STS_START)) != 0) goto stopScan;
    }
    else
    { // use incremental scans
      tgt = ms->tgtPos;
      if (mp->inc > 0)
      {
        if (pos > tgt) goto stopScan;
        tgt = ms->lastPos + mp->inc;
      }
      if (mp->inc < 0)
      {
        if (pos < tgt) goto stopScan;
        tgt = ms->lastPos - mp->inc;
      }
      ms->lastPos = tgt;
      if ((cc=setMotorTargetPosition(mot,tgt)) != 0) goto stopScan;
      if ((cc=setMoveToStatusFcn(mot,PROC_STS_START)) != 0) goto stopScan;
    }
  }
  if (mp->idx < ms->length) 
  {
    mp->idx++;
    return;
  }
stopScan:
  if (ms->isStepping)
  {
    gAbortStepScan = FALSE;
    ms->isStepping = FALSE;
  }
  else
  {
    stopScanMonitor(ms);
  }
  return;
}
int startScanMonitor(MonitorScan *ms)
{
  int cc = 0, dlen;
  MonitorParams *mp;
  DTYPE dout;

  if (ms == NULL) return invalid_parameter;
  if ((mp=ms->params) == NULL) return invalid_parameter;
  if (ms->length == 0 || 
      mp->len == 0 ||
      mp->fmt == CF_NULL ||
      strlen(mp->dev) == 0 ||
      strlen(mp->prp) == 0) return configuration_error;
  if (mp->dat == NULL)
  {
    if ((mp->dat=(BYTE *)calloc(mp->len,fmtsizeof(mp->fmt))) == NULL)
      return out_of_server_memory;
  }
  if (mp->tmr < 10) mp->tmr = 1000;

  if (ms->length > ms->capacity)
  {
    dlen = ms->capacity = ms->length + 100 - (ms->length % 100);
    if (ms->xAxis != NULL) free(ms->xAxis);
    if (ms->yAxis != NULL) free(ms->yAxis);
    if ((ms->xAxis=(double *)calloc(dlen,sizeof(double))) == NULL) return out_of_server_memory;
    dlen *= mp->len; /* possible doubly dimensioned array : mp->len >= 1 */
    if ((ms->yAxis=(double *)calloc(dlen,sizeof(double))) == NULL) return out_of_server_memory;
  }

  memset(&dout,0,sizeof(DTYPE));
  dout.dFormat = mp->fmt;
  dout.dArrayLength = mp->len;
  dout.data.bptr = mp->dat;

  mp->idx = 0;
  mp->err = 0;
  ms->stop = 0;
  ms->id = AttachLinkEx2(mp->dev,mp->prp,&dout,NULL,CA_READ,mp->tmr,cbScanMonitor,CM_TIMER,UNASSIGNED_CALLBACKID,(void *)ms);
  if (ms->id < 0) cc = ms->sts = -ms->id;
  ms->start = MakeDataTimeStamp();

  return cc;
}
MonitorParams *parseScanInputString(const char *inpt,double *pos,double *gear)
{ 
  char str[256],*c,*dev=NULL,*prp=NULL,*del=" ";
  MonitorParams *mp;
  double dpos=0.0, dgear=1.0;
  int fmt=CF_FLOAT,len=1,tmr=1000,tgtpos_given=FALSE,fast_scan=FALSE;
  int delay=100,incr=1000;

  if (pos == NULL) return NULL;
  strncpy(str,inpt,256);
  for (c=strtok(str,del); c != NULL; c=strtok(NULL,del))
  {
    if (*c != '-' && *c != '/' ) break; else c++;
    switch (*c)
    {
      case 'm': /* monitor target */
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          dev = c;
          if ((prp=strchr(str,'[')) == NULL) return NULL;
          *prp++ = 0;
          if ((c=strchr(prp,']')) != NULL) *c = 0;
        }
        continue;
      case 'p': /* position target */
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          dpos = strtod(c,NULL);
          tgtpos_given = TRUE;
        }
        continue;
      case 'g': /* gear ratio (default = 1.0) */
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          dgear = strtod(c,NULL);
        }
        continue;
      case 's': /* size of monitored data (default = 1) */
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          len = atoi(c);
        }
        continue;
      case 'f': /* format of monitored data (default = float) */
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          fmt = (int)GetFormatFromString(c);
        }
        continue;
      case 't': /* timer interval (default = 1000) */
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          tmr = atoi(c);
        }
        continue;
      case 'd': /* delay pause between steps (default = 100) */
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          delay = atoi(c);
        }
        continue;
      case 'i': /* step increment when no 'stepto' is provided (default = 1000 mu) */
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          incr = atoi(c);
        }
        continue;
      default:
        continue;
    }
  }
  if (!tgtpos_given) return NULL;
  *pos = dpos;
  if (gear != NULL) *gear = dgear;
  if ((mp=getMonitorParams(dev,prp,fmt,len,tmr,delay,incr)) == NULL)
  {
    feclog("could not parse '%s' into monitor parameters\n",inpt);
  }
  return mp;
}
int msteqm(char *devName,char *devProperty,DTYPE *dout, DTYPE *din,short access)
{
  int i,m,ival,alen,blen,devnr,grpnr=-1,prpid,grpid=-1,cc,idx=0;
  int isGroupedCall=FALSE, isGroupedDevice=FALSE, isMonitorCall=FALSE,monitorStepScan=TRUE;
  short sval;
  double dval, dvals[4], dvalArray[NUM_MSTEQM_DEVICES];
  UINT32 lval, lvalArray[NUM_MSTEQM_DEVICES];
  char grpdevs[1048],grpprp[PROPERTY_NAME_SIZE+8],sfn[256];
  char *g=NULL,*cp=NULL,*unitscat=NULL,*tag;
  int numInGroup=NUM_MOTORS_MAX;
  int motorsInGroup[NUM_MOTORS_MAX];
  DTYPE dscan;
  MonitorParams *mp=NULL;
  MonitorScan *ms=NULL;
  double *xScanAxis=NULL,*yScanAxis=NULL;
  double v, dp;

  devnr = GetDeviceNumberEx(MSTEQM_TAG,devName,devProperty);
  if (devnr < 0) 
  { /* possibly an on-the-fly group call ? */
    if ((cc=mstSplitGroupFromList(devName,&numInGroup,motorsInGroup,grpdevs)) != 0) return cc;
    grpid = mstGetMotorGroup(grpdevs,numInGroup,motorsInGroup);
    mstSetGroupHead(grpid,motorsInGroup[0]+1); /* works with motor number (not device number) */
    isGroupedCall = TRUE;
    devnr = motorsInGroup[0];
  }
  if (devnr < 0 && grpid < 0) 
  { /* definitely not valid */
    return illegal_device;
  }
  isMonitorCall = strnicmp(devProperty,"ScanMonitor.",12) == 0 ? TRUE : FALSE;
  if (devnr >= gNumMotors) 
  { /* a registered motor group device */
    isGroupedDevice = TRUE;
    /* grpnr is an entry in the group table (what was read from the motorgroups.csv file) */
    grpnr = devnr - gNumMotors;
    /* grpid is an entry in the mstGroups[] table (registered with the motor library) */
    if (mstGroupTblSize <= grpnr) return illegal_device; /* should never arise */
    grpid = mstGroupTbl[grpnr].groupId;
    /* find a representative motor for 'status' calls */
    devnr = mstGroupTbl[grpnr].members[0]->motorNr - 1;
    numInGroup = mstGroupTbl[grpnr].numberInGroup;
    isGroupedCall = TRUE;
    if (strnicmp(devProperty,"Move.",5) == 0)
    { /* re-wire a simple "Move" command */
      strncpy(grpprp,devProperty,PROPERTY_NAME_SIZE);
      sprintf(devProperty,"Group%.32s",grpprp);
    }
    if (strnicmp(devProperty,"IncrementMove.",14) == 0)
    { /* re-wire a simple "Move" command */
      strncpy(grpprp,devProperty,PROPERTY_NAME_SIZE);
      sprintf(devProperty,"IncrementGroupMove.%.32s",&grpprp[14]);
    }
    if (isMonitorCall)
    { /* re-wire a simple "Move" command */
      if (!stricmp(devProperty,"ScanMonitor.PARAMS") ||
          !stricmp(devProperty,"ScanMonitor.X") ||
          !stricmp(devProperty,"ScanMonitor.Y"))
      {
        isMonitorCall = FALSE;
      }
      else
      {
        strncpy(grpprp,&devProperty[12],PROPERTY_NAME_SIZE);
        sprintf(devProperty,"GroupMove.%.32s",grpprp);
      }
    }
  }
  prpid = GetPropertyId(MSTEQM_TAG,devProperty);

  switch (prpid)
  {
    case PRP_STEPS_PER_MU:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromAny(dout,&mstTbl[0].spmu,CF_DOUBLE,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_STEPS_PER_RADIAN:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromAny(dout,&mstTbl[0].spr,CF_DOUBLE,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_MICROSTEPS_PER_STEP:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromAny(dout,&mstTbl[0].msps,CF_INT32,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_STATUS:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (isGroupedDevice)
          {
            dout->dArrayLength = 1;
            if (getGroupMotorStatusFcn != NULL)
            {
              ival = getGroupMotorStatus(grpid);
              return PutValuesFromLongEx(dout,&ival,1,0);
            }
          }
          if (isGroupedCall) dout->dArrayLength = 1;
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromAny(dout,&mstTbl[0].status,CF_INT16,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_STATUS_BLOCK:
        if (access&CA_WRITE) return illegal_read_write;
        if (isGroupedCall) return illegal_device;
        if (dout->dArrayLength > 0)
        {
          if (dout->dFormat != CF_STRUCT) return illegal_format;
          if (strcmp(dout->dTag,"MotSts")) return invalid_structure_tag;
          for (i=0,m=devnr; i<(int)dout->dArrayLength && m<gNumMotors; i++,m++)
          {
            cc = getMotorStatusBlockFcn(m,&((MotorStatus *)dout->data.vptr)[i]);
            if (cc != 0) return cc;
          }
          dout->dArrayLength = i;
        }
        return 0;
    case PRP_ONLINE:
        if (isGroupedCall) return illegal_device;
        if (isGroupedDevice) return illegal_device;
        if (access&CA_WRITE) 
        {
          if (din->dArrayLength > 0)
          {
            if ((cc=GetValuesAsShort(din,&sval,1)) != 0) return cc;
            if (setMotorOnlineFcn != NULL) setMotorOnlineFcn(devnr,sval);
            mstTbl[devnr].online = sval;
            feclog("motor %s set to %s",devName,sval ? "on line" : "off line");
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromAny(dout,&mstTbl[0].online,CF_INT16,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_CALIBRATE:
        if (isGroupedCall) return illegal_device;
        if (isGroupedDevice) return illegal_device;
        if (access&CA_WRITE)
        {
           if (din->dArrayLength > 0) 
           {
             if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
             if ((cc=calibrateToOffset(devnr,dval)) != 0) return cc;
           }
           else
           {
             if ((cc=calibrateMotor(devnr)) != 0) return cc;
             dval = 0;
           }
           if (setMotorTargetStepsFcn == NULL)
           {
             mstTbl[devnr].stepcounter = mu2steps(devnr,dval);
             mstTbl[devnr].microstepcounter = mstTbl[devnr].stepcounter*mstTbl[devnr].msps;
           }
           else
           {
             mstTbl[devnr].stepcounter = mstTbl[devnr].microstepcounter = 0;
           }
           mstTbl[devnr].tgtPosition = dval;
           mstTbl[devnr].tgtMicroPosition = mstTbl[devnr].microstepcounter;
           feclog("motor %.64s has been reset",devName);
        }
        return 0;

    case PRP_RESET:
        if (isGroupedCall) return illegal_device;
        if (isGroupedDevice) return illegal_device;
        if (access&CA_WRITE)
        {
           if (din->dArrayLength > 0) return illegal_read_write;
           if ((cc=resetMotor(devnr)) != 0) return cc;
           mstTbl[devnr].stepcounter = mstTbl[devnr].microstepcounter = 0;
           feclog("motor %.64s has been reset",devName);
        }
        return 0;
    case PRP_TARGET_POSITION:
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if ((cc=GetValuesAsDouble(din,dvalArray,NUM_MSTEQM_DEVICES)) != 0) return cc;
            if (isGroupedDevice)
            { /* passed as a registered motor device group: target applies to all member of the group */
              if (din->dArrayLength != 1) return dimension_error;
              dval = dvalArray[0];
              if ((cc=setGroupMotorTargetPosition(grpid,dval)) != 0) return cc;
            }
            else if (isGroupedCall)
            { /* passed as a sequence of motors */
              if (din->dArrayLength != (UINT32)numInGroup) return dimension_error;
              for (i=0; i<numInGroup; i++)
              {
                m = motorsInGroup[i];
                if ((cc=setMotorTargetPosition(m,dvalArray[i])) != 0) return cc;
                mstTbl[m].tgtPosition = dvalArray[i];
              }
            }
            else
            { /* normal: not a motor device group ! */
              for (i=0; i<(int)din->dArrayLength; i++)
              {
                if (devnr + i >= gNumMotors) continue;
                if ((cc=setMotorTargetPosition(devnr+i,dvalArray[i])) != 0) return cc;
                mstTbl[devnr+i].tgtPosition = dvalArray[i];
              }
            }
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if (isGroupedDevice) 
          { /* cut to the chase */
            dval = getGroupMotorTargetPosition(grpid);
            dout->dArrayLength = 1;
            return PutValuesFromDoubleEx(dout,&dval,1,0);
          }
          else if (isGroupedCall)
          { /* return them in the order specified */
            if (dout->dArrayLength != (UINT32)numInGroup) return dimension_error;
            for (i=0; i<numInGroup; i++) 
            {
              m = motorsInGroup[i];
              dvalArray[i] = mstTbl[m].tgtPosition;
              return PutValuesFromDoubleEx(dout,dvalArray,numInGroup,0);
            }
          }
          if ((cc=PutValuesFromAny(dout,&mstTbl[0].tgtPosition,CF_DOUBLE,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_GROUP_GEAR_RATIO:
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
          }
          else
          {
            if (grpnr < 0) return illegal_device;
            dval = mstGroupTbl[grpnr].gearRatio;
            if (dval == 0) dval = mstGroupTbl[grpnr].members[0]->gearRatio;
          }
          if ((cc=setGroupGearRatio(grpid,dval)) != 0) return cc;
        }
        if (!isGroupedCall) return illegal_device;
        if (dout->dArrayLength > 0)
        {
          dval = getGroupGearRatio(grpid);
          if ((cc=PutValuesFromDouble(dout,&dval,1)) != 0) return cc;
        }
        return 0;
    case PRP_TARGET_STEPS:
        if (isGroupedCall) return illegal_device;
        if (isGroupedDevice) return illegal_device;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if ((cc=GetValuesAsLong(din,&lval,1)) != 0) return cc;
            if ((cc=setMotorTargetSteps(devnr,lval)) == not_implemented)
            {
              dval = steps2mu(devnr,lval);
              if ((cc=setMotorTargetPosition(devnr,dval)) != 0) return cc;
              mstTbl[devnr].tgtPosition = dval;
            }
            else
            { // distinction between 'step' moves and continuous moves
              if (cc != 0) return cc;
              mstTbl[devnr].stepcounter = lval;
            }
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if (setMotorTargetStepsFcn == NULL)
          {
            for (i=0; i<gNumMotors; i++) lvalArray[i] = (UINT32)mu2steps(devnr,mstTbl[i].tgtPosition);
            cc = PutValuesFromAny(dout,&mstTbl[0].tgtPosition,CF_DOUBLE,TRUE,sizeof(Motor),gNumMotors,devnr);
          }
          else
          {
            cc = PutValuesFromAny(dout,&mstTbl[0].stepcounter,CF_INT32,TRUE,sizeof(Motor),gNumMotors,devnr);
          }
          return cc;
        }
        return 0;
    case PRP_TARGET_MICROSTEPS:
        if (isGroupedCall) return illegal_device;
        if (isGroupedDevice) return illegal_device;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if ((cc=GetValuesAsLong(din,&lval,1)) != 0) return cc;
            if ((cc=setMotorTargetMicroPosition(devnr,lval)) != 0) return cc;
            mstTbl[devnr].tgtMicroPosition = lval;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromAny(dout,&mstTbl[0].tgtMicroPosition,CF_INT32,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_POSITION:
        if (access&CA_WRITE) 
        {
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength != 1) return dimension_error;
            if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
            if (isGroupedDevice || isGroupedCall) return not_allowed;
            cc = setMotorPosition(devnr,dval);
            if (cc != 0) return cc;
          }
          else
          {
            return illegal_read_write;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (isGroupedDevice) 
          { /* cut to the chase */
            if (getGroupMotorPositionFcn != NULL)
            { /* the motor plug will handle the call */
              dval = getGroupMotorPosition(grpid);
              return PutValuesFromDoubleEx(dout,&dval,1,0);
            }
            dout->dArrayLength = 1;
          }
          else if (isGroupedCall)
          { /* on-the-fly group: return them in the order specified */
            if (dout->dArrayLength != (UINT32)numInGroup) return dimension_error;
            for (i=0; i<numInGroup; i++) 
            {
              m = motorsInGroup[i];
              dvalArray[i] = mstTbl[m].position;
              return PutValuesFromDoubleEx(dout,dvalArray,numInGroup,0);
            }
          }
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromAny(dout,&mstTbl[0].position,CF_DOUBLE,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_VELOCITY_EGU: unitscat = "/sec";
    case PRP_ACCELERATION_EGU: if (unitscat == NULL) unitscat = "/sec^2";
    case PRP_MOVE_START_EGU:
    case PRP_INCR_MOVE_START_EGU:
    case PRP_FREE_MOVE_START_EGU:
    case PRP_LIMITS_VEL_LWR_EGU:
    case PRP_LIMITS_VEL_UPR_EGU:
    case PRP_LIMITS_ACC_UPR_EGU:
    case PRP_POSITION_EGU:
    case PRP_TARGET_POSITION_EGU:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          int nlen;
          if (dout->dArrayLength > (UINT32)(devnr + gNumMotors)) dout->dArrayLength = (UINT32)(devnr + gNumMotors);
          switch (dout->dFormat)
          {
            case CF_USTRING:
              for (i=0; i<(int)dout->dArrayLength; i++)
              {
                strncpy(((DUSTRING *)dout->data.vptr)[i].str,mstTbl[devnr+i].units.name,16);
                if (unitscat != NULL) strncat(((DUSTRING *)dout->data.vptr)[i].str,unitscat,6);
                ((DUSTRING *)dout->data.vptr)[i].f1val = (float)mstTbl[devnr+i].positionMinimum;
                ((DUSTRING *)dout->data.vptr)[i].f2val = (float)mstTbl[devnr+i].positionMaximum;
              }
              break;
            case CF_NAME16:
            case CF_NAME32:
            case CF_NAME48:
            case CF_NAME64:
              nlen = fmtsizeof(dout->dFormat);
              for (i=0; i<(int)dout->dArrayLength; i++)
              {
                strncpy(dout->data.cptr+i*nlen,mstTbl[devnr+i].units.name,10);
                if (unitscat != NULL) strncat(dout->data.cptr+i*nlen,unitscat,6);
              }
              break;
            default:
              return illegal_format;
          }
        }
        return 0;
    case PRP_INCR_MOVE_STATUS:
        if (isGroupedCall) return illegal_device;
        if (getIncrementMoveStatusFcn == NULL) return not_implemented;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=getIncrementMoveStatusFcn(devnr,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_INCR_MOVE_RESUME:
        if (isGroupedCall) return illegal_device;
        if (setIncrementMoveStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setIncrementMoveStatusFcn(devnr,PROC_STS_RESUME);
        }
        return cc;
    case PRP_INCR_MOVE_PAUSE:
        if (isGroupedCall) return illegal_device;
        if (setIncrementMoveStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setIncrementMoveStatusFcn(devnr,PROC_STS_PAUSE);
        }
        return cc;
    case PRP_INCR_MOVE_STOP:
        if (isGroupedCall) return illegal_device;
        if (setIncrementMoveStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setIncrementMoveStatusFcn(devnr,PROC_STS_STOP);
        }
        return cc;
    case PRP_INCR_MOVE_START:
        if (isGroupedCall) return illegal_device;
        if (setIncrementMoveStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
            dval += mstTbl[devnr].tgtPosition;
            if ((cc=setMotorTargetPosition(devnr,dval)) != 0) return cc;
            mstTbl[devnr].tgtPosition = dval;
            //millisleep(100);
          }
          cc = setIncrementMoveStatusFcn(devnr,PROC_STS_START);
        }
        return cc;
    case PRP_LIMITS_VEL_LWR:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=PutValuesFromDouble(dout,&mstTbl[devnr].limits[VEL_LWR_IDX],1)) != 0) return cc;
        }
        return 0;
    case PRP_LIMITS_VEL_UPR:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=PutValuesFromDouble(dout,&mstTbl[devnr].limits[VEL_UPR_IDX],1)) != 0) return cc;
        }
        return 0;
    case PRP_LIMITS_ACC_UPR:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=PutValuesFromDouble(dout,&mstTbl[devnr].limits[ACC_UPR_IDX],1)) != 0) return cc;
        }
        return 0;
    case PRP_GRP_MOVE_STATUS:
        if (getGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) return illegal_device;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=getGroupMoveStatusFcn(grpid,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_GRP_MOVE_PROGRESS:
        if (getGroupMoveProgressFcn == NULL) return not_implemented;
        if (!isGroupedCall) return illegal_device;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=getGroupMoveProgressFcn(grpid,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_GRP_MOVE_RESUME:
        if (setGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) return illegal_device;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setGroupMoveStatusFcn(grpid,PROC_STS_RESUME);
        }
        return cc;
    case PRP_GRP_MOVE_PAUSE:
        if (setGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) return illegal_device;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setGroupMoveStatusFcn(grpid,PROC_STS_PAUSE);
        }
        return cc;
    case PRP_GRP_MOVE_STOP:
        if (setGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) return illegal_device;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setGroupMoveStatusFcn(grpid,PROC_STS_STOP);
        }
        return cc;
    case PRP_GRP_MOVE_START:
        if (setGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) return illegal_device;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          { 
            if (din->dFormat == CF_TEXT)
            { /* input string */
              if ((mp=parseScanInputString(din->data.cptr,&dvals[0],&dvals[1])) == NULL) return invalid_reference;
              if ((cc=setGroupMotorTargetPosition(grpid,dvals[0])) != 0) return cc;
              if ((cc=setGroupGearRatio(grpid,dvals[1])) != 0) return cc;
            }
            else
            {
              if ((cc=GetValuesAsDouble(din,dvals,2)) != 0) return cc;
              if ((cc=setGroupMotorTargetPosition(grpid,dvals[0])) != 0) return cc;
              if (din->dArrayLength > 1)
              { /* gear ratio supplied in call */
                if ((cc=setGroupGearRatio(grpid,dvals[1])) != 0) return cc;
              }
            }
          }
          if (grpid >= MST_DYNAGRP_OFFST) 
          { /* dealing with a group ! */
            if ((dval=getGroupGearRatio(grpid)) == 0) 
            { /* have not yet set the gear ratio */
              dval = mstGroupTbl[grpnr].gearRatio;
              if (dval == 0) dval = mstGroupTbl[grpnr].members[0]->gearRatio;
              if (dval == 0) dval = 1;
              setGroupGearRatio(grpid,dval);
            }
          }
          if (isMonitorCall)
          { /* a "ScanMonitor" call */
            ms = &mstGroupTbl[grpnr].monScan;
            if (mp != NULL)
            { /* input given */
              if (ms->params == NULL) ms->params = mp;
              else memcpy(ms->params,mp,sizeof(MonitorParams));
            }
            if ((mp=ms->params) == NULL)
            { /* no known monitor parameters */
              return not_implemented;
            }
            ms = &mstGroupTbl[grpnr].monScan;
            if (mp->tmr < 100) mp->tmr = 100;
            dp = fabs(mstTbl[devnr].tgtPosition-mstTbl[devnr].position);
            if (dp == 0) dp = 1;
            v = mstTbl[devnr].velocity;
            if (v < 0.01) v = 0.01;
            blen = (int)((dp/v) * (1000.0/mp->tmr));
            if (blen < 10) blen = 10;
            ms->length = mp->len * blen * 2;
            ms->mot = devnr;
            if ((cc=startScanMonitor(ms)) != 0) return cc;
          }
          cc = setGroupMoveStatusFcn(grpid,PROC_STS_START);
        }
        return cc;
    
    case PRP_INCR_GRP_MOVE_STATUS:
        if (getGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) return illegal_device;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=getGroupMoveStatusFcn(grpid,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_INCR_GRP_MOVE_PROGRESS:
        if (getIncrementGroupMoveProgressFcn == NULL) return not_implemented;
        if (!isGroupedCall) return illegal_device;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=getIncrementGroupMoveProgressFcn(grpid,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_INCR_GRP_MOVE_RESUME:
        if (setIncrementGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) return illegal_device;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setIncrementGroupMoveStatusFcn(grpid,PROC_STS_RESUME);
        }
        return cc;
    case PRP_INCR_GRP_MOVE_PAUSE:
        if (setIncrementGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) return illegal_device;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setIncrementGroupMoveStatusFcn(grpid,PROC_STS_PAUSE);
        }
        return cc;
    case PRP_INCR_GRP_MOVE_STOP:
        if (setIncrementGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) return illegal_device;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setIncrementGroupMoveStatusFcn(grpid,PROC_STS_STOP);
        }
        return cc;
    case PRP_INCR_GRP_MOVE_START:
        if (setIncrementGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) return illegal_device;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
            if (isGroupedDevice) 
            { /* cut to the chase */
              dval += getGroupMotorTargetPosition(grpid);
            }
            else if (grpid >= MST_DYNAGRP_OFFST) 
            {
              dval += mstTbl[devnr].tgtPosition;
            }
            if ((cc=setGroupMotorTargetPosition(grpid,dval)) != 0) return cc;
          }
          cc = setIncrementGroupMoveStatusFcn(grpid,PROC_STS_START);
        }
        return cc;
    case PRP_STEP_STATUS:
        if (getStepToStatusFcn != NULL)
        {
          if (access&CA_WRITE) return illegal_read_write;
          if ((cc=getStepToStatusFcn(devnr,&lval)) != 0) return cc;
          return PutValuesFromLong(dout,&lval,1);
        }
    case PRP_MOVE_STATUS:
    case PRP_FREE_MOVE_STATUS:
    case PRP_FASTSCANMONITOR_STATUS:
        if (isGroupedCall) return illegal_device;
        if (getMoveToStatusFcn == NULL) return not_implemented;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=getMoveToStatusFcn(devnr,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_SCANMONITOR_STATUS:
        if (isGroupedCall) return illegal_device;
        if (getStepToStatusFcn == NULL) return not_implemented;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=getStepToStatusFcn(devnr,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_STEP_PROGRESS:
        if (getStepToProgressFcn != NULL)
        {
          if (access&CA_WRITE) return illegal_read_write;
          if (dout->dArrayLength != 1) return dimension_error;
          if ((cc=getStepToProgressFcn(devnr,&lval)) != 0) return cc;
          return PutValuesFromLong(dout,&lval,1);
        }
    case PRP_MOVE_PROGRESS:
    case PRP_FREE_MOVE_PROGRESS:
    case PRP_FASTSCANMONITOR_PROGRESS:
        if (isGroupedCall) return illegal_device;
        if (getMoveToProgressFcn == NULL) return not_implemented;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=getMoveToProgressFcn(devnr,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_SCANMONITOR_PROGRESS:
        if (isGroupedCall) return illegal_device;
        if (getStepToProgressFcn == NULL) return not_implemented;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          ms = &mstTbl[devnr].monScan;
          if ((mp=ms->params) == NULL) return code_failure;
          lval = (ms->length - mp->idx) * 100;
          lval /= ms->length;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_STEP_RESUME:
        if (setStepToStatusFcn != NULL)
        {
          if (!(access&CA_WRITE)) return illegal_read_write;
          return setStepToStatusFcn(devnr,PROC_STS_RESUME);
        }
    case PRP_MOVE_RESUME:
    case PRP_FASTSCANMONITOR_RESUME:
        if (isGroupedCall) return illegal_device;
        if (setMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setMoveToStatusFcn(devnr,PROC_STS_RESUME);
        }
        return cc;
    case PRP_SCANMONITOR_RESUME:
        if (isGroupedCall) return illegal_device;
        if (setMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          gPauseStepScan = FALSE;
          return 0;
        }
        return cc;
    case PRP_STEP_PAUSE:
        if (setStepToStatusFcn != NULL)
        {
          if (!(access&CA_WRITE)) return illegal_read_write;
          return setStepToStatusFcn(devnr,PROC_STS_PAUSE);
        }
    case PRP_MOVE_PAUSE:
    case PRP_FASTSCANMONITOR_PAUSE:
        if (isGroupedCall) return illegal_device;
        if (setMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setMoveToStatusFcn(devnr,PROC_STS_PAUSE);
        }
        return cc;
    case PRP_SCANMONITOR_PAUSE:
        if (isGroupedCall) return illegal_device;
        if (setMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          gPauseStepScan = TRUE;
          return 0;
        }
        return cc;
    case PRP_MOVE_STOP:
    case PRP_FASTSCANMONITOR_STOP:
        if (isGroupedCall) return illegal_device;
        if (setMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setMoveToStatusFcn(devnr,PROC_STS_STOP);
        }
        return cc;
    case PRP_SCANMONITOR_STOP:
        if (isGroupedCall) return illegal_device;
        if (setStepToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          gAbortStepScan = TRUE;
          return 0;
        }
        return cc;
    case PRP_FASTSCANMONITOR_START:
        monitorStepScan = FALSE;
    case PRP_MOVE_START:
    case PRP_SCANMONITOR_START:
        if (isGroupedCall) return illegal_device;
        if (setMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if (din->dFormat == CF_TEXT)
            { /* input string */
              dval = mstTbl[devnr].tgtPosition;
              if ((mp=parseScanInputString(din->data.cptr,&dval,NULL)) == NULL) return invalid_reference;
            }
            else
            {
              if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
            }
            if ((cc=setMotorTargetPosition(devnr,dval)) != 0) return cc;
            mstTbl[devnr].tgtPosition = dval;
          }
          if (grpid >= 0) 
          { /* dealing with a group ! */
            if ((dval=getGroupGearRatio(grpid)) == 0) 
            { /* have not yet set the gear ratio */
              dval = mstGroupTbl[grpnr].gearRatio;
              if (dval == 0) dval = mstGroupTbl[grpnr].members[0]->gearRatio;
              if (dval == 0) dval = 1;
              setGroupGearRatio(grpid,dval);
            }
          }
          if (isMonitorCall)
          { /* a "ScanMonitor" call */
            ms = &mstTbl[devnr].monScan;
            if (monitorStepScan && ms->isStepping)
            {
              return operation_busy;
            }
            ms->lastPos = mstTbl[devnr].position;
            ms->isStepping = monitorStepScan;
            if (mp != NULL)
            { /* input given */
              if (ms->params == NULL) ms->params = mp;
              else memcpy(ms->params,mp,sizeof(MonitorParams));
            }
            if ((mp=ms->params) == NULL)
            { /* no known monitor parameters */
              return not_implemented;
            }
            if (mp->tmr < 100) mp->tmr = 100;
            dp = fabs(mstTbl[devnr].tgtPosition-mstTbl[devnr].position);
            if (dp == 0) dp = 1;
            if (monitorStepScan)
            {
              blen = (int)((dp * mstTbl[devnr].spmu) * (1000.0/mp->tmr));
            }
            else
            {
              v = mstTbl[devnr].velocity;
              if (v < 0.01) v = 0.01;
              blen = (int)((dp/v) * (1000.0/mp->tmr));
            }
            if (blen < 10) blen = 10;
            ms->length = mp->len * blen * 2;
            ms->tgtPos = mstTbl[devnr].tgtPosition;
            ms->mot = devnr;
            if ((cc=startScanMonitor(ms)) != 0) return cc;
            if (monitorStepScan) return 0;
          }
          cc = setMoveToStatusFcn(devnr,PROC_STS_START);
        }
        return cc;
    case PRP_SCANMONITOR:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength < 32) return dimension_error;
        if (dout->dFormat != CF_TEXT) return illegal_format;
        if (grpid >= 0) 
        { /* dealing with a group ! */
          if ((mp=mstGroupTbl[grpnr].monScan.params) == NULL) return not_implemented;
        }
        else
        {
          if ((mp=mstTbl[devnr].monScan.params) == NULL) return not_implemented;
        }
        sprintf(sfn,"-m=%.132s[%.64s] -s=%d -f=%.8s -t=%d -d=%d -i=%d",
          mp->dev,mp->prp,mp->len,GetFormatAsString(mp->fmt),mp->tmr,mp->dly,mp->inc);
        strncpy(dout->data.cptr,sfn,dout->dArrayLength);
        dout->dArrayLength = (UINT32)strlen(sfn);
        return 0;
    case PRP_SCANMONITOR_X:
    case PRP_SCANMONITOR_Y:
        if (access&CA_WRITE) return illegal_read_write;
        if (grpid >= 0) 
        { /* dealing with a group ! */
          if ((mp=mstGroupTbl[grpnr].monScan.params) == NULL) return not_implemented;
          xScanAxis = mstGroupTbl[grpnr].monScan.xAxis;
          yScanAxis = mstGroupTbl[grpnr].monScan.yAxis;
          blen = mstGroupTbl[grpnr].monScan.length;
        }
        else
        {
          if ((mp=mstTbl[devnr].monScan.params) == NULL) return not_implemented;
          xScanAxis = mstTbl[devnr].monScan.xAxis;
          yScanAxis = mstTbl[devnr].monScan.yAxis;
          blen = mstTbl[devnr].monScan.length;
        }
        if (xScanAxis == NULL || yScanAxis == NULL) return un_allocated;
        if (dout->dArrayLength > 1)
        {
          if (prpid == PRP_SCANMONITOR_X)
          { 
            cc = PutValuesFromDouble(dout,xScanAxis,blen);
          }
          else
          { /* y parameters can be double dimensioned ! */
            idx = 0;
            if (din->dArrayLength > 0)
            {
              if ((cc=GetValuesAsLong(din,&idx,1)) != 0) return cc;
            }
            if ((alen=mp->len) < 1) return configuration_error;
            cc = PutValuesFromAny(dout,yScanAxis,CF_DOUBLE,1,alen*sizeof(double),blen,idx);
          }
          dout->dArrayLength = blen;
          return cc;
        }
        return 0;
    case PRP_SAVESCANMONITOR:
        if ((access&CA_WRITE) == 0) return illegal_read_write;
        if ((cc=GetValuesAsStringEx(din,sfn,CF_TEXT,256,0)) != 0) return cc;
        if (grpid >= 0) 
        { /* dealing with a group ! */
          ms = &mstGroupTbl[grpnr].monScan;
        }
        else
        {
          ms = &mstTbl[devnr].monScan;
        }
        cc = saveScanFileDataEx(sfn,ms);
        return cc;
    case PRP_FREE_MOVE_RESUME:
        if (isGroupedCall) return illegal_device;
        if (setFreeMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setFreeMoveToStatusFcn(devnr,PROC_STS_RESUME);
        }
        return cc;
    case PRP_FREE_MOVE_PAUSE:
        if (isGroupedCall) return illegal_device;
        if (setFreeMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setFreeMoveToStatusFcn(devnr,PROC_STS_PAUSE);
        }
        return cc;
    case PRP_FREE_MOVE_STOP:
        if (isGroupedCall) return illegal_device;
        if (setFreeMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setFreeMoveToStatusFcn(devnr,PROC_STS_STOP);
        }
        return cc;
    case PRP_FREE_MOVE_START:
        if (isGroupedCall) return illegal_device;
        if (setFreeMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
            if ((cc=setMotorTargetPosition(devnr,dval)) != 0) return cc;
            mstTbl[devnr].tgtPosition = dval;
          }
          cc = setFreeMoveToStatusFcn(devnr,PROC_STS_START);
        }
        return cc;
    case PRP_STEP_START:
        if (isGroupedCall) return illegal_device;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          if (setStepToStatusFcn != NULL)
          { // a dedicated stepping function has been registered
            if (din->dArrayLength > 0)
            {
              if ((cc=GetValuesAsLong(din,&lval,1)) != 0) return cc;
              if ((cc=setMotorTargetSteps(devnr,lval)) != 0) return cc;
              mstTbl[devnr].stepcounter = lval;
            }
            cc = setStepToStatusFcn(devnr,PROC_STS_START);
          }
          else if (setMoveToStatusFcn != NULL)
          { // no stepping function: use the moving function
            if (din->dArrayLength > 0)
            {
              if ((cc=GetValuesAsLong(din,&lval,1)) != 0) return cc;
              dval = steps2mu(devnr,lval);
              if ((cc=setMotorTargetPosition(devnr,dval)) != 0) return cc;
              mstTbl[devnr].tgtPosition = dval;
            }
            cc = setMoveToStatusFcn(devnr,PROC_STS_START);
          }
        }
        return cc;
    case PRP_STEPSIZE:
        if (access&CA_WRITE)
        {
          if (setMotorTargetStepSizeFcn != NULL)
          {
            if ((cc=GetValuesAsDouble(din, &dval, 1)) != 0) return cc;
            if ((cc=setMotorTargetStepSizeFcn(devnr, dval)) != 0) return cc;
          }
          else return not_implemented;
        }
        if (dout->dArrayLength > 0)
        {
          if (getMotorTargetStepSizeFcn != NULL)
          {
            if ((cc = getMotorTargetStepSizeFcn(devnr, &dval)) != 0) return cc;
            return PutValuesFromDoubleEx(dout, &dval, 1, 0);
          }
        }
        return not_implemented;
    case PRP_CTRL_GRP_MOVE_STATUS:
        if (getControlGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) return illegal_device;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=getControlGroupMoveStatusFcn(grpid,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_CTRL_GRP_MOVE_PROGRESS:
        if (getControlGroupMoveProgressFcn == NULL) return not_implemented;
        if (!isGroupedCall) return illegal_device;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=getControlGroupMoveProgressFcn(grpid,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_CTRL_GRP_MOVE_RESUME:
        if (setControlGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) return illegal_device;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setControlGroupMoveStatusFcn(grpid,PROC_STS_RESUME);
        }
        return cc;
    case PRP_CTRL_GRP_MOVE_PAUSE:
        if (setControlGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) return illegal_device;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setControlGroupMoveStatusFcn(grpid,PROC_STS_PAUSE);
        }
        return cc;
    case PRP_CTRL_GRP_MOVE_STOP:
        if (setControlGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) return illegal_device;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setControlGroupMoveStatusFcn(grpid,PROC_STS_STOP);
        }
        return cc;
    case PRP_CTRL_GRP_MOVE_START:
        if (setControlGroupMoveStatusFcn == NULL) return not_implemented;
        if (!isGroupedCall) return illegal_device;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setControlGroupMoveStatusFcn(grpid,PROC_STS_START);
        }
        return cc;  
    case PRP_SAVESCAN:
        if (getScanMoveToStatusFcn == NULL) return not_implemented;
        if ((access&CA_WRITE) == 0) return illegal_read_write;
        if ((cc=GetValuesAsStringEx(din,sfn,CF_TEXT,256,0)) != 0) return cc;
        memset(&dscan,0,sizeof(DTYPE));
        dscan.dArrayLength = 10000;
        dscan.dFormat = CF_FLOAT;
        dscan.data.fptr = scanbuffer;
        if (isGroupedCall) 
        {
          if (getScanGroupMoveToStatusFcn == NULL) return not_implemented;
          cc = getScanGroupMoveToStatusFcn(grpid,&dscan);
        }
        else
        {
          if ((cc=getScanMoveToStatusFcn(devnr,&dscan)) != 0) return cc;
        }
        cc = saveScanFileData(sfn,scanbuffer,dscan.dArrayLength);
        return cc;
    case PRP_GETSCANFILELIST:
        if ((access&CA_WRITE) == 0) return illegal_read_write;
        if (dout->dArrayLength < 1) return dimension_error;
        if (dout->dFormat != CF_NAME64) return illegal_format;
        cc = getScanFileSet((NAME64 *)dout->data.vptr,&dout->dArrayLength);
        return cc;
    case PRP_GETSCAN_X:
    case PRP_GETSCAN_Y:
        if ((access&CA_WRITE) == 0) return illegal_read_write;
        if ((cc=GetValuesAsStringEx(din,sfn,CF_TEXT,256,0)) != 0) return cc;
        if (dout->dArrayLength < 1) return dimension_error;
        if (dout->dFormat != CF_FLOAT) return illegal_format;
        tag = (prpid == PRP_GETSCAN_X) ? "X-AXIS" : "Y-AXIS";
        if ((cp=strchr(sfn,' ')) != NULL) *cp++ = 0;
        idx = 0;
        if (!strcmp(tag,"Y-AXIS") && cp != NULL)
        {
          idx = atoi(cp);
        }
        cc = getScanFileData(sfn,tag,dout->data.fptr,&dout->dArrayLength,idx);
        return cc;
    case PRP_SCANMOVE_X:
    case PRP_SCANMOVE_Y:
        if (getScanMoveToStatusFcn == NULL) return not_implemented;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 1)
        {
          dscan.dArrayLength = 10000;
          dscan.dFormat = CF_FLOAT;
          dscan.data.fptr = scanbuffer;
          if (isGroupedCall) 
          {
            if (getScanGroupMoveToStatusFcn == NULL) return not_implemented;
            cc = getScanGroupMoveToStatusFcn(grpid,&dscan);
          }
          else
          {
            cc = getScanMoveToStatusFcn(devnr,&dscan);
          }
          if (cc != 0) return cc;
          blen = (int)dscan.dArrayLength/2;
          if (blen < (int)dout->dArrayLength) dout->dArrayLength = (UINT32)blen;
          if (prpid == PRP_SCANMOVE_X)
          { /* x-axis is the first part */
            cc = PutValuesFromFloat(dout,dscan.data.fptr,blen);
          }
          else
          { /* y-axis is the second part */
            cc = PutValuesFromFloat(dout,&dscan.data.fptr[blen],blen);
          }
          return cc;
        }
        return 0;
    case PRP_SCANMOVE_STATUS:
        if (getScanMoveToStatusFcn == NULL) return not_implemented;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (isGroupedCall) 
          {
            if (getScanGroupMoveToStatusFcn == NULL) return not_implemented;
            cc = getScanGroupMoveToStatusFcn(grpid,dout);
          }
          else
          {
            if ((cc=getScanMoveToStatusFcn(devnr,dout)) != 0) return cc;
          }
        }
        return 0;
    case PRP_SCANMOVE_PAUSE:
        if (setScanMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          if (isGroupedCall) 
          {
            if (setScanGroupMoveToStatusFcn == NULL) return not_implemented;
            cc = setScanGroupMoveToStatusFcn(grpid,PROC_STS_PAUSE,NULL);
          }
          else
          {
            cc = setScanMoveToStatusFcn(devnr,PROC_STS_PAUSE,NULL);
          }
        }
        return cc;
    case PRP_SCANMOVE_PROGRESS:
        if (getScanMoveToProgressFcn == NULL) return not_implemented;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=getScanMoveToProgressFcn(devnr,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_SCANMOVE_RESUME:
        //if (isGroupedCall) return illegal_device;
        if (setScanMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          if (isGroupedCall) 
          {
            if (setScanGroupMoveToStatusFcn == NULL) return not_implemented;
            cc = setScanGroupMoveToStatusFcn(grpid,PROC_STS_RESUME,din);
          }
          else
          {
            cc = setScanMoveToStatusFcn(devnr,PROC_STS_RESUME,din);
          }
        }
        return cc;
    case PRP_SCANMOVE_STOP:
        if (setScanMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          if (isGroupedCall) 
          {
            if (setScanGroupMoveToStatusFcn == NULL) return not_implemented;
            cc = setScanGroupMoveToStatusFcn(grpid,PROC_STS_STOP,NULL);
          }
          else
          {
            cc = setScanMoveToStatusFcn(devnr,PROC_STS_STOP,NULL);
          }
        }
        return cc;
    case PRP_SCANMOVE_START:
        if (setScanMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          if (isGroupedCall) 
          {
            if (setScanGroupMoveToStatusFcn == NULL) return not_implemented;
            cc = setScanGroupMoveToStatusFcn(grpid,PROC_STS_START,din);
          }
          else
          {
            cc = setScanMoveToStatusFcn(devnr,PROC_STS_START,din);
          }
        }
        return cc;    
    case PRP_ACCELERATION:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength > 1) return dimension_error;
            if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
            if (dval > mstTbl[devnr].limits[ACC_UPR_IDX]) return out_of_range;
            if (dval < 0) return out_of_range;
            cc = setMotorAcceleration(devnr,dval);
            if (cc == 0) mstTbl[devnr].acceleration = dval; else return cc;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromAny(dout,&mstTbl[0].acceleration,CF_DOUBLE,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_VELOCITY:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength > 1) return dimension_error;
            if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
            if (dval > mstTbl[devnr].limits[VEL_UPR_IDX]) return out_of_range;
            if (dval < mstTbl[devnr].limits[VEL_LWR_IDX]) return out_of_range;
            cc = setMotorVelocity(devnr,dval);
            if (cc == 0) mstTbl[devnr].velocity = dval; else return cc;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromAny(dout,&mstTbl[0].velocity,CF_DOUBLE,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_CURRENT:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength > 1) return dimension_error;
            if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
            if ((cc=setMotorCurrent(devnr,dval)) != 0) return cc;
            mstTbl[devnr].current = dval;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromAny(dout,&mstTbl[0].current,CF_DOUBLE,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_ROTATIONMOVEALLOWED:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength > 1) return dimension_error;
            if ((cc=GetValuesAsLong(din,&lval,1)) != 0) return cc;
            mstTbl[devnr].rotationmoveallowed = lval;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromAny(dout,&mstTbl[0].rotationmoveallowed,CF_INT32,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_MICROSTEP:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE)
        {
          if (setMicroMoveStatusFcn == NULL) return not_implemented;
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength > 1) return dimension_error;
            if ((cc=GetValuesAsLong(din,&lval,1)) != 0) return cc;
            if (lval > PRP_MICROSTEP_UPR_LIMIT) return out_of_range;
            if (lval < PRP_MICROSTEP_LWR_LIMIT) return out_of_range;
            if ((cc=setMotorTargetMicroPosition(devnr,lval)) != 0) return cc;
          }
          else
          {
            lval = mstTbl[devnr].tgtMicroPosition + 1;
          }
          if ((cc=setMotorTargetMicroPosition(devnr,lval)) != 0) return cc;
          mstTbl[devnr].tgtMicroPosition = lval;
          if ((cc=setMicroMoveStatusFcn(devnr,PROC_STS_START)) != 0) return cc;
        }
        return 0;
    case PRP_MICROSTEPCOUNTER:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength > 1) return dimension_error;
            if ((cc=GetValuesAsLong(din,&lval,1)) != 0) return cc;
            if (lval > PRP_STEPCOUNTER_UPR_LIMIT) return out_of_range;
            if (lval < PRP_STEPCOUNTER_LWR_LIMIT) return out_of_range;
            mstTbl[devnr].microstepcounter = lval;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromAny(dout,&mstTbl[0].microstepcounter,CF_INT32,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_STEPCOUNTER:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength > 1) return dimension_error;
            if ((cc=GetValuesAsLong(din,&lval,1)) != 0) return cc;
            if (lval > PRP_STEPCOUNTER_UPR_LIMIT) return out_of_range;
            if (lval < PRP_STEPCOUNTER_LWR_LIMIT) return out_of_range;
            mstTbl[devnr].stepcounter = lval;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromAny(dout,&mstTbl[0].stepcounter,CF_INT32,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_STATUSBIT_LIST:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if ((cc=PutValuesFromString(dout,(char *)mstStsList,CF_NAME32,sizMstStsList,0)) != 0) return cc;
        }
        return 0;
    case PRP_LIMITS_POS_LWR:
        if (access&CA_WRITE) return illegal_read_write;
        if (isGroupedCall) return illegal_device;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromAny(dout,&mstTbl[0].positionMinimum,CF_DOUBLE,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_LIMITS_POS_UPR:
        if (access&CA_WRITE) return illegal_read_write;
        if (isGroupedCall) return illegal_device;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromAny(dout,&mstTbl[0].positionMaximum,CF_DOUBLE,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_POSITION_OFFSET:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE) 
        {
          if (setMotorPositionOffsetFcn == NULL) return illegal_read_write;
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength != 1) return dimension_error;
            if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
            if ((cc=setMotorPositionOffset(devnr,dval)) != 0) return cc;
            acquireStaticMotorInfo(devnr);
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromAny(dout,&mstTbl[0].positionOffset,CF_DOUBLE,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_POSITION_SCALE:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE) 
        {
          if (setMotorPositionScaleFcn == NULL) return illegal_read_write;
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength != 1) return dimension_error;
            if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
            if ((cc=setMotorPositionScale(devnr,dval)) != 0) return cc;
            acquireStaticMotorInfo(devnr);
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromAny(dout,&mstTbl[0].positionScale,CF_DOUBLE,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_LASTHDWERR:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          for (i=0; i<(int)dout->dArrayLength && (devnr+i)<gNumMotors; i++)
          {
            switch (dout->dFormat)
            {
              case CF_NAME64I: 
                cc = getLastHardwareError(devnr+i,(NAME64 *)((NAME64I *)dout->data.vptr)[i].name,&((NAME64I *)dout->data.vptr)[i].ival);
                break;
              case CF_NAME64: 
                cc = getLastHardwareError(devnr+i,&((NAME64 *)dout->data.vptr)[i],NULL);
                break;
              case CF_INT32:
                cc = getLastHardwareError(devnr+i,NULL,&dout->data.lptr[i]);
                break;
              default:
                return illegal_format;
            }
            if (cc != 0) return cc;
          }
          dout->dArrayLength = (UINT32)i;
        }
        return 0;
    default:
        if (!isGroupedCall && xmaDispatch != NULL)
        {
          return xmaDispatch(devName,devProperty,dout,din,access);
        }
        return illegal_property;
  }
}
