/*
 * smpeqm.c    REVISION HISTORY:
 * Generated by SRVWIZARD on Mon Dec 18 15:39:21 2006
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#ifdef WIN32
# include "direct.h"
char *delStr = "\\";
#else
# include "dirent.h"
char *delStr = "/";
#endif
#include "tine.h"
#include "smpeqm.h"
#include "smplib.h"

SmarPodMotor mstTbl[NUM_MSTEQM_DEVICES];

short g_IncrementMoveIdleCondition;
short g_IncrementMoveProcessLevel;
short g_IncrementMoveNumProcessSteps = 5;
short g_GroupMoveIdleCondition;
short g_GroupMoveProcessLevel;
short g_GroupMoveNumProcessSteps = 1;
short g_MoveToIdleCondition;
short g_MoveToProcessLevel;
short g_MoveToNumProcessSteps = 5;
double g_runcurrent;

int motorServerInitialized = FALSE;
int gNumMotors = 0;
NAME64 *gMotorNames = NULL;
char gMotorServerExportName[EXPORT_NAME_SIZE] = "MotorSteering";
char gMotorServerContext[CONTEXT_NAME_SIZE] = "TEST";
char gMotorServerGroup[EXPORT_NAME_SIZE] = "";
int gMotorGroupMetric = 0;
void loadMotorLib(void);
void initializedMotorServer(void);

CSVCOLUMN csvMstMonitorInfoConfigColumns[] =
{
  { "MOTOR_NAME","",0,CF_TEXT,DEVICE_NAME_SIZE,(BYTE *)OFFSETIN(MonitorInfo,nam),NULL,0 },
  { "MONITOR_DEVICE","",0,CF_TEXT,132,(BYTE *)OFFSETIN(MonitorInfo,dev),NULL,0 },
  { "MONITOR_PROPERTY","",0,CF_TEXT,PROPERTY_NAME_SIZE,(BYTE *)OFFSETIN(MonitorInfo,prp),NULL,0 },
  { "MONITOR_FORMAT","float",0,CF_TEXT,16,(BYTE *)OFFSETIN(MonitorInfo,fmt),NULL,0 },
  { "MONITOR_SIZE","1",0,CF_INT32,1,(BYTE *)OFFSETIN(MonitorInfo,len),NULL,0 },
  { "MONITOR_TIMER","1000",0,CF_INT32,1,(BYTE *)OFFSETIN(MonitorInfo,tmr),NULL,0 },
  { "STEP_DELAY","100",0,CF_INT32,1,(BYTE *)OFFSETIN(MonitorInfo,dly),NULL,0 },
  { "STEP_INCREMENT","1000",0,CF_INT32,1,(BYTE *)OFFSETIN(MonitorInfo,inc),NULL,0 },
};
CSVDB csvMstMonitorInfoConfigDb =
{
  csvMstMonitorInfoConfigColumns,
  sizeof(csvMstMonitorInfoConfigColumns)/sizeof(csvMstMonitorInfoConfigColumns[0]),
  0,
  csvStdInit,
  csvStdIterator,
  csvStdExit,
  0,
  NULL,
  sizeof(MonitorInfo),
  0
};

CSVCOLUMN csvMstGroupInfoConfigColumns[] =
{
  { "GROUP_NAME","Group",0,CF_TEXT,DEVICE_NAME_SIZE,(BYTE *)OFFSETIN(MstGroupInfoStruct,name),NULL,0 },
  { "GROUP_ID","-1",0,CF_INT32,1,(BYTE *)OFFSETIN(MstGroupInfoStruct,groupId),NULL,0 },
  { "MOTOR_NUMBER","",0,CF_INT32,1,(BYTE *)OFFSETIN(MstGroupInfoStruct,motorNr),NULL,0 },
  { "GEAR_RATIO","1",0,CF_FLOAT,1,(BYTE *)OFFSETIN(MstGroupInfoStruct,gearRatio),NULL,0 },
  { "SCALE","1",0,CF_FLOAT,1,(BYTE *)OFFSETIN(MstGroupInfoStruct,scale),NULL,0 },
  { "OFFSET","1",0,CF_FLOAT,1,(BYTE *)OFFSETIN(MstGroupInfoStruct,offset),NULL,0 },
  { "WEIGHT","1",0,CF_FLOAT,1,(BYTE *)OFFSETIN(MstGroupInfoStruct,weight),NULL,0 },
};
CSVDB csvMstGroupInfoConfigDb =
{
  csvMstGroupInfoConfigColumns,
  sizeof(csvMstGroupInfoConfigColumns)/sizeof(csvMstGroupInfoConfigColumns[0]),
  0,
  csvStdInit,
  csvStdIterator,
  csvStdExit,
  0,
  NULL,
  sizeof(MstGroupInfoStruct),
  0
};

MstGroupDevice *mstGroupTbl = NULL;
int mstGroupTblSize = 0;
extern char gMotorLib[256];
extern char gMstFecName[32];
extern int gMstFecPortOffset;
extern int gIsSmarPod;
float *scanbuffer = NULL;
char scanFilesPath[256] = "../SCANFILES";
int makeDirPath(char *fname)
{
# if defined(UNIX)
  DIR *dp;
# elif defined(WIN32)
  char fn[256];
  struct _finddata_t fp;
# endif
  char *c,tmpname[256],dirname[256];

  strncpy(tmpname,fname,256); dirname[0] = 0;
  for (c=strtok(tmpname,delStr); c != NULL; c=strtok(NULL,delStr))
  {
    strcat(dirname,c);
    if (!strncmp(dirname,fname,256)) /* okay the directory should be there */
    {
      return 0;
    }
    strcat(dirname,delStr);
#   if defined(UNIX)
    if ((dp=opendir(dirname)) != NULL) 
    {
      closedir(dp);
    }
    else
    {
      if (mkdir(dirname,S_IWUSR|S_IRUSR|S_IXUSR|S_IWGRP|S_IRGRP|S_IXGRP|S_IROTH|S_IXOTH)) return 0;
    }
#   elif defined(WIN32)
    sprintf(fn,"%s*.*",dirname);
    if (_findfirst(fn, &fp) == -1)
    {
      if (mkdir(dirname)) return 0;
    }
#   endif
  }
  return -1;
}
int saveScanFileDataEx(const char *fn,MonitorScan *ms)
{
  FILE *fp=NULL;
  int i, k, len, cc = 0;
  char *c, *fnp, filename[512];
  MonitorParams *mp = NULL;

  if (ms == NULL || fn == NULL) ccerr(invalid_parameter);
  if ((len=ms->length) == 0) ccerr(dimension_error);
  if (ms->xAxis == NULL || ms->yAxis == NULL) ccerr(not_implemented);
  if ((mp=ms->params) == NULL) ccerr(not_implemented);
  fnp = (char *)fn;
  if ((c=strstr(fnp,scanFilesPath)) != NULL) fnp = c + strlen(scanFilesPath);
  sprintf(filename,"%.255s%s%.255s",scanFilesPath,delStr,fnp);
  if ((c=strrchr(filename,'.')) == NULL || stricmp(c,".csv") != 0) strcat(filename,".csv");
  makeDirPath(filename);
  if ((fp=fopen(filename,"w")) == NULL) ccerr(file_error);
  fprintf(fp,"X-Axis, Y-Axis\n");
  for (i=0; i<len; i++)
  {
    fprintf(fp,"%g,",ms->xAxis[i]);
    for (k=0; k<mp->len; k++) fprintf(fp," %g",ms->yAxis[k+i*mp->len]);
    fprintf(fp,"\n");
  }
err:
  if (fp != NULL) fclose(fp);
  return cc;
}
int saveScanFileData(const char *fn,float *buf,int buflen)
{
  FILE *fp=NULL;
  int i, cc = 0;
  char *c, *fnp, filename[512];

  if (buf == NULL || fn == NULL) ccerr(invalid_parameter);
  if (buflen == 0) ccerr(dimension_error);
  fnp = (char *)fn;
  if ((c=strstr(fnp,scanFilesPath)) != NULL) fnp = c + strlen(scanFilesPath);
  sprintf(filename,"%.255s%s%.255s",scanFilesPath,delStr,fnp);
  if ((c=strrchr(filename,'.')) == NULL || stricmp(c,".csv") != 0) strcat(filename,".csv");
  makeDirPath(filename);
  if ((fp=fopen(filename,"w")) == NULL) ccerr(file_error);
  fprintf(fp,"X-Axis, Y-Axis\n");
  for (i=0; i<buflen/2; i++)
  {
    fprintf(fp,"%g, %g\n",buf[i],buf[i+buflen/2]);
  }

err:
  if (fp != NULL) fclose(fp);
  return cc;
}
int getScanFileData(const char *fn,const char *colhdr,float *buf,int *buflen,int index)
{
  FILE *fp=NULL;
  int i = 0, k, done = 0, cc = 0, limit;
  char *c,*cp=NULL,str[1024],scratch[512];
  int col = -1;
  float fval = 0;
  char filename[512];

  if (buf == NULL || colhdr == NULL || buflen == NULL || fn == NULL) ccerr(invalid_parameter);
  if (buflen == 0) ccerr(dimension_error);
  sprintf(filename,"%.255s%s%.255s",scanFilesPath,delStr,fn);
  if ((c=strrchr(filename,'.')) == NULL || stricmp(c,".csv") != 0) strcat(filename,".csv");
  if ((fp=fopen(filename,"r")) == NULL) ccerr(file_error);
  limit = *buflen;
  while (fgets(str,1024,fp) != NULL )
  {
    if (strlen(str) == 0) continue;
    if (strchr("%;#\n",str[0])) continue;      /* comment line(s) */
    if (!done)
    {
      if ((col=GetCsvColumnIndex(str,colhdr)) < 0) ccerr(no_such_line);
      done = 1;
      continue;
    }    
    if (i < limit)
    {
      strncpy(scratch,GetCsvColumnString(col,str),512);
      if (index > 0)
      {
        for (c=strtok_r(scratch," ",&cp), k=0; c != NULL; c=strtok_r(NULL," ",&cp), k++)
        {
          fval = (float)strtod(c,NULL);
          if (k >= index) break;
        }
      }
      else
      {
        fval = (float)strtod(scratch,&cp);
      }
      buf[i++] = fval;
    }
    else
    {
      break;
    }
  }
  *buflen = i;
err:
  if (fp != NULL) fclose(fp);
  return cc;
}
int getScanFileSet(NAME64 *files,int *nfiles)
{
# define fpat ".csv"
  int i=0, maxfiles;
  char dirname[128];
# if defined(UNIX)
  DIR *dp;
  struct dirent *dirp;
# elif defined(WIN32)
  struct _finddata_t fd;
# ifndef OS_64BIT
  long hfp;
# else
  intptr_t hfp;
# endif
# endif

  if (files == NULL || nfiles == NULL) return argument_list_error;
  maxfiles = *nfiles;
  *nfiles = 0;
# if defined(UNIX)
  strncpy(dirname,scanFilesPath,96); dirname[96] = 0;
  if ((dp=opendir(dirname)) == NULL) return no_such_file;
  while ((dirp=readdir(dp)) != NULL)
  {
    if (strstr(dirp->d_name,fpat) == NULL) continue;
    strncpy(files[i].name,dirp->d_name,64);
# elif defined(WIN32)
  sprintf(dirname,"%s\\*.*",scanFilesPath);
  if ((hfp=_findfirst(dirname, &fd)) == -1) return no_such_file;
  do
  {
    if (strstr(fd.name,fpat) == NULL) continue;
    strncpy(files[i].name,fd.name,64);
# endif
    if (++i == maxfiles) break;
# if defined(UNIX)
  }
  closedir(dp);
# elif defined(WIN32)
  } while (_findnext(hfp,&fd) != -1);
# endif
  *nfiles = i;
  return 0;
}

void PreSystemInit(void)
{
  int slen;
  char usrnam[32];
  char *usr = getenv("USERNAME");
  char *sfp = getenv("MST_SCANFILE_PATH");
  if (usr == NULL)
  {
    usr = "UNKNOWN";
  }
  strncpy(usrnam,usr,32);
  if (strlen(gMstFecName) > 0)
  { /* passed at the command line (so register FEC info here) */
    RegisterFecInformation(gMstFecName,"MST",gMotorServerContext,
      "Motor Steering server","","CDI",usrnam,(UINT16)gMstFecPortOffset);
  }
  if (sfp != NULL) 
  {
    strncpy(scanFilesPath,sfp,256);
    if ((slen=strlen(scanFilesPath)) > 0)
    {
      if (scanFilesPath[slen-1] == FS_DELIMITER) scanFilesPath[slen-1] = 0;
    }
  }
}

void PostSystemInit(void)
{
  registerStructs();
  RegisterEquipmentModule(gMotorServerExportName,MSTEQM_TAG,NUM_MSTEQM_DEVICES,smpeqm,smpeqm_ini,smpeqm_bkg,MSTEQM_RATE,smpeqm_exi);
  SetExportedContext(MSTEQM_TAG,gMotorServerContext);
  if (strlen(gMotorServerGroup) > 0)
  {
    JoinEquipmentGroup(MSTEQM_TAG,gMotorServerGroup,gMotorGroupMetric);
  }
  loadMotorLib();
  SetEnforceMultiChannelAccess(FALSE);
}

void smpeqm_bkg(void)
{
  int i,ival;

  if (!FecIsInitialized()) return;
  if (!motorServerInitialized) initializedMotorServer();
  ClearAlarm(MSTEQM_TAG,-1);

  for (i=0; i<gNumMotors; i++)
  {
    if (getMotorOnlineFcn != NULL) 
    {
      if (getMotorOnlineFcn(i,&ival) == 0) mstTbl[i].online = ival;
      else mstTbl[i].online = FALSE;
    }
    /* if (mstTbl[i].online == FALSE) continue; */
    mstTbl[i].status = getMotorStatus(i);
    getMotorPosition(i,mstTbl[i].position,6);
    getMotorTargetPosition(i,mstTbl[i].tgtPosition,6);
  }
}
int RegisterMsteqmProperties(void)
{
  int cc = 0;
  short access;
  char desc[256];
  DTYPE dout,din;

  memset(&dout,0,sizeof(DTYPE)); memset(&din,0,sizeof(DTYPE));
  if (getMotorStepsPerMUFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_DOUBLE;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"MicroStepsPerMotorUnit",&dout,&din,CA_READ,AT_CHANNEL,0,"Motor steps per millimeter",PRP_STEPS_PER_MU,"")) < 0) goto err;
  }
  if (getMotorStepsPerRadianFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_DOUBLE;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"MicroStepsPerRadian",&dout,&din,CA_READ,AT_CHANNEL,0,"Motor steps per radian",PRP_STEPS_PER_RADIAN,"")) < 0) goto err;
  }
  if (getMotorMicroStepsPerStepFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"MicroStepsPerStep",&dout,&din,CA_READ,AT_CHANNEL,0,"Motor micro steps per step",PRP_MICROSTEPS_PER_STEP,"")) < 0) goto err;
  }
  
  if (calibrateMotorFcn != NULL)
  {
    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    if (calibrateToOffsetFcn != NULL)
    {
      din.dArrayLength = 1;
      din.dFormat = CF_DOUBLE;
      sprintf(desc,"[%g:%g %.16s]calibrate motor to given offset",
        mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    }
    else
    {
      din.dArrayLength = 0;
      din.dFormat = CF_NULL;
      strcpy(desc,"calibrate motor");
    }
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Calibrate",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,desc,PRP_CALIBRATE,"")) < 0) goto err;
  }  
  if (resetMotorFcn != NULL)
  {
    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Reset",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Reset Motor",PRP_RESET,"")) < 0) goto err;
  }
  if (getSmarPodPositionFcn != NULL)
  {
    access = CA_READ;
    dout.dArrayLength = 6;
    dout.dFormat = CF_DOUBLE;
    if (getSmarPodPositionFcn != NULL)
    {
      din.dArrayLength = 6;
      din.dFormat = CF_DOUBLE;
      access |= CA_WRITE;
    }
    else
    {
      din.dArrayLength = 0;
      din.dFormat = CF_NULL;
    }
    sprintf(desc,"[%g:%g %.16s]smarpod position",
      mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Position",&dout,&din,access,AT_STRUCTURED,0,desc,PRP_POSITION,"")) < 0) goto err;
  }
  if (setIncrementMoveStatusFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementMove.STATUS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Status of Increment Move to target",PRP_INCR_MOVE_STATUS,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementMove.RESUME",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Resume Increment Move to target",PRP_INCR_MOVE_RESUME,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementMove.PAUSE",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Pause Increment Move to target",PRP_INCR_MOVE_PAUSE,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementMove.STOP",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Stop Increment Move to target",PRP_INCR_MOVE_STOP,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 1;
    din.dFormat = CF_DOUBLE;
    sprintf(desc,"[%g:%g %.16s]start Increment Move to target position",
      mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"IncrementMove.START",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,desc,PRP_INCR_MOVE_START,"")) < 0) goto err;
  }
  if (getSmarPodPositionMinimumFcn != NULL)
  {
    dout.dArrayLength = 6;
    dout.dFormat = CF_DOUBLE;
    sprintf(desc,"[%g:%g %.16s]motor position lower limit",
      mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"PositionMinimum",&dout,&din,CA_READ,AT_STRUCTURED,0,desc,PRP_LIMITS_POS_LWR,"")) < 0) goto err;
  }
  if (getSmarPodPositionMaximumFcn != NULL)
  {
    dout.dArrayLength = 6;
    dout.dFormat = CF_DOUBLE;
    sprintf(desc,"[%g:%g %.16s]motor position upper limit",
      mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"PositionMaximum",&dout,&din,CA_READ,AT_SCALAR,0,desc,PRP_LIMITS_POS_UPR,"")) < 0) goto err;
  }
  if (setSmarPodPositionOffsetFcn != NULL)
  {
    access = CA_READ;
    if (setMotorPositionOffsetFcn != NULL) access |= CA_WRITE;
    dout.dArrayLength = 6;
    dout.dFormat = CF_DOUBLE;
    sprintf(desc,"[%g:%g %.16s]motor position offset",
      mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"PositionOffset",&dout,&din,access,AT_STRUCTURED,0,desc,PRP_POSITION_OFFSET,"")) < 0) goto err;
  }
  if (getSmarPodPositionScaleFcn != NULL)
  {
    access = CA_READ|CA_WRITE;
    if (getSmarPodPositionScaleFcn != NULL) access |= CA_WRITE;
    dout.dArrayLength = 6;
    dout.dFormat = CF_DOUBLE;
    sprintf(desc,"[%g:%g %.16s]motor position scale",
      mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"PositionScale",&dout,&din,access,AT_STRUCTURED,0,desc,PRP_POSITION_SCALE,"")) < 0) goto err;
  }
  if (getMotorVelocityLowerLimitFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_DOUBLE;
    din.dArrayLength = 1;
    din.dFormat = CF_DOUBLE;
    sprintf(desc,"[0:100 %.16s/sec]motor velocity lower limit",mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"VeloctityMinimum",&dout,&din,CA_READ|CA_WRITE,AT_SCALAR,0,desc,PRP_LIMITS_VEL_LWR,"")) < 0) goto err;
  }
  if (getMotorVelocityUpperLimitFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_DOUBLE;
    din.dArrayLength = 1;
    din.dFormat = CF_DOUBLE;
    sprintf(desc,"[0:100 %.16s/sec]motor velocity upper limit",mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"VeloctityMaximum",&dout,&din,CA_READ|CA_WRITE,AT_SCALAR,0,desc,PRP_LIMITS_VEL_UPR,"")) < 0) goto err;
  }
  if (getMotorAccelerationUpperLimitFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_DOUBLE;
    din.dArrayLength = 1;
    din.dFormat = CF_DOUBLE;
    sprintf(desc,"[0:100 %.16s/sec^2]motor acceleration upper limit",mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"AccelerationMaximum",&dout,&din,CA_READ,AT_SCALAR,0,desc,PRP_LIMITS_ACC_UPR,"")) < 0) goto err;
  }
  if (setMoveToStatusFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Move.STATUS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Status of Move to target",PRP_MOVE_STATUS,"")) < 0) goto err;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"StepMove.STATUS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Status of Move to target",PRP_STEP_STATUS,"")) < 0) goto err;

    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Move.PROGRESS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Progress (seconds remaining) of Move to target",PRP_MOVE_PROGRESS,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Move.RESUME",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Resume Move to target",PRP_MOVE_RESUME,"")) < 0) goto err;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"StepMove.RESUME",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Resume Move to target",PRP_STEP_RESUME,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Move.PAUSE",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Pause Move to target",PRP_MOVE_PAUSE,"")) < 0) goto err;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"StepMove.PAUSE",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Pause Move to target",PRP_STEP_PAUSE,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Move.STOP",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Stop Move to target",PRP_MOVE_STOP,"")) < 0) goto err;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"StepMove.STOP",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Stop Move to target",PRP_STEP_STOP,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 1;
    din.dFormat = CF_DOUBLE;
    sprintf(desc,"[%g:%g %.16s]start Move to target position",
      mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Move.START",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,desc,PRP_MOVE_START,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 1;
    din.dFormat = CF_INT32;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"StepMove.START",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"[0:32767 steps]Start Move to target position (steps)",PRP_STEP_START,"")) < 0) goto err;    
  }
  if (setFreeMoveToStatusFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FreeMove.STATUS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Status of Free Move (no endswitch control) to target",PRP_FREE_MOVE_STATUS,"")) < 0) goto err;

    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FreeMove.PROGRESS",&dout,&din,CA_READ,AT_UNKNOWN,0,"Progress (seconds remaining) of Free Move (no endswitch control) to target",PRP_FREE_MOVE_PROGRESS,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FreeMove.RESUME",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Resume Free Move (no endswitch control) to target",PRP_FREE_MOVE_RESUME,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FreeMove.PAUSE",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Pause Free Move (no endswitch control) to target",PRP_FREE_MOVE_PAUSE,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FreeMove.STOP",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,"Stop Free Move (no endswitch control) to target",PRP_FREE_MOVE_STOP,"")) < 0) goto err;

    dout.dArrayLength = 0;
    dout.dFormat = CF_NULL;
    din.dArrayLength = 1;
    din.dFormat = CF_DOUBLE;
    sprintf(desc,"[%g:%g %.16s]start free move (no endswitch control) to target position",
      mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"FreeMove.START",&dout,&din,CA_READ|CA_WRITE,AT_UNKNOWN,0,desc,PRP_FREE_MOVE_START,"")) < 0) goto err;
  }
  if (getMotorStatusFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_INT32;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Status",&dout,&din,CA_READ,AT_CHANNEL,0,"[0:1 ]Get Motor Status",PRP_STATUS,"")) < 0) goto err;
  }
  if (getMotorStatusBlockFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_STRUCT;
    strcpy(dout.dTag,"MotSts");
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"StatusInfo",&dout,&din,CA_READ,AT_CHANNEL,0,"[0:1 ]Get Motor Status Information (atomic structure)",PRP_STATUS_BLOCK,"")) < 0) goto err;
    memset(&dout,0,sizeof(DTYPE));
  }
  dout.dArrayLength = gNumMotors;
  dout.dFormat = CF_INT32;
  din.dArrayLength = 1;
  din.dFormat = CF_INT32;
  if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"OnLine",&dout,&din,CA_READ,AT_CHANNEL,0,"[0:1 ]Get/Set Motor On-Line Status",PRP_ONLINE,"")) < 0) goto err;
  if (getSmarPodTargetPositionFcn != NULL)
  {
    dout.dArrayLength = 6;
    dout.dFormat = CF_DOUBLE;
    access = CA_READ;
    if (setSmarPodTargetPositionFcn != NULL)
    {
      din.dArrayLength = 6;
      din.dFormat = CF_DOUBLE;
      access |= CA_WRITE;
    }
    else
    {
      din.dArrayLength = 0;
      din.dFormat = CF_NULL;
    }
    sprintf(desc,"[%g:%g %.16s]get/set SmarPod Target Position",
      mstTbl[0].positionMinimum,mstTbl[0].positionMaximum,mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"TargetPosition",&dout,&din,access,AT_STRUCTURED,0,desc,PRP_TARGET_POSITION,"")) < 0) goto err;
  }
  if (getMotorTargetMicroPositionFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_INT32;
    access = CA_READ;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"TargetMicroPosition",&dout,&din,access,AT_CHANNEL,0,"[0:32767 microsteps]Get/Set Motor Target Position",PRP_TARGET_MICROSTEPS,"")) < 0) goto err;
  }
  if (getMotorAccelerationFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_DOUBLE;
    access = CA_READ;
    if (setMotorAccelerationFcn != NULL)
    {
      din.dArrayLength = 1;
      din.dFormat = CF_DOUBLE;
      access |= CA_WRITE;
    }
    else
    {
      din.dArrayLength = 0;
      din.dFormat = CF_NULL;
    }
    sprintf(desc,"[0:1 %.16s/sec^2]get/set Motor Acceleration",mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Acceleration",&dout,&din,access,AT_CHANNEL,0,desc,PRP_ACCELERATION,"")) < 0) goto err;
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_USTRING;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    sprintf(desc,"Motor Acceleration units");
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Acceleration.EGU",&dout,&din,CA_READ,AT_CHANNEL,0,desc,PRP_ACCELERATION_EGU,"")) < 0) goto err;
  }
  if (getMotorVelocityFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_DOUBLE;
    access = CA_READ;
    if (setMotorVelocityFcn != NULL)
    {
      din.dArrayLength = 1;
      din.dFormat = CF_DOUBLE;
      access |= CA_WRITE;
    }
    else
    {
      din.dArrayLength = 0;
      din.dFormat = CF_NULL;
    }
    sprintf(desc,"[0:100 %.16s/sec]get/set Motor Velocity",mstTbl[0].units.name);
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Velocity",&dout,&din,access,AT_CHANNEL,0,desc,PRP_VELOCITY,"")) < 0) goto err;
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_USTRING;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    sprintf(desc,"Motor Velocity units");
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Velocity.EGU",&dout,&din,CA_READ,AT_CHANNEL,0,desc,PRP_VELOCITY_EGU,"")) < 0) goto err;
  }
  if (getMotorCurrentFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_DOUBLE;
    access = CA_READ;
    if (setMotorCurrentFcn != NULL)
    {
      din.dArrayLength = 1;
      din.dFormat = CF_DOUBLE;
      access |= CA_WRITE;
    }
    else
    {
      din.dArrayLength = 0;
      din.dFormat = CF_NULL;
    }
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"Current",&dout,&din,access,AT_CHANNEL,0,"[0:1 mA]Motor Current",PRP_CURRENT,"")) < 0) goto err;
  }
  if (getLastHdwErrFcn != NULL)
  {
    dout.dArrayLength = gNumMotors;
    dout.dFormat = CF_NAME64;
    access = CA_READ;
    din.dArrayLength = 0;
    din.dFormat = CF_NULL;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"LastHardwareError",&dout,&din,access,AT_CHANNEL,0,"Last Hardware Error",PRP_LASTHDWERR,"")) < 0) goto err;
  }
  
  if (getSmarPodPivotFcn != NULL)
  {
    dout.dArrayLength = 3;
    dout.dFormat = CF_DOUBLE;
    access = CA_READ|CA_WRITE;
    din.dArrayLength = 3;
    din.dFormat = CF_DOUBLE;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"PivotPoint",&dout,&din,access,AT_STRUCTURED,0,"get/set pivot point",PRP_PIVOT,"")) < 0) goto err;
  }
  if (getSmarPodPivotModeFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    access = CA_READ|CA_WRITE;
    din.dArrayLength = 1;
    din.dFormat = CF_INT32;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"PivotMode",&dout,&din,access,AT_SCALAR,0,"get/set pivot mode",PRP_PIVOT_MODE,"")) < 0) goto err;
  }
  if (getSmarPodSensorModeFcn != NULL)
  {
    dout.dArrayLength = 1;
    dout.dFormat = CF_INT32;
    access = CA_READ|CA_WRITE;
    din.dArrayLength = 1;
    din.dFormat = CF_INT32;
    if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"SensorMode",&dout,&din,access,AT_SCALAR,0,"get/set sensor mode",PRP_SENSOR_MODE,"")) < 0) goto err;
  }

  dout.dArrayLength = gNumMotors;
  dout.dFormat = CF_LONG;
  din.dArrayLength = 1;
  din.dFormat = CF_LONG;
  if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"RotationMoveAllowed",&dout,&din,CA_READ|CA_WRITE,AT_CHANNEL,0,"[0:1 ]Linear Rotation Moves (end switc",PRP_ROTATIONMOVEALLOWED,"")) < 0) goto err;

  dout.dArrayLength = 0;
  dout.dFormat = CF_NULL;
  din.dArrayLength = 1;
  din.dFormat = CF_LONG;
  if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"MicroStep",&dout,&din,CA_READ|CA_WRITE,AT_CHANNEL,0,"[0:100 steps]Move Micro Step",PRP_MICROSTEP,"")) < 0) goto err;

  dout.dArrayLength = gNumMotors;
  dout.dFormat = CF_LONG;
  din.dArrayLength = 1;
  din.dFormat = CF_LONG;
  if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"StepCounter",&dout,&din,CA_READ|CA_WRITE,AT_CHANNEL,0,"[0:100 steps]Set/Read Step Counter",PRP_STEPCOUNTER,"")) < 0) goto err;

  dout.dArrayLength = gNumMotors;
  dout.dFormat = CF_LONG;
  din.dArrayLength = 1;
  din.dFormat = CF_LONG;
  if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"MicroStepCounter",&dout,&din,CA_READ|CA_WRITE,AT_CHANNEL,0,"[0:100 micro-steps]Set/Read Micro Step Counter",PRP_MICROSTEPCOUNTER,"")) < 0) goto err;

  dout.dArrayLength = 32;
  dout.dFormat = CF_NAME32;
  din.dArrayLength = 0;
  din.dFormat = CF_NULL;
  if ((cc=RegisterPropertyInformation(MSTEQM_TAG,"StatusBits",&dout,&din,CA_READ,AT_UNKNOWN,0,"motor status bit definitions",PRP_STATUSBIT_LIST,"")) < 0) goto err;

err:
  if (cc < 0)
  {
    feclog("Can't register property : %s",erlst[-cc]);
  }
  return cc;
}

void acquireStaticMotorInfo(int i)
{
  mstTbl[i].status = getMotorStatus(i);
  // get limits 
//  mstTbl[i].limits[VEL_LWR_IDX] = getMotorVelocityLowerLimit(i);
//  mstTbl[i].limits[VEL_UPR_IDX] = getMotorVelocityUpperLimit(i);
//  mstTbl[i].limits[ACC_UPR_IDX] = getMotorAccelerationUpperLimit(i);
  // get current settings (velocity, acceleration, target, current positions)
  mstTbl[i].velocity = getMotorVelocity(i);
  mstTbl[i].acceleration = getMotorAcceleration(i);
  getMotorPositionMinimum(i,mstTbl[i].positionMinimum,6);
  getMotorPositionMaximum(i,mstTbl[i].positionMaximum,6);
  getMotorPositionOffset(i,mstTbl[i].positionOffset,6);
  getMotorPositionScale(i,mstTbl[i].positionScale,6);
}
void initializedMotorServer(void)
{
  int i, cc;
  MstGroupInfoStruct *mstInfoTbl = NULL;

  if (motorServerInitialized) return;
  motorServerInitialized = TRUE;
  if ((cc=initializeMotorHardware()) != 0)
  {
    feclog("error in initializing motor steering hardware : %s",erlst[cc]);
  }
  getMotorList(&gMotorNames,&gNumMotors);

  if (gNumMotors < 1) 
  { // configuration error
    feclog("no configured motors");
    printf("There are no configured motors !\n");
    return; 
  }
  for (i=0; i<gNumMotors; i++)
  {
    if ((cc=RegisterDeviceName(MSTEQM_TAG,gMotorNames[i].name,i)) != 0) 
      feclog("cannot register device %s : %s",gMotorNames[i].name,erlst[cc]);
    acquireStaticMotorInfo(i);
    mstTbl[i].online = TRUE; // is device on line ?
  }

  RegisterMsteqmProperties();

  /* now fix the number of exported devices ... */
  AssignNumDevices(MSTEQM_TAG,gNumMotors+mstGroupTblSize);
}
void smpeqm_ini(void)
{
# ifdef EAGER_INIT
  initializedMotorServer();
# endif
}
void smpeqm_exi(void)
{
  /* TODO: put your shutdown routines here */
}
void stopScanMonitor(MonitorScan *ms)
{
  MonitorParams *mp = NULL;
  if (ms == NULL || (mp=ms->params) == NULL) return;
  ms->stop = MakeDataTimeStamp();
  ms->length = mp->idx;
  if (mp->err < ms->length) ms->sts = 0;
  CloseLink(ms->id);
}
int smpeqm(char *devName,char *devProperty,DTYPE *dout, DTYPE *din,short access)
{
  int i,m,ival,devnr,grpnr=-1,prpid,grpid=-1,cc,idx=0;
  int isGroupedCall=FALSE, isGroupedDevice=FALSE, isMonitorCall=FALSE,monitorStepScan=TRUE;
  short sval;
  double dval, dvals[6], dvalArray[NUM_MSTEQM_DEVICES];
  UINT32 lval;
  char *g=NULL,*cp=NULL,*unitscat=NULL;
  int numInGroup=NUM_MOTORS_MAX;
  MonitorParams *mp=NULL;
  MonitorScan *ms=NULL;
  double *xScanAxis=NULL,*yScanAxis=NULL;

  devnr = GetDeviceNumberEx(MSTEQM_TAG,devName,devProperty);
  prpid = GetPropertyId(MSTEQM_TAG,devProperty);

  switch (prpid)
  {
    case PRP_STATUS:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (isGroupedDevice)
          {
            dout->dArrayLength = 1;
            if (getGroupMotorStatusFcn != NULL)
            {
              ival = getGroupMotorStatus(grpid);
              return PutValuesFromLongEx(dout,&ival,1,0);
            }
          }
          if (isGroupedCall) dout->dArrayLength = 1;
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromAny(dout,&mstTbl[0].status,CF_INT16,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_STATUS_BLOCK:
        if (access&CA_WRITE) return illegal_read_write;
        if (isGroupedCall) return illegal_device;
        if (dout->dArrayLength > 0)
        {
          if (dout->dFormat != CF_STRUCT) return illegal_format;
          if (strcmp(dout->dTag,"MotSts")) return invalid_structure_tag;
          for (i=0,m=devnr; i<(int)dout->dArrayLength && m<gNumMotors; i++,m++)
          {
            cc = getMotorStatusBlockFcn(m,&((MotorStatus *)dout->data.vptr)[i]);
            if (cc != 0) return cc;
          }
          dout->dArrayLength = i;
        }
        return 0;
    case PRP_ONLINE:
        if (isGroupedCall) return illegal_device;
        if (isGroupedDevice) return illegal_device;
        if (access&CA_WRITE) 
        {
          if (din->dArrayLength > 0)
          {
            if ((cc=GetValuesAsShort(din,&sval,1)) != 0) return cc;
            if (setMotorOnlineFcn != NULL) setMotorOnlineFcn(devnr,sval);
            mstTbl[devnr].online = sval;
            feclog("motor %s set to %s",devName,sval ? "on line" : "off line");
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromAny(dout,&mstTbl[0].online,CF_INT16,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_CALIBRATE:
        if (isGroupedCall) return illegal_device;
        if (isGroupedDevice) return illegal_device;
        if (access&CA_WRITE)
        {
          return not_implemented;
        }
        return 0;

    case PRP_RESET:
        if (isGroupedCall) return illegal_device;
        if (isGroupedDevice) return illegal_device;
        if (access&CA_WRITE)
        {
           if (din->dArrayLength > 0) return illegal_read_write;
           if ((cc=resetMotor(devnr)) != 0) return cc;
           feclog("motor %.64s has been reset",devName);
        }
        return 0;
    case PRP_TARGET_POSITION:
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if ((cc=GetValuesAsDouble(din,dvalArray,NUM_MSTEQM_DEVICES)) != 0) return cc;
            if (devnr < 0 || devnr >= gNumMotors) return illegal_device;
            if ((cc=setMotorTargetPosition(devnr,dvalArray,(int)din->dArrayLength)) != 0) return cc;
            memcpy(mstTbl[devnr].tgtPosition,dvalArray,din->dArrayLength*sizeof(double));
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromDouble(dout,mstTbl[0].tgtPosition,6)) != 0) return cc;
        }
        return 0;
    case PRP_POSITION:
        if (access&CA_WRITE) 
        {
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength < 1) return dimension_error;
            if ((cc=GetValuesAsDouble(din,dvals,6)) != 0) return cc;
            cc = setMotorPosition(devnr,dvals,6);
            if (cc != 0) return cc;
          }
          else
          {
            return illegal_read_write;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if ((cc=PutValuesFromDouble(dout,mstTbl[0].position,6)) != 0) return cc;
        }
        return 0;
    case PRP_INCR_MOVE_STATUS:
        if (isGroupedCall) return illegal_device;
        if (getIncrementMoveStatusFcn == NULL) return not_implemented;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=getIncrementMoveStatusFcn(devnr,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_INCR_MOVE_RESUME:
        if (isGroupedCall) return illegal_device;
        if (setIncrementMoveStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setIncrementMoveStatusFcn(devnr,PROC_STS_RESUME);
        }
        return cc;
    case PRP_INCR_MOVE_PAUSE:
        if (isGroupedCall) return illegal_device;
        if (setIncrementMoveStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setIncrementMoveStatusFcn(devnr,PROC_STS_PAUSE);
        }
        return cc;
    case PRP_INCR_MOVE_STOP:
        if (isGroupedCall) return illegal_device;
        if (setIncrementMoveStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setIncrementMoveStatusFcn(devnr,PROC_STS_STOP);
        }
        return cc;
    case PRP_INCR_MOVE_START:
        if (isGroupedCall) return illegal_device;
        if (setIncrementMoveStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if ((cc=GetValuesAsDouble(din,dvals,1)) != 0) return cc;
            for (i=0; i<(int)din->dArrayLength; i++)
            {
              dvals[i] += mstTbl[devnr].tgtPosition[i];
            }
            if ((cc=setMotorTargetPosition(devnr,dvals,din->dArrayLength)) != 0) return cc;
            memcpy(mstTbl[devnr].tgtPosition,dvals,din->dArrayLength*sizeof(double));
            //millisleep(100);
          }
          cc = setIncrementMoveStatusFcn(devnr,PROC_STS_START);
        }
        return cc;
    case PRP_LIMITS_VEL_LWR:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=PutValuesFromDouble(dout,&mstTbl[devnr].limits[VEL_LWR_IDX],1)) != 0) return cc;
        }
        return 0;
    case PRP_LIMITS_VEL_UPR:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=PutValuesFromDouble(dout,&mstTbl[devnr].limits[VEL_UPR_IDX],1)) != 0) return cc;
        }
        return 0;
    case PRP_LIMITS_ACC_UPR:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=PutValuesFromDouble(dout,&mstTbl[devnr].limits[ACC_UPR_IDX],1)) != 0) return cc;
        }
        return 0;
    case PRP_MOVE_STATUS:
        if (isGroupedCall) return illegal_device;
        if (getMoveToStatusFcn == NULL) return not_implemented;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=getMoveToStatusFcn(devnr,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_MOVE_PROGRESS:
        if (isGroupedCall) return illegal_device;
        if (getMoveToProgressFcn == NULL) return not_implemented;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 1) return dimension_error;
          if ((cc=getMoveToProgressFcn(devnr,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_MOVE_RESUME:
        if (isGroupedCall) return illegal_device;
        if (setMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setMoveToStatusFcn(devnr,PROC_STS_RESUME);
        }
        return cc;
    case PRP_MOVE_PAUSE:
        if (isGroupedCall) return illegal_device;
        if (setMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setMoveToStatusFcn(devnr,PROC_STS_PAUSE);
        }
        return cc;
    case PRP_MOVE_STOP:
        if (isGroupedCall) return illegal_device;
        if (setMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          cc = setMoveToStatusFcn(devnr,PROC_STS_STOP);
        }
        return cc;
    case PRP_MOVE_START:
        if (isGroupedCall) return illegal_device;
        if (setMoveToStatusFcn == NULL) return not_implemented;
        cc = illegal_read_write;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if ((cc=GetValuesAsDouble(din,dvals,6)) != 0) return cc;
            if ((cc=setMotorTargetPosition(devnr,dvals,din->dArrayLength)) != 0) return cc;
            memcpy(mstTbl[devnr].tgtPosition,dvals,din->dArrayLength*sizeof(double));
          }
          cc = setMoveToStatusFcn(devnr,PROC_STS_START);
        }
        return cc;
    case PRP_ACCELERATION:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength > 1) return dimension_error;
            if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
            if (dval > mstTbl[devnr].limits[ACC_UPR_IDX]) return out_of_range;
            if (dval < 0) return out_of_range;
            cc = setMotorAcceleration(devnr,dval);
            if (cc == 0) mstTbl[devnr].acceleration = dval; else return cc;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromAny(dout,&mstTbl[0].acceleration,CF_DOUBLE,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_VELOCITY:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength > 1) return dimension_error;
            if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
            if (dval > mstTbl[devnr].limits[VEL_UPR_IDX]) return out_of_range;
            if (dval < mstTbl[devnr].limits[VEL_LWR_IDX]) return out_of_range;
            cc = setMotorVelocity(devnr,dval);
            if (cc == 0) mstTbl[devnr].velocity = dval; else return cc;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromAny(dout,&mstTbl[0].velocity,CF_DOUBLE,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_CURRENT:
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength > 1) return dimension_error;
            if ((cc=GetValuesAsDouble(din,&dval,1)) != 0) return cc;
            if ((cc=setMotorCurrent(devnr,dval)) != 0) return cc;
            mstTbl[devnr].current = dval;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromAny(dout,&mstTbl[0].current,CF_DOUBLE,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_PIVOT:
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if ((cc=GetValuesAsDouble(din,dvals,3)) != 0) return cc;
            if ((cc=setSmarPodPivotFcn(devnr,dvals,din->dArrayLength)) != 0) return cc;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if ((cc=getSmarPodPivotFcn(devnr,dvals,dout->dArrayLength)) != 0) return cc;
          if ((cc=PutValuesFromDouble(dout,dvals,3)) != 0) return cc;
        }
        return 0;
    case PRP_PIVOT_MODE:
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if ((cc=GetValuesAsLong(din,&lval,1)) != 0) return cc;
            if ((cc=setSmarPodPivotModeFcn(devnr,lval)) != 0) return cc;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if ((cc=getSmarPodPivotModeFcn(devnr,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_SENSOR_MODE:
        if (access&CA_WRITE)
        {
          if (din->dArrayLength > 0)
          {
            if ((cc=GetValuesAsLong(din,&lval,1)) != 0) return cc;
            if ((cc=setSmarPodSensorModeFcn(devnr,lval)) != 0) return cc;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if ((cc=getSmarPodSensorModeFcn(devnr,&lval)) != 0) return cc;
          if ((cc=PutValuesFromLong(dout,&lval,1)) != 0) return cc;
        }
        return 0;
    case PRP_STATUSBIT_LIST:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if ((cc=PutValuesFromString(dout,(char *)mstStsList,CF_NAME32,sizMstStsList,0)) != 0) return cc;
        }
        return 0;
    case PRP_LIMITS_POS_LWR:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if ((cc=PutValuesFromDouble(dout,mstTbl[devnr].positionMinimum,6)) != 0) return cc;
        }
        return 0;
    case PRP_LIMITS_POS_UPR:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if ((cc=PutValuesFromDouble(dout,mstTbl[devnr].positionMaximum,6)) != 0) return cc;
        }
        return 0;
    case PRP_POSITION_OFFSET:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE) 
        {
          if (setSmarPodPositionOffsetFcn == NULL) return illegal_read_write;
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength < 1) return dimension_error;
            if ((cc=GetValuesAsDouble(din,dvals,6)) != 0) return cc;
            if ((cc=setMotorPositionOffset(devnr,dvals,din->dArrayLength)) != 0) return cc;
            acquireStaticMotorInfo(devnr);
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromAny(dout,mstTbl[0].positionOffset,CF_DOUBLE,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_POSITION_SCALE:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE) 
        {
          if (setSmarPodPositionScaleFcn == NULL) return illegal_read_write;
          if (din->dArrayLength > 0)
          {
            if (din->dArrayLength < 1) return dimension_error;
            if ((cc=GetValuesAsDouble(din,dvals,6)) != 0) return cc;
            if ((cc=setMotorPositionScale(devnr,dvals,din->dArrayLength)) != 0) return cc;
            acquireStaticMotorInfo(devnr);
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > (UINT32)gNumMotors) return dimension_error;
          if ((cc=PutValuesFromAny(dout,mstTbl[0].positionScale,CF_DOUBLE,TRUE,sizeof(Motor),gNumMotors,devnr)) != 0) return cc;
        }
        return 0;
    case PRP_LASTHDWERR:
        if (isGroupedCall) return illegal_device;
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          for (i=0; i<(int)dout->dArrayLength && (devnr+i)<gNumMotors; i++)
          {
            switch (dout->dFormat)
            {
              case CF_NAME64I: 
                cc = getLastHardwareError(devnr+i,(NAME64 *)((NAME64I *)dout->data.vptr)[i].name,&((NAME64I *)dout->data.vptr)[i].ival);
                break;
              case CF_NAME64: 
                cc = getLastHardwareError(devnr+i,&((NAME64 *)dout->data.vptr)[i],NULL);
                break;
              case CF_INT32:
                cc = getLastHardwareError(devnr+i,NULL,&dout->data.lptr[i]);
                break;
              default:
                return illegal_format;
            }
            if (cc != 0) return cc;
          }
          dout->dArrayLength = (UINT32)i;
        }
        return 0;
    default:
       return illegal_property;
  }
}
