/*
 * devsrv    REVISION HISTORY:
 * Generated by SRVWIZARD on Mon Dec 18 15:39:21 2006
 */

#define APPV_MAJOR 1
#define APPV_MINOR 0
#define APPV_REVISION 1

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "tine.h"
#ifdef UNIX
#include <dlfcn.h>
#endif
#include "smpeqm.h"
#include "smplib.h"

char gMotorLib[256] = "";
char gMstFecName[32] = "";
int gMstFecPortOffset = 0;
int gIsSmarPod = FALSE;
void loadMotorLib(void)
{
  char tmp[256];
# if defined(WIN32)
  LPVOID lpMsgBuf;
  char *libExt = ".dll";
  char *libPre = NULL;
# elif defined(UNIX)
  char *libExt = ".so";
  char *libPre = "lib";
# endif
  
  if (strlen(gMotorLib) != 0)
  { /* the external motor lib will register all of the relevant dispatch routines */
    if (!stricmp(gMotorLib,"smarpod")) gIsSmarPod = TRUE;
    if (libPre != NULL && strncmp(libPre,gMotorLib,strlen(libPre))) 
    {
      strncpy(tmp,gMotorLib,256);
      strcpy(gMotorLib,libPre);
      strncat(gMotorLib,tmp,200);
    }
    if (strcmp(&gMotorLib[strlen(gMotorLib)-strlen(libExt)],libExt)) strcat(gMotorLib,libExt);
    feclog("load motor library %.256s",gMotorLib);
#   if defined(WIN32)
    if (LoadLibrary(gMotorLib) == NULL)
    {
      FormatMessage( 
        FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,GetLastError(),
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
        (LPTSTR) &lpMsgBuf,0,NULL);
      feclog("could not load motor library %s : %s",gMotorLib,lpMsgBuf);
    }
#   else
    dlopen(gMotorLib, RTLD_LAZY);
#   endif
  }
  else
  {
    feclog("no motor library entered !");
  }
}
void dumpUsage(void)
{
  printf("Usage:\n\n\tmst /f=<fecname> /p=<port offset> /s=<server name> /c=<context> /g=<server group> /m=<group metric> /l=<motor library> /a=<set alarms (TRUE or FALSE)> /d=<debug level>\n");
  exit(0);
}
int main(int argc, char *argv[])
{
  int i, cc;
  char *c, tmp[256];

  if (argc <= 1) dumpUsage();
  for (i=1; i<argc; i++)
  {
    c = argv[i];
    if (*c++ != '/') continue;
    switch (tolower(*c))
    {
      case 'f':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(gMstFecName,c,32);
        }
        continue;
      case 'p':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          gMstFecPortOffset = atoi(c);
        }
        continue;
      case 'd':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          tineDebug = atoi(c);
        }
        continue;
      case 's':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(gMotorServerExportName,c,32);
        }
        continue;
      case 'g':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(gMotorServerGroup,c,32);
        }
        continue;
      case 'm':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          gMotorGroupMetric = atoi(c);
        }
        continue;
      case 'c':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(gMotorServerContext,c,32);
        }
        continue;
      case 'l':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(gMotorLib,c,256);
        }
        continue;
      case 'a':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(tmp,c,32);
          gMstSetAlarms = stricmp(tmp,"TRUE") ? TRUE : FALSE;
        }
        continue;
      case 'h':
      case '?':
        dumpUsage();
      default:
        continue;
    }
  }

  AssignFecApplicationInfo(APPV_MAJOR,APPV_MINOR,APPV_REVISION);
  SetPreSystemInitFunction(PreSystemInit);
  SetPostSystemInitFunction(PostSystemInit);
  if ((cc=SystemInit(TRUE)) != 0)
  {
    printf(erlst[cc]);
    exit(1);
  }
  for(;;)
  {
    SystemCycle(TRUE);
  }
  return 0;
}
