#include "app_version.h"
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <sys/types.h>
#include "tine.h"

void PostSystemInit(void);
void PreSystemInit(void);
extern int useConnectedLinks;

extern char thisFecName[FEC_NAME_SIZE+4];
extern char thisContext[CONTEXT_NAME_SIZE+4];
extern char thisLocation[FEC_LOCATION_SIZE];
extern char thisExtension[4];
extern UINT16 thisPortOffset;
extern int PreallocatedDataBufferSize;
extern int startupInputsGiven;

char *usageText = "usage: pmarch [/f=<fecname> /c=<context> /p=<port offset> /x=<extension> /l=<location> /s=<prealloc buffersize in bytes> /t=<TRUE to use tcp sockets> /d=<debug level>";
int main(int argc, char *argv[])
{
  int i,cc;
  char *c, scratch[256];

  for (i=1; i<argc; i++)
  { /* options given */
    c = argv[i];
    if (*c++ != '/') break;
    switch (tolower(*c))
    {
      case 'x':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(thisExtension,c,4);
        }
        continue;
      case 'f':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(thisFecName,c,FEC_NAME_SIZE);
          startupInputsGiven = TRUE;
        }
        continue;
      case 'c':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(thisContext,c,CONTEXT_NAME_SIZE);
          startupInputsGiven = TRUE;
        }
        continue;
      case 'l':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(thisLocation,c,FEC_LOCATION_SIZE);
        }
        continue;
      case 'p':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(scratch,c,32);
          thisPortOffset = atoi(scratch);      
        }
        continue;
      case 's':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(scratch,c,32);
          PreallocatedDataBufferSize = atoi(scratch);      
        }
        continue;
      case 'd':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(scratch,c,32);
          tineDebug = atoi(scratch);      
        }
        continue;
      case 't':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(scratch,c,32);
          if (stricmp(scratch,"TRUE") == 0)
          {
            useConnectedLinks = TRUE;
          }
        }
        continue;
      case '?':
      case 'h':
        printf("%s",usageText);
        exit(0);
      default:
        continue;
    }
  }

  AssignFecApplicationInfo(APPV_MAJOR,APPV_MINOR,APPV_REVISION);
  SetPreSystemInitFunction(PreSystemInit);
  SetPostSystemInitFunction(PostSystemInit);
  
  if ((cc=SystemInit(TRUE)) != 0) { printf("init error: %.32s\n",erlst[cc]); exit(1); }
  for(;;)
  {
    SystemCycle(TRUE);
  }
  return 0;
}
