#include "prolog.h"
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <time.h>
#include <errno.h>
#include <stdio.h>
#include <fcntl.h>
#include "servdef.h"
#include "rpctypes.h"
#include "database.h"
#include "errors.h"
#include "arceqm.h"

extern int nofeclog;
extern int ListenForGlobals;
extern int ListenForMCasts;

int gethdr(char *devname,char *chan)
{
  DTYPE dout;
  int rc;
  DHS hdr;

  dout.dFormat = CF_STRUCT;
  dout.dArrayLength = 1;
  strncpy(dout.dTag,"HEADER",8);
  dout.data.vptr = &hdr;

  rc = ExecLink(devname,"HEADER",&dout,NULL,CA_READ);

  if (rc) 
  {
    printf("call to %s HEADER failed : %s\n",devname,erlst[rc]);
    return rc;
  }
//  printf("ChannelID : %s\n",hdr.channelID);
  strncpy(chan,hdr.channelID,16);
  return 0;
}
void doinit(void);
 
void regstr(void)
{
  if (fillstruct("HEADER",OFFSETIN(DHS,channelID),32,CF_TEXT)) quit(out_of_local_memory);
  if (fillstruct("HEADER",OFFSETIN(DHS,eventcode),1,CF_LONG)) quit(out_of_local_memory);
  if (fillstruct("HEADER",OFFSETIN(DHS,arraysize),1,CF_SHORT)) quit(out_of_local_memory);
  if (fillstruct("HEADER",OFFSETIN(DHS,datatype),1,CF_SHORT)) quit(out_of_local_memory);
  if (fillstruct("HEADER",OFFSETIN(DHS,samplingrate),1,CF_FLOAT)) quit(out_of_local_memory);
  if (fillstruct("HEADER",OFFSETIN(DHS,pretrigger),1,CF_LONG)) quit(out_of_local_memory);
  if (fillstruct("HEADER",OFFSETIN(DHS,timeoffset),1,CF_LONG)) quit(out_of_local_memory);
  if (fillstruct("HEADER",OFFSETIN(DHS,lowcount),1,CF_LONG)) quit(out_of_local_memory);
  if (fillstruct("HEADER",OFFSETIN(DHS,highcount),1,CF_LONG)) quit(out_of_local_memory);
  if (fillstruct("HEADER",OFFSETIN(DHS,egu),16,CF_TEXT)) quit(out_of_local_memory);
  if (fillstruct("HEADER",OFFSETIN(DHS,egulow),1,CF_FLOAT)) quit(out_of_local_memory);
  if (fillstruct("HEADER",OFFSETIN(DHS,eguhigh),1,CF_FLOAT)) quit(out_of_local_memory);
  if (fillstruct("HEADER",OFFSETIN(DHS,datalength),1,CF_LONG)) quit(out_of_local_memory);
  if (fillstruct("HEADER",OFFSETIN(DHS,desc),4*64,CF_TEXT)) quit(out_of_local_memory);
  if (fillstruct("HEADER",sizeof(DHS),1,CF_NULL)) quit(out_of_local_memory);
}

int main(int argc, char *argv[])
{
  int cc,i,j,k,n;
  char dev[64],svr[16],chan[16],cl[2] = {0,0};
  int c1start,c1stop,c2start,c2stop,c3start,c3stop;
  switch (argc)                           /* initial debug level */
  {           /* on UNIX or DOS stations: set debug = 1 (2,or 3) */
    default:
      printf("usage: gethdr <deviceServer> <ch1 start> <ch1 stop> <ch2 start> <ch2 stop> <ch3 start> <ch3 stop>\n");
      exit(1);
      break;
    case 9:
      strncpy(svr,argv[1],16);
      c1start = atoi(argv[2]);
      c1stop = atoi(argv[3]);
      cl[0] = *(argv[4]);
      c2start = atoi(argv[5]);
      c2stop = atoi(argv[6]);
      c3start = atoi(argv[7]);
      c3stop = atoi(argv[8]);
      break;
    case 8:
      strncpy(svr,argv[1],16);
      c1start = atoi(argv[2]);
      c1stop = atoi(argv[3]);
      c2start = atoi(argv[4]);
      c2stop = atoi(argv[5]);
      c3start = atoi(argv[6]);
      c3stop = atoi(argv[7]);
      break;
  }
 
  MaxNumConnections = 3;
  ListenForGlobals = ListenForMCasts = FALSE;
  MaxPollingRate = MinPollingRate = 200;
  nofeclog = TRUE;
 
  regstr();
 
  n = 0;
  printf("DEVICE_NUMBER,DEVICE_NAME,DEVICE_ALIAS\n");
  for (i=c1start; i<=c1stop; i++) for (j=c2start; j<=c2stop; j++) for (k=c3start; k<=c3stop; k++)
  {
    if (cl[0] != 0)
      sprintf(dev,"%s/#%d.%s.#%d.#%d",svr,i,cl,j,k);
    else
      sprintf(dev,"%s/#%d.#%d.#%d",svr,i,j,k);
    gethdr(dev,chan);
    printf("%d,%s,%s\n",n,dev,chan);
    n++;
  }
//  for(;;)
//  {
//    SystemCycle(TRUE);
//  }
  return 0;
}
