# variables with defaults can be overridden by environment variables
#   TINE_INCL
#   TINE_LIBS
#   TINE_ARCSRC

TINE_INCL ?= ../../../include
TINE_LIBS ?= ../../../lib
TINE_ARCSRC ?= ../../shared

HDRS = ${TINE_INCL}/project.def \
	${TINE_INCL}/prolog.h \
	${TINE_INCL}/srvcore.h \
	${TINE_INCL}/errors.h \
	${TINE_INCL}/tinetype.h \
	${TINE_INCL}/tinedefs.h \
	${TINE_INCL}/swaplib.h \
	${TINE_INCL}/dbtools.h \
	${TINE_INCL}/almlib.h 

TINELIB = libtinemt.a

CPP = g++ -c -g -Wno-deprecated -I. -I${TINE_INCL} -I${TINE_ARCSRC}
CC = cc -c -Aa -DMULTITHREADED -g -I. -I${TINE_INCL} -I${TINE_ARCSRC}
CCL = cc
LM = -lm -lpthread -lrt

pmarch: arctools.o streqm.o apceqm.o arceqm.o devsrv.o
	${CCL} -o pmarch arctools.o streqm.o apceqm.o arceqm.o devsrv.o ${TINE_LIBS}/${TINELIB} ${LM}
	chmod a+x pmarch

devsrv.o: devsrv.c app_version.h ${HDRS} 
	${CC} devsrv.c

arctools.o: ${TINE_ARCSRC}/arctools.c ${TINE_ARCSRC}/arctools.h ${HDRS}
	${CC} ${TINE_ARCSRC}/arctools.c

streqm.o: streqm.c ${TINE_ARCSRC}/apceqm.h ${TINE_ARCSRC}/arctools.h ${HDRS}
	${CC} streqm.c 

apceqm.o: ${TINE_ARCSRC}/apceqm.c ${TINE_ARCSRC}/apceqm.h ${HDRS}
	${CC} ${TINE_ARCSRC}/apceqm.c 

arceqm.o: arceqm.c ${TINE_ARCSRC}/arceqm.h ${TINE_ARCSRC}/arctypes.h ${HDRS}
	${CC} arceqm.c

clean:
	rm -f *.o
