# variables with defaults can be overridden by environment variables
#   TINE_INCL
#   TINE_LIBS

TINE_INCL ?= ../../../include
TINE_LIBS ?= ../../../lib

HDRS = ${TINE_INCL}/project.def \
	${TINE_INCL}/prolog.h \
	${TINE_INCL}/srvcore.h \
	${TINE_INCL}/errors.h \
	${TINE_INCL}/tinetype.h \
	${TINE_INCL}/tinedefs.h \
	${TINE_INCL}/swaplib.h \
	${TINE_INCL}/dbtools.h \
	${TINE_INCL}/almlib.h 

TINELIB = libtine.a

CPP = g++ -I${TINE_INCL}
CC = cc -c -g -I${TINE_INCL}
CCL = cc -g
LM = -lm -lrt -lpthread

pulsegen: devsrv.o plseqm.o 
	${CCL} -o pulsegen devsrv.o plseqm.o ${TINE_LIBS}/${TINELIB} ${LM}
	chmod a+x pulsegen

devsrv.o: devsrv.c ${HDRS}
	${CC} devsrv.c

plseqm.o: plseqm.c ${HDRS}
	${CC} plseqm.c

clean:
	rm -f *.o
