#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include "tine.h"

#define SET_MAJOR_VERSION 1
#define SET_MINOR_VERSION 0
#define SET_REVERSION 0

extern char setCfgFile[64];
extern char thisFecContext[32];
extern char thisFecServer[32];
extern char thisFecName[32];
extern char thisSubsystem[16];
extern char thisFecDescription[64];
extern char thisFecLocation[64];
extern char thisFecResponsible[32];
extern int thisFecPort;
extern int isUseOnError;
extern int needsRestart; 
#ifdef WIN32
char *gUsageString = "Usage:\n\n\tsettingsServer /s=<server name> [/f=<config file> /n=<fecname> c=<context> /u=<subsystem> /l=<location> /r=<responsible> /p=<port offset> /b=TRUE (run in background) /m=TRUE (run minimized)]\n";
#else
char *gUsageString = "Usage:\n\n\tsettingsServer /s=<server name> [/f=<config file> /n=<fecname> /c=<context> /u=<subsystem> /l=<location> /r=<responsible> /p=<port offset>\n";
#endif

void PostSystemInit(void);
void PreSystemInit(void);
void RestartServer(void);
#ifdef WIN32
int minimize(void)
{
  char t[500];
  HWND hwnd;

  GetConsoleTitleA(t, 500);     // retrieve the text
  hwnd = FindWindowA(NULL, t);  // FindWindowA actually
  ShowWindow(hwnd, SW_MINIMIZE);
  return 0;
}
#endif
int atobool(char *v)
{
  char str[64];
  if (v == NULL) return FALSE;
  strncpy(str, v, 64);
  strtrm(v);
  if (stricmp(v, "TRUE") == 0) return TRUE;
  if (stricmp(v, "YES") == 0) return TRUE;
  if (stricmp(v, "ON") == 0) return TRUE;
  return FALSE;
}
int main(int argc, char *argv[])
{
  int i, cc, n = 0;
  char *c;
# ifdef WIN32
  int noConsole = FALSE, minimized = FALSE;
  HWND hwnd = GetConsoleWindow();
  HMENU hmenu = GetSystemMenu(hwnd, FALSE);
  EnableMenuItem(hmenu, SC_CLOSE, MF_GRAYED);
# endif

  for (i = 1; i < argc; i++)
  {
    c = argv[i];
    if (*c++ != '/') continue;
    switch (tolower(*c))
    {
    case 'f':
      if ((c = strchr(c, '=')) != NULL)
      {
        c++;
        strncpy(setCfgFile, c, 64);
      }
      continue;
    case 'n':
      if ((c = strchr(c, '=')) != NULL)
      {
        c++;
        strncpy(thisFecName, c, 32);
      }
      continue;
    case 's':
      if ((c = strchr(c, '=')) != NULL)
      {
        c++;
        strncpy(thisFecServer, c, 32);
      }
      continue;
    case 'c':
      if ((c = strchr(c, '=')) != NULL)
      {
        c++;
        strncpy(thisFecContext, c, 32);
      }
      continue;
    case 'u':
      if ((c = strchr(c, '=')) != NULL)
      {
        c++;
        strncpy(thisSubsystem, c, 16);
      }
      continue;
    case 'l':
      if ((c = strchr(c, '=')) != NULL)
      {
        c++;
        strncpy(thisFecLocation, c, 32);
      }
      continue;
    case 'r':
      if ((c = strchr(c, '=')) != NULL)
      {
        c++;
        strncpy(thisFecResponsible, c, 32);
      }
      continue;
    case 'p':
      if ((c = strchr(c, '=')) != NULL)
      {
        c++;
        thisFecPort = atoi(c);
      }
      continue;
#     ifdef WIN32
    case 'b':
      if ((c = strchr(c, '=')) != NULL)
      {
        c++;
        noConsole = atobool(c);
      }
      continue;
    case 'm':
      if ((c = strchr(c, '=')) != NULL)
      {
        c++;
        minimized = atobool(c);
      }
      continue;
#     endif
    case 'h':
    case '?':
      printf("%s\n", gUsageString);
      exit(0);
    default:
      continue;
    }
  }

# ifdef WIN32
  if (noConsole) FreeConsole();
  else if (minimized) minimize();
# endif

  SetPreSystemInitFunction(PreSystemInit);
  SetPostSystemInitFunction(PostSystemInit);
  SetAppVersion(SET_MAJOR_VERSION, SET_MINOR_VERSION, SET_REVERSION);

  if ((cc = SystemInit(TRUE)) != 0) { printf("init error: %s\n", erlst[cc]); exit(1); }

# ifdef USE_CYCLER
  SystemStartCycleTimer();
  SystemWaitCycleTimer();
# else
  for (;;)
  {
    if (needsRestart) RestartServer();
    SystemCycle(TRUE);
  }
# endif
  return 0;
}
