# variables with defaults can be overridden by environment variables
#   TINE_INCL
#   TINE_LIBS

TINE_INCL ?= ../../../include
TINE_LIBS ?= ../../../lib

HDRS = ${TINE_INCL}/project.def \
	${TINE_INCL}/prolog.h \
	${TINE_INCL}/srvcore.h \
	${TINE_INCL}/errors.h \
	${TINE_INCL}/tinetype.h \
	${TINE_INCL}/tinedefs.h \
	${TINE_INCL}/swaplib.h \
	${TINE_INCL}/dbtools.h \
	${TINE_INCL}/almlib.h 

TINELIB = libtine.a

CPP = g++ -I${TINE_INCL}
CC = cc -c -Aa -g -I${TINE_INCL}
CCL = cc -g
LM = -lM -lrt -lpthread

sinegen: devsrv.o sineqm.o 
	${CCL} -o sinegen devsrv.o sineqm.o ${TINE_LIBS}/${TINELIB} ${LM}
	chmod a+x sinegen

devsrv.o: devsrv.c ${HDRS}
	${CC} devsrv.c

sineqm.o: sineqm.c ${HDRS}
	${CC} sineqm.c

clean:
	rm -f *.o
