/*
 * devsrv    REVISION HISTORY:
 * Generated by SRVWIZARD on Tue Mar 11 13:42:56 2003
*/

#include "app_version.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "tine.h"

void PreSystemInit(void);
void PostSystemInit(void);
extern int needsRestart;
void RestartServer(void);

int g_isTerminating = FALSE;

extern char thisFecName[FEC_NAME_SIZE];
extern char thisContext[CONTEXT_NAME_SIZE];
extern char thisLocation[FEC_LOCATION_SIZE];
extern UINT16 thisPortOffset;

void term_handler(int signum)
{                  
  g_isTerminating = TRUE;
  feclog("caught SIGTERM");          
}

char *usageText = "usage: statesrv [/f=<fecname> /c=<context> /p=<port offset> /l=<location> /d=<debug level>";
int main(int argc, char *argv[])
{
  int i,cc;
  char *c, scratch[256];

  for (i=1; i<argc; i++)
  { /* options given */
    c = argv[i];
    if (*c++ != '/') break;
    switch (tolower(*c))
    {
      case 'f':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(thisFecName,c,FEC_NAME_SIZE);
        }
        continue;
      case 'c':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(thisContext,c,CONTEXT_NAME_SIZE);
        }
        continue;
      case 'l':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(thisLocation,c,FEC_LOCATION_SIZE);
        }
        continue;
      case 'p':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(scratch,c,32);
          thisPortOffset = atoi(scratch);      
        }
        continue;
      case 'd':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(scratch,c,32);
          tineDebug = atoi(scratch);      
        }
        continue;
      case '?':
      case 'h':
        printf("%s",usageText);
        exit(0);
      default:
        continue;
    }
  }

  signal(SIGTERM,term_handler);
  AssignFecApplicationInfo(APPV_MAJOR,APPV_MINOR,APPV_REVISION);
  SetPreSystemInitFunction(PreSystemInit);
  SetPostSystemInitFunction(PostSystemInit);
  SetWorkAreaSize(1000000);
  if ((cc=SystemInit(TRUE)) != 0)
  {
    printf("initialization error : %s",cc2str(cc));
    exit(1);
  }
  for(;;)
  {
    if (g_isTerminating) ttyquit(NULL,NULL);
    SystemCycle(TRUE);
    if (needsRestart) RestartServer();
  }
  return 0;
}
