#include "tine.h"
#include "unittest.h"

int waitForServer = 0;
int killserver = FALSE;
int testcaseCount = 0;

/*
  <testsuite tine="2">
	<testcase classname="build" name="buildTestServerAndClient"/>
	<testcase classname="performTestSuite" name="performTestSuite">
	  <failure type="testsuiteError"> for details about failure to perform test suite see logfiles </failure>
	</testcase>
  </testsuite>
*/

void writeTestResultQuit(int cc)
{
	writeTestsuiteLogStart();
	writeTestsuiteLogTestcase("servercommunication", "contact server", 1);
	writeTestsuiteLogEnd();
}
int testResultWriteLine(char* log_text)
{
	FILE* fp = NULL;
	static char* fmod = "a+";
	fp = fopen("testresults.xml", fmod);
	if (fp != NULL) {
		fwrite(log_text, (int)strlen(log_text), 1, fp);
		fclose(fp);
		return 0;
	}
	return 1;
}
void shutdownServer(char* tgt, NAME64* devs)
{
	int cc = 0;
	char devstr[128];
	DTYPE din;
	DTYPEZERO(din);
	din.dFormat = CF_INT16;
	din.dArrayLength = 1;
	din.data.vptr = blobIn;
	din.data.sptr[0] = 0;
	sprintf(devstr, "%s/%.64s", tgt, devs[0].name);
	cc = ExecLink(devstr, "SRVEXIT", NULL, &din, CA_WRITE);
	if (cc != 0) {
		printf("failed to shutdown server\n");
	}
}
void writeLogXmlFileLine(char* log_text, int reset, int prepend)
{
	FILE* fp = NULL;
	if (reset) {
		remove("testresult.xml");
		return;
	}
	fp = fopen("testresult.xml", prepend ? "r+" : "a+");
	if (fp == NULL) {
		printf("*** unitclient FATAL: can not write testresult.xml\n");
	}
	fwrite(log_text, strlen(log_text), 1, fp);
	if (log_text[strlen(log_text) - 1] != '\n') {
		fwrite("\n", 1, 1, fp);
	}
	fclose(fp);
}
void writeTestsuiteLogStart()
{
	char logfileline[256];
	writeLogXmlFileLine("", 1, 0);
	sprintf(logfileline, "<testsuite tine=\"01\">");
	writeLogXmlFileLine(logfileline, 0, 0);
}
void writeTestsuiteLogEnd()
{
	char logfileline[256];
	sprintf(logfileline, "<testsuite tine=\"%02d\">", testcaseCount);
	writeLogXmlFileLine(logfileline, 0, 1);
	writeLogXmlFileLine("</testsuite>", 0, 0);
}
void writeTestsuiteLogTestcase(char* casetype, char* casename, int result)
{
	char logfileline[256];
	sprintf(logfileline, "<testcase classname=\"tinetest\" name=\"%s\">", casename);
	writeLogXmlFileLine(logfileline, 0, 0);
	if (result) {
		sprintf(logfileline, "<failure type=\"%s\"> for details about %d error(s) in testcase '%s' see logfiles </failure>", casetype, result, casename);
		writeLogXmlFileLine(logfileline, 0, 0);
	}
	writeLogXmlFileLine("</testcase>", 0, 0);
}
