/*
 * File statebase.h
 *
 * Authors Philip Duval (DESY)
 *
 * Copyright (c) Deutsches Elektronen-Synchrotron DESY 1992-2023
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef _STATEBASE_H_
#define _STATEBASE_H_

#include "archive.h"

#define NULLSTATE_NAME "NullStates.csv"
#define BEAMPARAM_NAME "BeamParameters.csv"
#define STATEPARAM_NAME "StateParameters.csv"
#define EPROC_NAME "eDeclaredProcedures.csv"
#define PPROC_NAME "pDeclaredProcedures.csv"
#define STATESRV_NAME "StateServer.csv"

extern CHECKNAME *checkedParameters;
extern int nCheckedParameters;
extern CHECKNAME *checkedStates;
extern int nCheckedStates;

#endif /* _STATEBASE_H_ */
