/*
 * devsrv    REVISION HISTORY:
 * Generated by SRVWIZARD on Tue Mar 11 13:42:56 2003
*/

#include "app_version.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "tine.h"
#include "timeqm.h"

#define TIMESERV_PORT_OFFSET 6
char thisFecName[FEC_NAME_SIZE] = "";
char thisContext[CONTEXT_NAME_SIZE] = "SITE";
char *thisSubSystem = "SER";
char thisFecDescription[FEC_DESC_SIZE] = "SITE Time Server";
char thisLocation[FEC_LOCATION_SIZE] = "";
UINT16 thisPortOffset = TIMESERV_PORT_OFFSET;

void PreSystemInit(void)
{
  int p;
  MinPollingRate = 100;
  MaxPollingRate = 100;
  MaxNumContracts = 150;
  MaxNumClients = 50;
  MaxNumConnections = 100;
  FeclogDepth = 100;
  gRequireAcknowledgments = FALSE;
  MaxSystemTransportSize = 65535;
  useGlobalSynchronization = FALSE;
  canSendGlobals = TRUE;

  if (strlen(thisFecName) == 0)
  {
    strncpy(thisFecName,"TIMSERV",FEC_NAME_SIZE); 
  }
  p = GetPortOffset(thisFecName);
  if (p >= 0 && p != thisPortOffset) 
  {
    printf("assigned port offset %d differs from registry entry %d",thisPortOffset,p);
  }
  RegisterFecInformation(thisFecName,thisSubSystem,thisContext,thisFecDescription,thisLocation,"none","administrator",thisPortOffset);
  // TODO: accept env or file to set the gcast addr
  // SetGCastAddr(addr);
}

char *usageText = "usage: timeserv [/f=<fecname> /p=<port offset> /l=<location> /d=<debug level>";
void PostSystemInit(void)
{
  RegisterEquipmentModule("TIMESRV",TIMEQM_TAG,0,timeqm,timeqm_ini,timeqm_bkg,TIMEQM_RATE,timeqm_exi);
}
int main(int argc, char *argv[])
{
  int i,cc;
  char *c, scratch[256];

  for (i=1; i<argc; i++)
  { /* options given */
    c = argv[i];
    if (*c++ != '/') break;
    switch (tolower(*c))
    {
      case 'f':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(thisFecName,c,FEC_NAME_SIZE);
        }
        continue;
      case 'l':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(thisLocation,c,FEC_LOCATION_SIZE);
        }
        continue;
      case 'p':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(scratch,c,32);
          thisPortOffset = atoi(scratch);      
        }
        continue;
      case 'd':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(scratch,c,32);
          tineDebug = atoi(scratch);      
        }
        continue;
      case '?':
      case 'h':
        printf("%s",usageText);
        exit(0);
      default:
        continue;
    }
  }
  AssignFecApplicationInfo(APPV_MAJOR,APPV_MINOR,APPV_REVISION);
  SetPreSystemInitFunction(PreSystemInit);
  SetPostSystemInitFunction(PostSystemInit);
  SetSendLegacyGlobals(TRUE); /* for the time being ... */
  if ((cc=SystemInit(TRUE)) != 0)
  {
    printf("initialization error : %s",cc2str(cc));
    exit(1);
  }
  for(;;)
  {
    SystemCycle(TRUE);
  }
  return 0;
}
