# variables with defaults can be overridden by environment variables
#   TINE_INCL
#   TINE_LIBS

TINE_INCL ?= ../../../include
TINE_LIBS ?= ../../../lib

TINEEXE = timeserv
TINELIB = libtine.a

HDRS = ${TINE_INCL}/project.def \
	${TINE_INCL}/prolog.h \
	${TINE_INCL}/srvcore.h \
	${TINE_INCL}/srvip.h \
	${TINE_INCL}/errors.h \
	${TINE_INCL}/tinetype.h \
	${TINE_INCL}/tinedefs.h \
	${TINE_INCL}/dbtools.h \
	${TINE_INCL}/swaplib.h \
	${TINE_INCL}/almlib.h

CPP = g++ -I${TINE_INCL}
CC = cc -c -Aa -g -I${TINE_INCL}
CCL = cc -g
LM = -lM -lrt

${TINEEXE}: devsrv.o timeqm.o
	${CCL} -o ${TINEEXE} devsrv.o timeqm.o  ${TINE_LIBS}/${TINELIB} ${LM}
	chmod a+x ${TINEEXE}

devsrv.o: devsrv.c ${HDRS}
	${CC} devsrv.c

timeqm.o: timeqm.c timeqm.h ${HDRS}
	${CC} timeqm.c

clean:
	rm -f *.o
