#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char *strtrm(char *s)
{
  char *start, *end;
  unsigned int len;

  if (s == NULL) return s;  /* NULL given, give it back */
  if ((len=(int)strlen(s)) == 0) return s; /* empty string given, give it back */
  /* find first non-whitespace */
  for (start=s; isspace((int)*start) && len > 0; start++, len--); 
  /* find last non-whitespace */
  for (end=start+len-1; isspace((int)*end) && len > 0; end--, len--) *end = 0;
  /* Move to the left */
  memmove(s, start, len + 1);
  /* return a pointer to the modified string as a curtesy */
  return s;
}
int main(int argc, char *argv[])
{
  FILE *fpap=NULL, *fpwd=NULL;
  char *c,str[256],path[256],wdir[256],env[256],fnam[256],nam[64];
  int i,nenv;

  if ((fpap=fopen("autoproc.conf","r")) == NULL)
  {
    perror("autoproc.conf");
    exit(1);
  }
  if ((fpwd=fopen("watchdog.cfg","w")) == NULL)
  {
    perror("watchdog.cfg");
    exit(1);
  }

  fprintf(fpwd,"# Watchdog config\n");
  fprintf(fpwd,"START_SERVER: Yes\n");
  fprintf(fpwd,"PRINT_INFO_ON_EACH_CYCLE: No\n");
  fprintf(fpwd,"WATCH_CYCLE_PERIOD: 1000\n");
  fprintf(fpwd,"CPU_MEASURING_PERIOD: 100\n");
  fprintf(fpwd,"SUSPENDED_TIMEOUT: 1800\n");
  fprintf(fpwd,"ALLOW_MONITORING_OTHER_HOSTS: No\n");

  fprintf(fpwd,"# FEC config\n");
  fprintf(fpwd,"# Uncomment the following line to change any of the default parameters\n");
  fprintf(fpwd,"#FEC: mcslxterm01.20\n");
  fprintf(fpwd,"#SERVER: WD_mcslxterm01\n");
  fprintf(fpwd,"#CONTEXT: SERVICE\n");
  fprintf(fpwd,"#SUBSYSTEM: WDOG\n");
  fprintf(fpwd,"#DESCRIPTION: Watchdog\n");
  fprintf(fpwd,"#LOCATION:\n");
  fprintf(fpwd,"#HARDWARE: none\n");
  fprintf(fpwd,"#RESPONSIBLE: Admin\n");
  fprintf(fpwd,"PORT_OFFSET: 20\n");

  fprintf(fpwd,"\n# Processes config\n");

  while (fgets(str,255,fpap) != NULL)
  {
    if (str[0] == '#') continue;
    if (strncmp(str,"PROCESS",7) == 0)
    { // convert info to watchdog.cfg
      strncpy(fnam,&str[8],16);
      if ((c=strpbrk(fnam," \t{\n")) != NULL) *c = 0;
      for (i=0; i<strlen(fnam); i++) fnam[i] = toupper(fnam[i]);
      fprintf(fpwd,"\n[%.16s]\n",fnam);
      while (fgets(str,255,fpap) != NULL)
      {
        if (str[0] == '#') continue;
        strtrm(str);
        if (strstr(str,"}") != NULL) break;
        if (strncmp(str,"PATH",4) == 0 && (c=strchr(str,':')) != NULL)
        {
          c++; while( *c == ' ') c++;
          strncpy(path,c,128);
          if ((c=strchr(path,' ')) != NULL) *c = 0;
          if ((c=strrchr(path,'/')) != NULL)
          {
            c++;
            strncpy(nam,c,64);
          }
          else
          {
            strncpy(nam,path,64);
            sprintf(path,"/usr/bin/%.64s",nam);
          }
          fprintf(fpwd,"NAME: %s\n",nam);
          fprintf(fpwd,"PATH_TO_EXECUTABLE: %s\n",path);
          continue;
        }
        if (strncmp(str,"WPATH",5) == 0 && (c=strchr(str,':')) != NULL)
        {
          c++; while( *c == ' ') c++;
          fprintf(fpwd,"WORKING_DIRECTORY: %s\n",c);
          continue;
        }
        if (strncmp(str,"ARGS",4) == 0 && (c=strchr(str,':')) != NULL)
        {
          c++; while( *c == ' ') c++;
          fprintf(fpwd,"COMMAND_LINE_PARAMETERS: %s\n",c);
          continue;
        }
        if (strncmp(str,"ENV",3) == 0)
        {
          fprintf(fpwd,"ENVIRONMENT_VARIABLES: ",c);
          nenv = 0;
          while (fgets(str,255,fpap) != NULL)
          {
            for (c=str; *c == ' ' || *c == '\t' || *c == '\n'; c++);
            strncpy(env,c,128);
            if (strncmp(env,"}",1) == 0)
            {
              fprintf(fpwd,"\n");
              break;
            }
            if ((c=strchr(env,':')) != NULL)
            {
              *c++ = 0;
              if (nenv++ > 0) fprintf(fpwd,";");
              fprintf(fpwd,"%s=%s",strtrm(env),strtrm(c));
            }
            continue;
          }
        }
      }
      fprintf(fpwd,"MATCH_PATH: Yes\n");
      fprintf(fpwd,"MATCH_PARAMETERS: Yes\n");
      fprintf(fpwd,"MAX_CPU_LOAD: 90\n");
      fprintf(fpwd,"NUMBER_OF_ALLOWED_CPU_LOAD_VIOLATIONS: 5\n");
      fprintf(fpwd,"MAX_MEMORY: 1000\n");
      fprintf(fpwd,"NUMBER_OF_ALLOWED_MEMORY_VIOLATIONS: 3\n");
      fprintf(fpwd,"AUTO_START: Yes\n");
      fprintf(fpwd,"MONITOR_N_SECONDS_AFTER_START: 5\n");
      fprintf(fpwd,"NUMBER_OF_RETRIES: 5\n");
      fprintf(fpwd,"RETRY_INTERVAL: 10\n");
    }
  }
  fprintf(fpwd,"\n");
  fclose(fpwd); fclose(fpap);
  return 0;
}
