/*
* console.h
*
* Provides helper routines for manipulating the application console.
*
*  Created on: Nov 28, 2015
*      Author: Jaka Bobnar
*/
#ifndef CONSOLE_H
#define CONSOLE_H

#include "util.h"

/**
* Handles the CTRL+C events and similar.
* \param a the event code
*/
void BreakHandler(int a);
/**
* Check the messages to the icon.
*/
void CheckMessages(void);
/**
* Hide the console window.
*/
void HideConsole(void);
/**
* Show the console window.
*/
void ShowConsole(void);
/**
* Adds the banana icon to the system tray.
*/
void IconToTray(void);
/**
* Returns the console to the original state and frees resources allocated by the console.
*/
void DestroyConsole(void);
/**
* \brief Disable the close window menu item
*
* Finds the close window menu item and disables it. If possible also disable the
* close button in the window toolbar.
*
* \return 1 if successful, 0 if not
*/
boolean DisableCloseWindow(void);

/**
* \brief Enable the close window menu item
*/
void EnableCloseWindow(void);
#endif