INCL = /usr/include/tine
LIBS = /usr/lib
TINE_LIB = tinemt
EXE = watchdog
HDRS = ${INCL}/project.def \
	${INCL}/prolog.h \
	${INCL}/srvcore.h \
	${INCL}/errors.h \
	${INCL}/tinetype.h \
	${INCL}/tinedefs.h \
	${INCL}/swaplib.h \
	${INCL}/dbtools.h \
	${INCL}/almlib.h 

CC = cc -c -DMULTITHREADED -g -I. -I../network -I${INCL}
CCL = cc -g
LM = -lm -lpthread -lrt
	
${EXE}: parser.o process.o tineserver.o watchdog.o utilities.o console.o
	${CCL} -o ${EXE} parser.o process.o tineserver.o watchdog.o utilities.o console.o -L${LIBS} -l${TINE_LIB} ${LM}
	chmod a+x ${EXE}

parser.o: parser.c ${HDRS}
	${CC} parser.c

process.o: process.c ${HDRS}
	${CC} process.c

tineserver.o: tineserver.c ${HDRS}
	${CC} tineserver.c

watchdog.o: watchdog.c ${HDRS}
	${CC} watchdog.c

utilities.o: utilities.c ${HDRS}
	${CC} utilities.c

console.o: console.c ${HDRS}
	${CC} console.c
    
clean:
	rm -f parser.o
	rm -f process.o
	rm -f tineserver.o
	rm -f watchdog.o
	rm -f utilities.o
	rm -f tcycler.o
	rm -f console.o

