INCL = ../../../source
LIBS = ../../../source

EXE = watchdog
HDRS = ${INCL}/project.def \
	${INCL}/prolog.h \
	${INCL}/srvcore.h \
	${INCL}/errors.h \
	${INCL}/tinetype.h \
	${INCL}/tinedefs.h \
	${INCL}/swaplib.h \
	${INCL}/dbtools.h \
	${INCL}/almlib.h

CC = cc -c -DMULTITHREADED -g -I. -I${INCL}
CCL = cc -g
LM = -lm -lpthread -lrt

${EXE}: parser.o process.o tineserver.o watchdog.o utilities.o tcycler.o console.o
	${CCL} -o ${EXE} parser.o process.o tineserver.o watchdog.o utilities.o tcycler.o console.o ${LIBS}/libtinemt.a ${LM}
	chmod a+x ${EXE}

parser.o: parser.c ${HDRS}
	${CC} parser.c

process.o: process.c ${HDRS}
	${CC} process.c

tineserver.o: tineserver.c ${HDRS}
	${CC} tineserver.c

watchdog.o: watchdog.c ${HDRS}
	${CC} watchdog.c

utilities.o: utilities.c ${HDRS}
	${CC} utilities.c

tcycler.o: tcycler.c ${HDRS}
	${CC} tcycler.c

console.o: console.c ${HDRS}
	${CC} console.c

clean:
	rm -f parser.o
	rm -f process.o
	rm -f tineserver.o
	rm -f watchdog.o
	rm -f utilities.o
	rm -f tcycler.o
	rm -f console.o
 