# Makefile for client test program - PKTR rpc calls
# Version 20.03.95
# Insert the defs for your machine
# SUN:    CC = CC         CCL = CC         LM = 
# SGI     CC = cc         CCL = cc         LM = -lm
# OSF     CC = cc         CCL = cc         LM = -lm
# LINUX   CC = cc         CCL = cc         LM = -lm
# ULT     CC = gcc -c -g  CCL = gcc -g     LM = 
# HP:     CC = cc -Aa     CCL = cc         LM = -lM
# SOL 2.4 CC = CC         CCL = CC         LM = -lsocket -lnsl

HDRS = project.def \
	prolog.h \
	srvcore.h \
	swaplib.h \
	hstlib.h \
	globals.h \
	dbtools.h \
	toolkit.h \
	errors.h \
	tinetype.h \
	tinedefs.h \
	almlib.h

CPP = CC
CC = cc -Aa -c
CCL = cc
LM = -lM

libtine.a: server.o srvdbase.o srvquery.o srvip.o client.o clnip.o iplib.o dblib.o dbtools.o errlist.o swaplib.o almlib.o ttycmd.o syslib.o hstlib.o toolkit.o
	ar r $@ server.o srvdbase.o srvquery.o srvip.o client.o clnip.o iplib.o dblib.o dbtools.o errlist.o swaplib.o almlib.o ttycmd.o syslib.o hstlib.o toolkit.o

server.o:  server.c ${HDRS}
	${CC} server.c

srvdbase.o: srvdbase.c ${HDRS}
	${CC} srvdbase.c

srvquery.o: srvquery.c ${HDRS}
	${CC} srvquery.c

srvip.o: srvip.c ${HDRS} srvip.h
	${CC} srvip.c

srvipx.o: srvipx.c ${HDRS} srvip.h srvipx.h
	${CC} srvipx.c

hstlib.o: hstlib.c ${HDRS}
	${CC} hstlib.c

toolkit.o: toolkit.c ${HDRS} toolkit.h
	${CC} toolkit.c

client.o: client.c ${HDRS}
	${CC} client.c

clnip.o: clnip.c ${HDRS} srvip.h
	${CC} clnip.c

clnipx.o: clnipx.c ${HDRS} srvip.h srvipx.h
	${CC} clnipx.c

iplib.o: iplib.c ${HDRS} srvip.h
	${CC} iplib.c

dblib.o: dblib.c ${HDRS}
	${CC} dblib.c

dbtools.o: dbtools.c ${HDRS}
	${CC} dbtools.c

almlib.o:  almlib.c ${HDRS}
	${CC} almlib.c

ttycmd.o: ttycmd.c ${HDRS} ttycmd.h
	${CC} ttycmd.c 

errlist.o: errlist.c errors.h project.def
	${CC} errlist.c

swaplib.o: swaplib.c ${HDRS}
	${CC} swaplib.c 

syslib.o: syslib.c ${HDRS}
	${CC} syslib.c

clean:
	rm *.o
